// ICAPKInterface.aidl
package wangpos.sdk4.emv;

import wangpos.sdk4.emv.ICallbackListener;

interface IEmvCoreInterface {
    int init();

    int addCapk(in byte[] capkdata, in int dataLen);

    int addAID(in byte[] emvparam, in int dataLen);

    int delAllAID();

    int delCapkAll();

    void setParam(in byte[] emvparam, in int len);

    void getParam(out byte[] emvparam, out int[] len);

    int getTLV(int tag, out byte[] data, out int[] datalen);

	int setTLV(int tag, in byte[] data, in int datalen);

    void transInit();

    int appSel(in int nInSlot, in int ulInTransNo, ICallbackListener emvcallback);

    int readAppData(ICallbackListener emvcallback);

    int cardAuth();

    int getPath();

    int procTrans(ICallbackListener emvcallback);

    int qPBOCPreProcess(ICallbackListener emvcallback);

	int getScriptResult(out byte[] pucOutScriptValue, out int[] pucOutScriptValueLen);

    int procQPBOCTrans(ICallbackListener emvcallback);

    int getBalance(out byte[] pucOutBalance_BCD6B);

    int getAID(in int aidIndex,out byte [] appdata, out int []len);

    int getCoreTLVMessage(out byte []outTLVMessage, out int []dataLen);

    int serailDebugPort(int onoff, int keep);

    int readLogRecord(in int nInRecordNo );

    int getLogItem(in int usInTag,out byte []pucOutTagData,out int  []pucOutTagDataLen );

    //2017 12 14 HS 0521
    int PayWaveHandle(in byte[] AuthData, in int AuthDataLen, in byte[] ScriptData, in int ScriptDataLen);
    //2017 12 27 HS
    int getCapk(in int aidIndex,out byte [] capkdata, out int []len);

    int delExceptPANAll();

    int addExceptPAN(in byte []inPANASCII,in int inPANASCIILen,in int inPANSeq);

    int getExceptPAN(in int inNum,out byte []outExceptPAN,out int []dataLen);

    //2018 3 5 wqk 0619
    int L1_PICC_Digital();
    //2018 3 5 wqk 061A
    int L1_PICC_ARM_Write(in int add,in int value,in int type);
    //2018 3 5 wqk 061B
    int L1_PICC_ARM_Read(in int add,in int type,out byte[] outData);
    //2018 3 5 wqk 061C
    int L1_PICC_TypeALoop();
    //2018 3 5 wqk 061D
    int L1_PICC_TypeBLoop();
    //2018 3 5 wqk 061E
    int L1_CarrierOnOFF(in int type);

    int addPID(in byte[] appData, in int datalen);

    int getPID(in int index, out byte [] appData, out int [] datalen);

    int delAllPID();

    int AppSelForLog(in int nInSlot,ICallbackListener emvcallback);

    int addAID_MC(in byte[] emvparam, in int dataLen,in byte[] mcdata);

    int KernalInit();

    int setParam_MC(in byte transCateCode,in byte[] merchantCustomData,in byte[] AcquirerId);

    int addIPKRevoke(in byte[] inRid, in int incapki, in byte[] inCerSerial);

    int getIPKRevoke(in int inNum, out byte[] outIPKRevoke, out int[] dataLen);

    int delIPKRevokeAll();

    int setTermConfig(in byte[] configData);

    int EmvLib_GetPrintStatus(out byte[] data, out int[] length);

    int getOutCome(out byte[] data,out int[] length);

    int getSelectedAID(out byte[] aid,out int[] len);

    int getMagTrackData_MC(in int trackFlg,out byte[] outData,out int[] dataLen);
    // Create HS date 2018/11/13
    int nGenTrack1Data_MC_Mag(out byte[] outData,out byte[] dataLen);
    // Create HS date 2018/11/13
    int nGenTrack2Data_MC_Mag(out byte[] outData,out byte[] dataLen);
    /*------ Create zss 20181119 add DET/DEK Operation Interface Begin ------*/
    int loadData_MC(in byte[] inData,in int inDataLen);
    int setDetConFlag_MC(int flag);
    int setOnDekReciceListener(ICallbackListener callback);
    int importDetData(in byte[] detData, in int detDataLen,in boolean isHasNextDet);
    /*------ Create zss 20181119 End ------*/
    // Create HS date 2018/11/20
    int  CleanTornLog_MC(out String[] TornTLVStr,out int[] number);
    // Create HS date 2018/11/20
    void DeleteAllTornRecord();
    // Create HS date 2018/11/20
    int getTornRecordTLV(out byte[] TLVData,out int[] length);



}
