﻿var devicePlatform;

function onLoad() {
    document.addEventListener("deviceready", onDeviceReady, false);
}

function onResume() {
    var idle = angular.element(document.body).injector().get("Idle");

    if (idle && idle.isExpired()) {
        var scope = angular.element(document.body).scope();

        if (scope) {
            scope.$broadcast('IdleTimeout');
        }
    }
}

function onDeviceReady() {
    devicePlatform = device.platform;
    document.addEventListener("resume", onResume, false);
}

function handleOpenURL(url) {
    var scope = angular.element(document.body).scope();
    if (scope) {
        scope.$broadcast('app-external-request', url);
    }
}

angular.module('easyorder', [
    'easyorder.xhrfactory',
    'ionic',
    'easyorder.services.audit',
    'easyorder.services.config',
    'easyorder.services.config.update',
    'easyorder.services.freight',
    'easyorder.services.order',
    'easyorder.services.user',
    'easyorder.services.insurance',
    'easyorder.services.externalloading',
    'easyorder.services.info',
    'easyorder.services.mail',
    'easyorder.services.financial',
    'easyorder.services.billing.payment',
    'easyorder.controllers.home',
    'easyorder.controllers.login',
    'easyorder.controllers.sled.barcode.scanner',
    'easyorder.controllers.barcode.camera',
    'easyorder.controllers.barcode.scanner',
    'easyorder.controllers.rfid.search',
    'easyorder.controllers.rfid.disable.tag',
    'easyorder.controllers.cart',
    'easyorder.controllers.customer',
    'easyorder.controllers.order',
    'easyorder.controllers.product',
    'easyorder.controllers.productdetail',
    'easyorder.controllers.productsearchresult',
    'easyorder.controllers.productdiscounts',
    'easyorder.controllers.paymentmethods',
    'easyorder.controllers.predefinedpaymentmethods',
    'easyorder.controllers.paymentplans',
    'easyorder.controllers.tefpayment',
    'easyorder.controllers.privatelabelpayment',
    'easyorder.controllers.giftcardpayment',
    'easyorder.controllers.covenantpayment',
    'easyorder.controllers.paymentresult',
    'easyorder.controllers.privatelabelbiopayment',
    'easyorder.controllers.giftcard',
    'easyorder.controllers.giftcardinfo',
    'easyorder.controllers.giftcardaddvalue',
    'easyorder.controllers.covenant',
    'easyorder.controllers.covenantpassword',
    'easyorder.controllers.servicesale',
    'easyorder.controllers.covenantidentification',
    'easyorder.controllers.covenanttypesidentification',
    'easyorder.controllers.externalloading',
    'easyorder.controllers.prescriptions',
    'easyorder.controllers.genericpayment',
    'easyorder.controllers.financial',
    'easyorder.controllers.giftcardmenu',
    'easyorder.controllers.giftcardvirtual',
    'easyorder.controllers.giftcardtheme',
    'easyorder.controllers.discountrules',
    'easyorder.controllers.discounttypes',
    'easyorder.controllers.includediscounts',
    'easyorder.controllers.purchasesummary',
    'easyorder.services.includediscounts',
    'easyorder.services.discountrules',
    'easyorder.services.discounttypes',
    'easyorder.services.insurance',
    'easyorder.services.externalloading',
    'easyorder.services.info',
    'easyorder.services.rfid.transaction',
    'easyorder.controllers.showroomingzipcode',
    'easyorder.controllers.showroomingfulfillments',
    'easyorder.controllers.showroomingitemfreightdetails',
    'easyorder.controllers.showroomingsummary',
    'easyorder.services.financial',
    'easyorder.services.mobilerecharge',
    'easyorder.services.log',
    'easyorder.controllers.mobilerechargeoptions',
    'easyorder.controllers.mobilerechargephonenumber',
    'easyorder.controllers.giftcardpaymentmenu',
    'ngCordova',
    'ngResource',
    'ngAnimate',
    'ui.mask',
    'ui.utils.masks',
    'ngIdle',
    'angular-jwt',
    'angular.filter',
    'angular-hmac-sha512',
    'ionicLazyLoad',
    'ionic.closePopup',
    'toaster',
    'fileLogger',
    'easyorder.components.accordion',
    'easyorder.components.badge',
    'easyorder.components.pdf',
    'easyorder.components.document.slides',
    'easyorder.components.button-float',
    'easyorder.components.item.list',
    'easyorder.components.item.detail',
    'easyorder.components.customer.item.detail',
    'easyorder.components.item.search.header',
    'easyorder.components.email.autocomplete',
    'easyorder.components.payment.tef.debit',
    'easyorder.components.email.float.button',
    'easyorder.components.restart.float.button',
    'easyorder.components.transaction.search',
    'easyorder.components.transaction.searchv3',
    'easyorder.controllers.authmanager',
    'easyorder.services.log',
    'easyorder.services.servicesale',
    'easyorder.services.eft',
    'easyorder.services.discount',
    'easyorder.controllers.balance',
    'easyorder.controllers.supply',
    'easyorder.components.order-button-float',
    'easyorder.controllers.operations',
    'easyorder.services.transactionsearchservice',
    'easyorder.services.transactionreturnservice',
    'easyorder.services.cashback',
    'easyorder.controllers.transactionsearch',
    'easyorder.controllers.transactionproductlist',
    'easyorder.controllers.transactionjustification',
    'easyorder.controllers.voucher',
    'easyorder.controllers.exchange.uuid.inputs',
    'easyorder.controllers.coupon.view',
    'easyorder.services.donation',
    'easyorder.controllers.donation',
    'easyorder.controllers.reprintsearch',
    'easyorder.controllers.reprintoptions',
    'easyorder.controllers.reprintreceiptlist',
    'snackbar',
    'easyorder.services.voucherservice',
    'easyorder.controllers.voucherpayment',
    'easyorder.controllers.voucherpaymentsearch',
    'easyorder.services.reportservice',
    'easyorder.controllers.reports',
    'easyorder.controllers.consolidatedstoresalessearch',
    'easyorder.controllers.consolidatedstoresalesresult',
    'easyorder.controllers.consolidatedstoresalesdetails',
    'easyorder.controllers.mysalessearch',
    'easyorder.controllers.mysalesresult',
    'easyorder.controllers.mysalesdetails',
    'easyorder.controllers.storesalessearch',
    'easyorder.controllers.storesalesresult',
    'easyorder.controllers.storesalesdetails',
    'easyorder.services.payment.processor',
    'easyorder.controllers.voucherpaymentsearchoptions',
    'easyorder.controllers.voucherbarcodepayment',
    'easyorder.services.reprintservice',
    'easyorder.controllers.returns.exchange',
    'easyorder.controllers.returns.exchange.rfid.tag.transaction.search',
    'easyorder.controllers.returns.exchange.rfid.tag.linkage',
    'easyorder.controllers.returns.exchange.rfid.scanned.transaction',
    'easyorder.controllers.returns.exchange.scanned.rfid.couponless',
    'easyorder.controllers.returns.exchange.scanned.search',
    'easyorder.controllers.returns.exchange.scanned.couponless',
    'easyorder.controllers.returns.exchange.document.search',
    'easyorder.controllers.returns.exchange.typed.search',
    'easyorder.controllers.returns.exchange.coupons',
    'easyorder.controllers.returns.exchange.products.list',
    'easyorder.controllers.returns.exchange.products.listv3',
    'easyorder.controllers.returns.exchange.customer',
    'easyorder.controllers.returns.exchange.rfid.activation',
    'easyorder.controllers.returns.exchange.request',
    'easyorder.controllers.returns.exchange.requestv3',
    'easyorder.services.configwatchdog',
    'easyorder.controllers.scannedgiftcardpayment',
    'easyorder.controllers.passwordgiftcardpayment',
    'easyorder.components.qr-code',
	'easyorder.controllers.sitefQRPayment',
    'easyorder.controllers.ewallet.payment',
    'easyorder.services.ewallet',
    'easyorder.controllers.voucherpaymentsearch',
    'easyorder.controllers.paymentlink',
    'easyorder.controllers.paymentlinkcustomerconfirmation',
    'easyorder.billing.payment.v1.menu',
    'easyorder.billing.payment.v1.document.search',
    'easyorder.billing.payment.v1.scanned.search',
    'easyorder.billing.payment.v1.chip.search',
    'easyorder.billing.payment.v1.processor.filter',
    'easyorder.billing.payment.v1.type.filter',
    'easyorder.billing.payment.v1.list',
    'easyorder.billing.payment.v1.detached.list',
    'easyorder.billing.payment.v1.card.statement.list',
    'easyorder.billing.payment.v1.customer',
    'easyorder.billing.payment.v1.payment',
    'easyorder.billing.payment.v1.result',
    'easyorder.controllers.sitef.paymentlink',
    'easyorder.services.paymentlink',
    'easyorder.controllers.order.doc.search',
    'easyorder.controllers.order.search.list',
    'easyorder.services.messaging',
    'elasticsearch',
    'elasticLogger',
    'loggers',
    'easyorder.controllers.rfid.tag.deactivation.menu',
    'easyorder.controllers.rfid.tag.deactivation.coupom.type.menu',
    'easyorder.controllers.rfid.document.transaction.tag.deactivation',
    'easyorder.controllers.rfid.document.transaction.list.tag.deactivation',
    'easyorder.controllers.rfid.epc.transaction.tag.deactivation',
    'easyorder.controllers.rfid.scanned.transaction.tag.deactivation',
    'easyorder.controllers.rfid.typed.transaction.tag.deactivation',
    'easyorder.controllers.rfid.tag.deactivation',
    'easyorder.controllers.rfid.detached.change.tag.header',
    'easyorder.modals.stylesearch',
    'easyorder.modals.tagsreader',
    'easyorder.modals.fiscalcustomer',
    'easyorder.modals.fiscalmenu',
    'easyorder.services.pafservice',
    'easyorder.controllers.cardnumbersearch',
    'easyorder.modals.orderchecking',
    'easyorder.services.biometrics',
    'easyorder.modals.facebiometrics',
    'easyorder.controllers.annulment',
    'easyorder.controllers.installment-plan-payment',
    'easyorder.services.installment-plan',
])
    .constant('$ionicLoadingConfig', {
        template: 'Por favor, aguarde...'
    })
    .run(function ($ionicPlatform, $state, $rootScope, $q, $injector, Idle, authManager, $cordovaFile, ConfigService, UtilService,
        ExternalLoadingService, AlertService, $timeout, AuditService, EFTService, LogService,
        PaymentProcessor, ConfigWatchdog) {
        var isAndroid = ionic.Platform.isAndroid();

        $rootScope.isCordova = false;
        $rootScope.APP_NAME = APP_NAME;
        $rootScope.APP_NAME_DESC = APP_NAME_DESC;
        $rootScope.PAF_VERSION = PAF_VERSION;
        $rootScope.appVersion = 'dev';
        $rootScope.platformNumberInputType = 'tel'; //Não usar 'number', pois campos de senha nesse formato irão ignorar zeros à esquerda!!!!
        $rootScope.defaultRequestTimeoutInMillis = 60000;

		$rootScope.getItemDisplayCode = (item) => {
			if (!item) return '';

			if (ConfigService.config.business.product_code_display_type == 'EXTERNAL_CODE') {
				return item.externalCode;
			} else if (ConfigService.config.business.product_code_display_type == 'AUTOMATION_CODE') {
				return item.automationCode;
			} else {
				return item.productCode;
			}
		};

        authManager.checkAuthOnRefresh();
        authManager.redirectWhenUnauthenticated();

        $rootScope.$on('message-integrity-check-failed', () => {
            $state.transitionTo('login');
        });

        $rootScope.externallyLoadedApp = false;

        $rootScope.$on('app-external-request', function (event, uriString) {
            ExternalLoadingService.validate(uriString).then(function () {
                $state.go('externalloading', {
                    'uri': uriString
                })
            }).catch(error => {
                AlertService.show('Erro ao carregar aplicação externamente', error.message, 'Sair');
            });

        });

        $rootScope.exitApp = function () {
            if (navigator.app) {
                LogService.info(`Aplicativo ${APP_NAME} fechado pelo usuário`);
                navigator.app.exitApp();
            } else if (navigator.device) {
                LogService.info(`Aplicativo ${APP_NAME} fechado pelo usuário`);
                navigator.device.exitApp();
            } else {
                $state.go('login');
            }
        }

        $ionicPlatform.ready(function () {
            window.addEventListener("batterystatus", status => {
                LogService.info("Status do Dispositivo: " + "Carga da Bateria: [" + status.level + "%]" + " Carregador Conectado: [" + status.isPlugged + "]");
                $rootScope.batteryAtMinimum = status.level <= 10 && !status.isPlugged;
            }, false);

            if (window.cordova) {
                if (isAndroid) {
                    $rootScope.rootFilePath = window.cordova.file.externalRootDirectory;
                } else {
                    $rootScope.rootFilePath = window.cordova.file.documentsDirectory;
                }
                $rootScope.fullRootFilePath = $rootScope.rootFilePath + "Linx/CaixaRapido";
                $rootScope.fullRootFilePathConfig = $rootScope.fullRootFilePath + "/config/";
                $rootScope.fullRootFilePathLogs = $rootScope.fullRootFilePath + "/logs/";
                $rootScope.fullRootFilePathDb = `${$rootScope.fullRootFilePath}/db/`;
                $rootScope.fullRootFilePathBin = $rootScope.fullRootFilePath + "/bin/";

                console.log($rootScope.rootFilePath);
                console.log($rootScope.fullRootFilePathConfig);
                console.log($rootScope.fullRootFilePathLogs);
                console.log($rootScope.fullRootFilePathDb);
                console.log($rootScope.fullRootFilePathBin);

                cordova.getAppVersion.getVersionNumber().then(function (version) {
                    $rootScope.appVersion = version;
                });
                $rootScope.isCordova = true;

                function onSuccess(address) {
                    window.ionic.ipAddress = address.ip;
                }
                networkinterface.getWiFiIPAddress(onSuccess, () => { });
                networkinterface.getCarrierIPAddress(onSuccess, () => { });

                ConfigService.device = {
                    lio: device.model == 'Cielo_LIO'
                };

                window.cordova.plugin.http.setServerTrustMode('pinned', function() {
                    console.log('ssl pinning enabled!');
                  }, function() {
                    console.log('ssl pinning error!');
                  });
            }

            $rootScope.dataSourceManager = new DataSourceProviderManager($injector);

            if (window.StatusBar) {
                StatusBar.styleDefault();
            }

            if (window.Keyboard) {
                // a versão atual do plugin de keyboard não possui alias para uso de método único.
                if (Keyboard.hideFormAccessoryBar) {
                    Keyboard.hideFormAccessoryBar(true);
                } else if (Keyboard.hideFormAccessoryBar) {
                    Keyboard.hideKeyboardAccessoryBar(true);
                }
            }

            EFTService.init();

            const loadDataSource = () => {
                return $rootScope.dataSourceManager.load()
                    .then(() => {
                        ConfigService.updateAppSettings();
                        AuditService.appStarted();
                    })
                    .catch(LogService.error)
                    .finally(() => {
                        PaymentProcessor.initialize();
                        $timeout(navigator.splashscreen.hide());
                    });
            };

            if (isAndroid && $rootScope.isCordova) {
                const permissions = cordova.plugins.permissions;

                const requiredPermissions = [
                    permissions.CAMERA,
                    permissions.INTERNET,
                    permissions.WRITE_EXTERNAL_STORAGE,
                ];

                const ver = device.version.split(".");
                const major = parseInt(ver[0]);

                if (major >= 12) {
                    requiredPermissions.push(permissions.BLUETOOTH_SCAN);
                    requiredPermissions.push(permissions.BLUETOOTH_CONNECT);
                } else {
                    requiredPermissions.push(permissions.BLUETOOTH);
                    requiredPermissions.push(permissions.BLUETOOTH_ADMIN);
                }

                const permissionsCheck = $q.defer();

                permissions.hasPermission(requiredPermissions, function (status) {
                    if (!status.hasPermission) {
                        const errorCallback = function () {
                            LogService.warn('Permissões não foram aceitas');
                            permissionsCheck.reject();
                        }
                        permissions.requestPermissions(requiredPermissions, function (status) {
                            if (!status.hasPermission) {
                                errorCallback();
                            } else {
                                permissionsCheck.resolve();
                            }
                        }, errorCallback);
                    } else {
                        permissionsCheck.resolve();
                    }
                }, permissionsCheck.reject);

                permissionsCheck.promise.then(() => {
                    LogService.initialize().then(() => {
                        LogService.configuration().finally(() => {
                            loadDataSource();
                        });
                    }).catch(console.log);
                }, (error) => {
		    const msg = 'Permissões necessárias para utilização do Aplicativo não foram aceitas. O Aplicativo será encerrado.';
                    LogService.error(msg, error);
                    AlertService.alert(msg).finally(() => {
                        navigator.app.exitApp();
                    });
                });

                /**
                 * Remove a ação do Botão de voltar do Android.
                 */
                $ionicPlatform.registerBackButtonAction(function (event) {
                    if ($state.is('login')) {
                        navigator.app.exitApp();
                    } else {
                        event.preventDefault();
                    }
                }, 151);
            } else if (!isAndroid && $rootScope.isCordova) { //Iphone
                LogService.initialize().then(() => {
                    LogService.configuration().finally(() => {
                        LogService.info('Carregando arquivo para IOS no storage...');
                        loadDataSource();
                    });
                }).catch(console.log);
            } else { //Iniciar apenas o datasource.
                LogService.initialize().then(() => {
                    LogService.configuration().finally(() => {
                        LogService.info('Carregando arquivo para IOS no storage...');
                        loadDataSource();
                    });
                }).catch(console.log);
            }
        });

        Number.prototype.toFixedDown = function (digits) {
            var re = new RegExp("(\\d+\\.\\d{" + digits + "})(\\d)"),
                m = this.toString().match(re);
            return m ? parseFloat(m[1]) : this.valueOf();
        };
    })

    /**
     * Tratador de redirecionamento de estados.
     *
     */
    .run(function ($rootScope, UserService, UtilService, ConfigService) {
        $rootScope.$on('$stateChangeStart', function (evt, to, params) {
            var redirect;

            if (to.redirectTo) {
                if (typeof to.redirectTo === "function") {
                    redirect = to.redirectTo($rootScope, ConfigService.config);
                } else {
                    redirect = to.redirectTo;
                }
            }

            if (redirect) {
                evt.preventDefault();

                if (localStorage.getItem('id_token')) {
                    UtilService.navigateWithoutHistory(redirect, params);
                } else {
                    UtilService.navigateWithoutHistory('login');
                }
            }

            if (to.name === 'login') {
                var idle = angular.element(document.body).injector().get("Idle");

                localStorage.removeItem('id_token');
                idle.unwatch();
            } else {
                if (!UserService.isAuthenticated()) {
                    evt.preventDefault();
                    UtilService.navigateWithoutHistory('login');
                }
            }
        });
    })

    /**
     * Interceptador para definições globais para requisição/resposta.
     */
    .factory('httpIntercept', function ($q, $timeout, $rootScope, LogService, jwtHelper) {
        var linxWS = "/linx-webservices";
        var messageKeyHeader = "Message-Key";
        var requestKeyHeader = "Request-Key";
        var applicationDataHeader = "Application-Data";
        var secret = "$%pf#&RTw7SLYp$!";


        /**
         * Função cria "defer" cuja promessa permite cancelar a requisição.
         * A promessa de timeout passada repassa o resultado de sua execução para o "defer" criado,
         * possibilitando limite de tempo para uma requisição.
         */
        var canceler = function (timeoutPromise) {
            var deferred = $q.defer();

            $q.when(timeoutPromise).then(deferred.resolve, deferred.reject);

            return deferred;
        }

        function getTimeoutByUrl(url, defaultTimeout) {
            if (url && url.contains('/linx-webservices/v1/paf')) {
                return $rootScope.pafTimeout;
            } else {
                return defaultTimeout ? defaultTimeout : 60000;
            }
        }

        function encodeObjectURI (obj) {
            let str = [];
            const sortedObj = Object.keys(obj).sort().reduce((r, k) => (r[k] = obj[k], r), {});
            for (let p in sortedObj)
                str.push(encodeURIComponent(p) + "=" + encodeURIComponent(sortedObj[p]));
            return str.join("&");
        }

        function getFinalUrl(rawUrl) {
            let url = new URL(rawUrl);
            if (url.port === 443) {
                url.port = '';
            }
            return url.toString();
        }

        return {
            'request': function (config) {
                if (config.url.contains(linxWS)) {
                    const timeout = getTimeoutByUrl(config.url, $rootScope.defaultRequestTimeoutInMillis);
                    config.canceler = canceler($timeout(function () {
                        config.timedOut = true;
                    }, timeout));
                    config.timeout = timeout;
                }

                var linxWSIndex = config.url.indexOf(linxWS);

                if (linxWSIndex > -1) {
                    // Se tiver dados no body do HTTP
                    if (config.data) {
                        // Se for um POST e um objeto, será convertido. Adiciona header de integridade.
                        if ((config.method === 'POST' || config.method === 'PUT') && angular.isObject(config.data)) {
                            const obj = config.data;
                            let content = null;
                            // se for 'application/x-www-form-urlencoded', codifica o conteúdo do body a ser enviado
                            if (config.headers['Content-Type'] === 'application/x-www-form-urlencoded') {
                                content = encodeObjectURI(obj);
                            } else {
                                content = angular.toJson(obj);
                            }
                            var hash = CryptoJS.HmacSHA512(content, secret);
                            config.headers[messageKeyHeader] = hash;
                        }
                    }
                    // Se começar com http/https, adiciona o hash para o 'Request-Key'
                    if (config.url.startsWith('http')) {
                        var rawUrl = getFinalUrl(config.url);

                        if (config.params) {
                            rawUrl = rawUrl + '?' + config.paramSerializer(config.params);
                        }
                        rawUrl = rawUrl.toLowerCase();

                        var hashUrl = CryptoJS.HmacSHA512(rawUrl, secret);
                        config.headers[requestKeyHeader] = hashUrl;

                        let applicationDataTestingObject = {"currentDate": new Date().toISOString(), "version": $rootScope.appVersion};
                        const key = CryptoJS.enc.Utf8.parse(secret);

                        var encrypted = CryptoJS.AES.encrypt(JSON.stringify(applicationDataTestingObject), key, {
                            mode: CryptoJS.mode.ECB,
                            padding: CryptoJS.pad.Pkcs7
                        });

                        let applicationDatabase64 = encrypted.ciphertext.toString(CryptoJS.enc.Base64);
                        config.headers[applicationDataHeader] = applicationDatabase64;
                    }

                    const tids = LogService.getKey('transactionsIds');
                    const externalTids = LogService.getKey('externalTransactionsIds');

                    if (tids) {
                        config.headers['Transactions-Ids'] = tids;
                    }
                    if (externalTids) {
                        config.headers['External-Transactions-Ids'] = externalTids;
                    }
                    config.headers['Application-Name'] = 'Caixa-Rapido';
                }
                return config;
            },
            'response': function (response) {
                var authorizationHeader = response.headers('Authorization');

                if (authorizationHeader) {

                    let decodedToken = jwtHelper.decodeToken(authorizationHeader);
                    if (decodedToken.sessionCryptoKey != null) {
                        sessionStorage.setItem('sessionCryptoKey', JSON.stringify(decodedToken.sessionCryptoKey));
                    }

                    var bearer = "Bearer ";
                    if (authorizationHeader.startsWith(bearer)) {
                        var token = authorizationHeader.substring(bearer.length, authorizationHeader.length);
                        localStorage.setItem('id_token', token);
                    }
                }

                if (response.config && response.config.url) {
                    var linxWSIndex = response.config.url.indexOf(linxWS);
                    if (linxWSIndex > -1) {
                        // é uma URL do linx-webservices
                        var relativeUrl = response.config.url.substring(linxWS.length + linxWSIndex);

                        // Verifica se o conteúdo original era um JSON (necessário manter o JSON original para checagem de Hash criptografado.
                        if (response.data && response.data.rawJson) {
                            var messageKey = response.headers(messageKeyHeader);

                            if (messageKey) {
                                var hash = CryptoJS.HmacSHA512(response.data.rawJson, secret);
                                var hashUpper = hash.toString().toUpperCase();
                                response.data.rawJson = undefined;

                                if (messageKey != hashUpper) {
                                    response.data = {
                                        message: 'Falha na verificação da integridade da mensagem! [001]'
                                    };
                                    $rootScope.$emit("message-integrity-check-failed");

                                    return $q.reject(response);
                                }
                            } else {
                                // se não tiver o header do servidor, rejeita.
                                response.data = {
                                    message: 'Falha na verificação da integridade da mensagem! [002]'
                                };
                                response.data.rawJson = undefined;
                                $rootScope.$emit("message-integrity-check-failed");

                                return $q.reject(response);
                            }
                        }
                    }
                }
                return response;
            },
            'responseError': function (response) {
                if (response.status == -1) { // Tanto um cancelamento da requisição, quando um timeout tem o mesmo status...
                    if (response.config.timedOut) {
                        response.data = {
                            message: 'Limite do tempo de espera excedido.'
                        };
                    } else {
                        response.data = {
                            message: 'Erro de comunicação com o Servidor.'
                        };
                    }
                } else {
                    if (response.config && response.config.url) {
                        var linxWSIndex = response.config.url.indexOf(linxWS);

                        if (linxWSIndex > -1) {
                            // é uma URL do linx-webservices
                            var relativeUrl = response.config.url.substring(linxWS.length + linxWSIndex);

                            // Verifica se o conteúdo original era um JSON (necessário manter o JSON original para checagem de Hash criptografado).
                            if (response.data && response.data.rawJson) {
                                var messageKey = response.headers(messageKeyHeader);

                                if (messageKey) {
                                    var hash = CryptoJS.HmacSHA512(response.data.rawJson, secret);
                                    var hashUpper = hash.toString().toUpperCase();
                                    response.data.rawJson = undefined;

                                    if (messageKey != hashUpper) {
                                        response.data = {
                                            message: 'Falha na verificação da integridade da mensagem! [001]'
                                        };

                                        $rootScope.$emit("message-integrity-check-failed");
                                    }
                                } else {
                                    // se não tiver o header do servidor, rejeita.
                                    response.data = {
                                        message: 'Falha na verificação da integridade da mensagem! [002]'
                                    };
                                    response.data.rawJson = undefined;
                                    $rootScope.$emit("message-integrity-check-failed");
                                }
                            }
                        }
                    }
                }
                return $q.reject(response);
            }
        };
    })

    .factory('$exceptionHandler', function ($injector) {
        return function (exception, cause) {
            var logFile = $injector.get('LogService');
            logFile.fatal(exception.message);
            logFile.fatal(exception.cause);
            logFile.fatal(exception.stack);
            var rScope = $injector.get('$rootScope');
            if (rScope) {
                rScope.$broadcast('exception', exception, cause);
            }
        };
    })
    /**
     *  Adicionando interceptador http.
     */
    .config(['$httpProvider', function ($httpProvider) {
        $httpProvider.defaults.transformResponse = function (data) {
            var newData = data;
            if (newData) {
                try {
                    JSON.parse(data);
                    var newData = angular.fromJson(data);
                    newData.rawJson = data;
                } catch (e) { }
            }
            return newData;
        };
        $httpProvider.interceptors.push('httpIntercept');
    }])

    .config(function (IdleProvider, KeepaliveProvider) {
        IdleProvider.idle(5); // em segundos
        IdleProvider.timeout(600); // em segundos
    })

    .config(function Config($httpProvider, jwtOptionsProvider) {
        jwtOptionsProvider.config({
            whiteListedDomains: ['[\s\S]*'],
            unauthenticatedRedirector: ['$state', function ($state) {
                console.log('Usuário não autenticado, redirecionando pro login...');
                $state.go('login');
            }],
            tokenGetter: ['options', function (options) {
                // Não envia o token de autenticação para URL's locais do ionic.
                if (options && options.url && options.url.startsWith('http') && options.url.contains('/linx-webservices')) {
                    return localStorage.getItem('id_token');
                } else {
                    return null;
                }

            }]
        });
        $httpProvider.interceptors.push('jwtInterceptor');
    })

    /**
     * Configurações do ionic.
     *
     * @param $ionicConfigProvider
     * @returns
     */
    .config(function ($ionicConfigProvider) {
        $ionicConfigProvider.navBar.alignTitle('center')
    })

    .config(function ($httpProvider) {
        $httpProvider.interceptors.push(function ($q, $injector) {
            
            function formatErrorResponse(rejection) {
                const data = rejection.data;
                const config = rejection.config;

                if (data && data.rawJson) {
                    data.rawJson = undefined;
                }

                const requestData = config ? `${config.method} ${config.url}`: '';
                const responseData = data ? `=> ${JSON.stringify(data)}` : '';
                
                return `${requestData} ${responseData}`;
            }

            return {
                request: function (request) {
                    return request;
                },
                response: function (response) {
                    return response;
                },

                responseError: function (rejection) {
                    var logFile = $injector.get('LogService');
                    logFile.responseError(formatErrorResponse(rejection));
                    return $q.reject(rejection);
                },

                requestError: function (reject) {
                    return reject;
                }
            };
        });
    })

    .config(function ($stateProvider, $urlRouterProvider) {

        $stateProvider.state('login', {
            cache: false,
            url: "/login",
            templateUrl: "views/login.html",
            controller: 'LoginCtrl'
        })

            .state('externalloading', {
                cache: false,
                url: "/externalloading",
                templateUrl: "views/externalloading.html",
                controller: 'ExternalLoadingCtrl',
                params: {
                    uri: null
                },
                disableExternalLoading: true
            })

            .state('easyorder', {
                cache: false,
                url: '/easyorder',
                templateUrl: 'views/home.html',
                controller: 'HomeCtrl'
            })

            .state('easyorder.customermenu', {
                url: '/customermenu',
                views: {
                    'menuItems': {
                        templateUrl: 'views/customermenu.html',
                        controller: 'CustomerCtrl'
                    }
                }
            })

            .state('easyorder.customercpfsearch', {
                cache: false,
                url: '/customercpfserach',
                views: {
                    'menuItems': {
                        templateUrl: 'views/customercpfsearch.html',
                        controller: 'CustomerCtrl'
                    }
                }
            })

            .state('easyorder.customeremailsearch', {
                url: '/customeremailsearch',
                views: {
                    'menuItems': {
                        templateUrl: 'views/customeremailsearch.html',
                        controller: 'CustomerCtrl'
                    }
                }
            })

            .state('easyorder.customercardnumbersearch', {
                url: '/customercardnumbersearch',
                views: {
                    'menuItems': {
                        templateUrl: 'views/customercardnumbersearch.html',
                        controller: 'CustomerCtrl'
                    }
                },
                cache: false,
                params: {
                    flowHistory: undefined,
                }
            })

            .state('easyorder.customerregistrationnumbersearch', {
                url: '/customerregistrationnumbersearch',
                views: {
                    'menuItems': {
                        templateUrl: 'views/customerregistrationnumbersearch.html',
                        controller: 'CustomerCtrl'
                    }
                }
            })

            .state('easyorder.customerbarcodesearch', {
                url: '/customerbarcodesearch',
                views: {
                    'menuItems': {
                        templateUrl: 'views/customerbarcodesearch.html',
                        controller: 'CustomerCtrl'
                    }
                },
                cache: false,
                params: {
                    flowHistory: undefined,
                }
            })

            .state('easyorder.customerchipsearch', {
                url: '/customerchipsearch',
                views: {
                    'menuItems': {
                        templateUrl: 'views/customerchipsearch.html',
                        controller: 'CustomerCtrl'
                    }
                },
                hideSideMenu: true,
                cache: false,
                params: {
                    flowHistory: undefined,
                },
                customerEditDisabled: true
            })

            .state('easyorder.customer', {
                url: '/customer',
                params: {
                    customerToEdit: null,
                    autoSearchByCustomerDocument: false
                },
                hideSideMenu: true,
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/customer.html',
                        controller: 'CustomerCtrl'
                    }
                }
            })

            .state('easyorder.barcode', {
                url: '/barcode',
                redirectTo: function (rootScope, ConfigService) {
                    if (!ConfigService.business.barcode_scanning_method || ConfigService.business.barcode_scanning_method === 'CAMERA') {
                        return 'easyorder.camera-product-search';
                    } else {
                        if (ConfigService.business.enables_rfid_reading) {
                            return 'easyorder.sled-scanner-product-search';
                        } else {
                            return 'easyorder.scanner-product-search';
                        }
                    }
                }
            })

            .state('easyorder.sled-scanner-product-search', {
                url: '/sled-scanner',
                views: {
                    'menuItems': {
                        templateUrl: 'views/product-search/barcodescanner.html',
                        controller: 'SledBarcodeScannerCtrl'
                    }
                },
                disconnetBluebirdOnExit: true
            })
            .state('easyorder.scanner-product-search', {
                url: '/scanner',
                views: {
                    'menuItems': {
                        templateUrl: 'views/product-search/barcodescanner.html',
                        controller: 'ProductSearchScannerCtrl'
                    }
                }
            })
            .state('easyorder.camera-product-search', {
                url: '/camera',
                views: {
                    'menuItems': {
                        templateUrl: 'views/product-search/barcodecamera.html',
                        controller: 'ProductSearchCameraCtrl'
                    }
                }
            })

            .state('easyorder.productsearch', {
                url: '/productsearch',
                views: {
                    'menuItems': {
                        templateUrl: 'views/productsearch.html',
                        controller: 'ProductCtrl'
                    }
                }
            })

            .state('easyorder.rfid-product-search', {
                url: '/rfidscanner',
                views: {
                    'menuItems': {
                        templateUrl: 'views/rfid/v1/sale/rfidscanner.html',
                        controller: 'RFIDScannerCtrl'
                    }
                },
                disconnetBluebirdOnExit: true
            })

            .state('easyorder.cart', {
                url: '/cart',
                views: {
                    'menuItems': {
                        templateProvider: function ($templateFactory, CartService) {
                            var url = (CartService.getCurrentOperation() === 'SERVICE' ? 'views/cart/service.cart.html' : 'views/cart/fiscal.cart.html');
                            return $templateFactory.fromUrl(url);
                        },
                        controller: 'CartCtrl'
                    }
                }
            })

            .state('easyorder.predefinedpaymentmethods', {
                url: '/predefinedpaymentmethods',
                views: {
                    'menuItems': {
                        templateUrl: 'views/payment/predefinedpaymentmethods.html',
                        controller: 'PreDefinedPaymentMethodsCtrl'
                    }
                },
                disableExternalLoading: true
            })

            .state('easyorder.paymentmethods', {
                url: '/paymentmethods',
                views: {
                    'menuItems': {
                        templateUrl: 'views/paymentmethods.html',
                        controller: 'PaymentMethodsCtrl'
                    }
                },
                disableExternalLoading: true,
                customerEditDisabled: true
            })

            .state('easyorder.paymentplans', {
                url: '/paymenteplans',
                params: {
                    paymentState: null,
                    flowHistory: undefined,
                    cashbackAddedInThisProcess: false,
                    disableSorting: false
                },
                views: {
                    'menuItems': {
                        templateUrl: 'views/paymentplans.html',
                        controller: 'PaymentPlansCtrl'
                    }
                },
                disableExternalLoading: true,
                customerEditDisabled: true
            })

            .state('easyorder.tefpayment', {
                url: '/tefpayment',
                views: {
                    'menuItems': {
                        templateUrl: 'views/tefpayment.html',
                        controller: 'TefPaymentCtrl'
                    }
                },
                disableExternalLoading: true
            })
            .state('easyorder.genericpayment', {
                url: '/genericpayment',
                views: {
                    'menuItems': {
                        templateUrl: 'views/payment/genericpayment.html',
                        controller: 'GenericPaymentCtrl'
                    }
                },
                disableExternalLoading: true
            })

            .state('easyorder.privatelabelpayment', {
                url: '/privatelabelpayment',
                views: {
                    'menuItems': {
                        templateUrl: 'views/privatelabelpayment.html',
                        controller: 'PrivateLabelPaymentCtrl'
                    }
                },
                disableExternalLoading: true,
                customerEditDisabled: true
            })

            .state('easyorder.giftcardpayment', {
                url: '/giftcardpayment',
                params: {
                    thruTrail: null
                },
                views: {
                    'menuItems': {
                        templateUrl: 'views/giftcardpayment.html',
                        controller: 'GiftCardPaymentCtrl'
                    }
                },
                disableExternalLoading: true,
                customerEditDisabled: true
            })

            .state('easyorder.covenantpayment', {
                url: '/covenantpayment',
                views: {
                    'menuItems': {
                        templateUrl: 'views/payment/covenantpayment.html',
                        controller: 'CovenantPaymentCtrl'
                    }
                },
                disableExternalLoading: true,
                customerEditDisabled: true
            })

            .state('easyorder.paymentresult', {
                url: '/paymentresult',
                views: {
                    'menuItems': {
                        templateUrl: 'views/paymentresult.html',
                        controller: 'PaymentresultCtrl'
                    }
                },
                disableExternalLoading: true,
                customerEditDisabled: true
            })

            .state('easyorder.ordersearchmenu', {
                url: '/ordersearchmenu',
                views: {
                    'menuItems': {
                        templateUrl: 'views/ordersearchmenu.html',
                        controller: 'OrderCtrl'
                    }
                }
            })

            .state('easyorder.ordersearch', {
                url: '/ordersearch',
                views: {
                    'menuItems': {
                        templateUrl: 'views/ordersearch.html',
                        controller: 'OrderCtrl'
                    }
                }
            })

            .state('easyorder.ordersearch-v2', {
                url: '/ordersearchv2',
                views: {
                    'menuItems': {
                        templateUrl: 'views/order/ordersearch-v2-menu.html',
                        controller: 'OrderCtrl'
                    }
                }
            })

            .state('easyorder.order-doc-search', {
                cache: false,
                url: '/orderdocumentsearch',
                views: {
                    'menuItems': {
                        templateUrl: 'views/order/order-document-search.html',
                        controller: 'OrderDocumentSearchCtrl'
                    }
                },
                params: {
                    flowHistory: undefined
                }
            })

            .state('easyorder.order-search-list', {
                cache: false,
                url: '/orderdocumentsearch',
                views: {
                    'menuItems': {
                        templateUrl: 'views/order/order-search-list.html',
                        controller: 'OrderSearchListCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    orderCustomerDocument: undefined
                }
            })

            .state('easyorder.giftcardmenu', {
                url: '/giftcardmenu',
                views: {
                    'menuItems': {
                        templateUrl: 'views/giftcardmenu.html',
                        controller: 'GiftCardMenuCtrl'
                    }
                },
                customerEditDisabled: true
            })

            .state('easyorder.giftcardsearch', {
                url: '/giftcardsearch',
                views: {
                    'menuItems': {
                        templateUrl: 'views/giftcard.html',
                        controller: 'GiftCardCtrl'
                    }
                }
            })

            .state('easyorder.giftcardtypedrecharge', {
                url: '/giftcardtypedrecharge',
                views: {
                    'menuItems': {
                        templateUrl: 'views/giftcardtypedrecharge.html',
                        controller: 'GiftCardCtrl'
                    }
                }
            })

            .state('easyorder.giftcardinfo', {
                url: '/giftcardinfo',
                params: {
                    giftCard: null
                },
                views: {
                    'menuItems': {
                        templateUrl: 'views/giftcardinfo.html',
                        controller: 'GiftCardInfoCtrl'
                    }
                }
            })

            .state('easyorder.giftcardtheme', {
                url: '/giftcardtheme',
                views: {
                    'menuItems': {
                        templateUrl: 'views/giftcardtheme.html',
                        controller: 'GiftCardThemeCtrl'
                    }
                },
                customerEditDisabled: true
            })

            .state('easyorder.giftcardaddvalue', {
                url: '/giftcardaddvalue',
                params: {
                    giftCard: null
                },
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/giftcardaddvalue.html',
                        controller: 'GiftCardAddValueCtrl'
                    }
                },
                customerEditDisabled: true
            })

            .state('easyorder.giftcardvirtual', {
                url: '/giftcardvirtual',
                params: {
                    giftCard: null
                },
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/giftcardvirtual.html',
                        controller: 'GiftCardVirtualCtrl'
                    }
                },
                customerEditDisabled: true
            })

            .state('easyorder.giftcardpaymentmenu', {
                url: '/giftcardpaymentmenu',
                params: {
                    flowHistory: undefined,
                    cashbackAddedInThisProcess: false
                },
                views: {
                    'menuItems': {
                        templateUrl: 'views/giftcardpaymentmenu.html',
                        controller: 'GiftCardPaymentMenuCtrl'
                    }
                },
                disableExternalLoading: true,
                customerEditDisabled: true
            })

            .state('easyorder.giftcardtypedpayment', {
                url: '/giftcardtypedpayment',
                params: {
                    flowHistory: undefined
                },
                views: {
                    'menuItems': {
                        templateUrl: 'views/giftcardtypedpayment.html',
                        controller: 'GiftCardPaymentCtrl'
                    }
                },
                customerEditDisabled: true
            })

            .state('easyorder.scannedgiftcardpayment', {
                url: '/scannedgiftcardpayment',
                views: {
                    'menuItems': {
                        templateUrl: 'views/scannedgiftcardpayment.html',
                        controller: 'ScannedGiftCardPaymentCtrl'
                    }
                },
                customerEditDisabled: true
            })

            .state('easyorder.passwordgiftcardpayment', {
                url: '/passwordgiftcardpayment',
                params: {
                    giftCard: null
                },
                views: {
                    'menuItems': {
                        templateUrl: 'views/passwordgiftcardpayment.html',
                        controller: 'PasswordGiftCardPaymentCtrl'
                    }
                },
                customerEditDisabled: true
            })

            .state('easyorder.covenant', {
                url: '/covenant',
                views: {
                    'menuItems': {
                        templateUrl: 'views/covenant.html',
                        controller: 'covenantCtrl'
                    }
                }
            })
            .state('easyorder.covenantidentification', {
                url: '/covenantidentification',
                params: {
                    "covenant": null
                },
                views: {
                    'menuItems': {
                        controller: "covenantidentificationCtrl",
                        templateUrl: 'views/covenantidentification.html'
                    }
                }
            })
            .state('easyorder.covenantpassword', {
                url: '/covenantpassword',
                params: {
                    "covenant": null
                },
                views: {
                    'menuItems': {
                        controller: 'covenantpasswordCtrl',
                        templateUrl: 'views/covenantpassword.html'
                    }
                }
            })
            .state('easyorder.covenanttypesidentification', {
                url: '/covenantidentificationCtrl',
                views: {
                    'menuItems': {
                        templateUrl: 'views/covenanttypesidentification.html',
                    }
                }
            })
            .state('easyorder.prescriptions', {
                url: '/prescriptions',
                views: {
                    'menuItems': {
                        templateUrl: 'views/prescriptions.html',
                        controller: 'prescriptionsCtrl'
                    }
                }
            })

            .state('easyorder.showroomingzipcode', {
                url: '/showroomingzipcode',
                params: {
                    currentItem: null,
                    prevState: null
                },
                views: {
                    'menuItems': {
                        templateUrl: 'views/showrooming/showroomingzipcode.html',
                        controller: 'ShowroomingZipcodeCtrl'
                    }
                }
            })

            .state('easyorder.showroomingitemfreightdetails', {
                url: '/showroomingitemfreightdetails',
                params: {
                    currentItem: null,
                    freightQuote: null
                },
                views: {
                    'menuItems': {
                        templateUrl: 'views/showrooming/showroomingitemfreightdetails.html',
                        controller: 'ShowroomingItemFreightCtrl'
                    }
                }
            })

            .state('easyorder.showroomingfulfillments', {
                url: '/showroomingfulfillments',
                params: {
                    freightQuote: null
                },
                views: {
                    'menuItems': {
                        templateUrl: 'views/showrooming/showroomingfulfillments.html',
                        controller: 'ShowroomingFulfillmentsCtrl'
                    }
                }
            })

            .state('easyorder.showroomingsummary', {
                url: '/showroomingsummary',
                params: {
                    freightSelected: null
                },
                views: {
                    'menuItems': {
                        templateUrl: 'views/showrooming/showroomingsummary.html',
                        controller: 'ShowroomingSummaryCtrl'
                    }
                }
            })

            .state('easyorder.productsearchresult', {
                url: '/productsearchresult',
                params: {
                    prevState: null,
                    searchResult: null,
                    productSearchParams: null
                },
                views: {
                    'menuItems': {
                        templateUrl: 'views/productsearchresult.html',
                        controller: 'ProductSearchResultCtrl'
                    }
                }
            })

            .state('easyorder.productdiscounts', {
                url: '/productdiscounts',
                cache: false,
                params: {
                    prevState: null,
                    item: null,
                    discountResult: null,
                    automatic: null,
                    discountType: null,
                    products: null,
                    cart: null
                },
                views: {
                    'menuItems': {
                        templateUrl: 'views/productdiscounts.html',
                        controller: 'ProductDiscountsCtrl'
                    }
                }
            })

            .state('easyorder.productdetail', {
                url: '/productdetail',
                params: {
                    currentItem: null,
                    prevState: null,
                    isPartnerItemReady: null,
                    productSearchParams: null
                },
                views: {
                    'menuItems': {
                        templateUrl: 'views/productdetail.html',
                        controller: 'ProductDetailCtrl'
                    }
                }
            })

            .state('easyorder.authmanager', {
                url: '/authmanager',
                params: {
                    nextPage: null,
                    permission: null,
                },
                views: {
                    'menuItems': {
                        templateUrl: 'views/authmanager.html',
                        controller: 'authmanagerCtrl'
                    }
                }
            })

            .state('easyorder.mobilerechargeoptions', {
                url: '/mobilerechargeoptions',
                views: {
                    'menuItems': {
                        templateUrl: 'views/mobile-recharge/mobilerechargeoptions.html',
                        controller: 'MobileRechargeOptionsCtrl'
                    }
                }
            })

            .state('easyorder.mobilerechargephonenumber', {
                url: '/mobilerechargephonenumber',
                params: {
                    mobileRechargeOption: null
                },
                views: {
                    'menuItems': {
                        templateUrl: 'views/mobile-recharge/mobilerechargephonenumber.html',
                        controller: 'MobileRechargePhoneNumberCtrl'
                    }
                }
            })

            .state('easyorder.servicesale', {
                url: '/servicesale',
                cache: false,
                params: {
                    "item": null,
                    "services": null,
                    "updateAdditionalServices": null
                },
                views: {
                    'menuItems': {
                        templateUrl: 'views/servicesale.html',
                        controller: 'servicesaleCtrl'
                    }
                }
            })

            .state('easyorder.balance', {
                url: '/balance',
                views: {
                    'menuItems': {
                        templateUrl: 'views/balance.html',
                        controller: 'balanceCtrl'
                    }
                }
            })

            .state('easyorder.supply', {
                cache: false,
                url: '/supply',
                views: {
                    'menuItems': {
                        templateUrl: 'views/supply.html',
                        controller: 'supplyCtrl'
                    }
                }
            })

            .state('easyorder.financial', {
                url: '/financial',
                views: {
                    'menuItems': {
                        templateUrl: 'views/financial.html',
                        controller: 'FinancialCtrl'
                    }
                }
            })

            .state('easyorder.discountstypes', {
                url: '/discounttypes',
                params: {
                    "item": null,
                    "result": null,
                    "automatic": null,
                    "cart": null
                },
                views: {
                    'menuItems': {
                        templateUrl: 'views/discountstypes.html',
                        controller: 'DiscountTypesCtrl'
                    }
                }
            })

            .state('easyorder.discountsrules', {
                url: '/discountsrules',
                params: {
                    "item": null,
                    "discountTypes": null
                },
                views: {
                    'menuItems': {
                        templateUrl: 'views/discountsrules.html',
                        controller: 'DiscountRulesCtrl'
                    }
                }
            })

            .state('easyorder.includediscounts', {
                url: '/includediscounts',
                cache: false,
                params: {
                    "discountData": null
                },
                views: {
                    'menuItems': {
                        templateUrl: 'views/includediscounts.html',
                        controller: 'IncludeDiscountsCtrl'
                    }
                }
            })
            .state('easyorder.purchasesummary', {
                url: '/purchasesummary',
                cache: false,
                params: {
                    "discountData": null,
                },
                views: {
                    'menuItems': {
                        templateUrl: 'views/purchasesummary.html',
                        controller: 'purchaseSummaryCtrl'
                    }
                }
            })
            .state('easyorder.employeediscounts', {
                url: '/employeediscounts',
                cache: false,
                params: {
                    "discounts": null,
                },
                views: {
                    'menuItems': {
                        templateUrl: 'views/employeediscounts.html',
                        controller: 'EmployeeDiscountsCtrl'
                    }
                }
            })
            .state('easyorder.operations', {
                url: '/operations',
                views: {
                    'menuItems': {
                        templateUrl: 'views/operations.html',
                        controller: 'OperationsCtrl'
                    }
                }
            })
            .state('easyorder.reports', {
                url: '/reports',
                views: {
                    'menuItems': {
                        templateUrl: 'views/reports/reportlist.html',
                        controller: 'ReportsCtrl'
                    }
                },
                hideFooterInfo: true
            })
            .state('easyorder.consolidatedstoresalessearch', {
                url: '/consolidatedstoresalessearch',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/reports/consolidatedstoresales/consolidatedstoresalessearch.html',
                        controller: 'ConsolidatedStoreSalesSearchCtrl'
                    }
                },
                hideFooterInfo: true
            })
            .state('easyorder.consolidatedstoresalesresult', {
                url: '/consolidatedstoresalesresult',
                views: {
                    'menuItems': {
                        templateUrl: 'views/reports/consolidatedstoresales/consolidatedstoresalesresult.html',
                        controller: 'ConsolidatedStoreSalesResultCtrl'
                    }
                },
                params: {
                    'saleSummaries': undefined,
                    'searchParams': undefined,
                    'pdf': undefined,
                    'printContents': undefined,
                    'documentTitle': undefined
                },
                hideFooterInfo: true
            })
            .state('easyorder.consolidatedstoresalesdetails', {
                url: '/consolidatedstoresalesdetails',
                views: {
                    'menuItems': {
                        templateUrl: 'views/reports/consolidatedstoresales/consolidatedstoresalesdetails.html',
                        controller: 'ConsolidatedStoreSalesDetailsCtrl'
                    }
                },
                params: {
                    'saleSummaries': undefined,
                    'searchParams': undefined,
                    'pdf': undefined,
                    'printContents': undefined,
                    'documentTitle': undefined
                },
                hideFooterInfo: true
            })
            .state('easyorder.storesalessearch', {
                url: '/storesalessearch',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/reports/storesales/storesalessearch.html',
                        controller: 'StoreSalesSearchCtrl'
                    }
                },
                hideFooterInfo: true
            })
            .state('easyorder.storesalesresult', {
                url: '/storesalesresult',
                views: {
                    'menuItems': {
                        templateUrl: 'views/reports/storesales/storesalesresult.html',
                        controller: 'StoreSalesResultCtrl'
                    }
                },
                params: {
                    'saleSummaries': undefined,
                    'searchParams': undefined
                },
                hideFooterInfo: true
            })
            .state('easyorder.storesalesdetails', {
                url: '/storesalesdetails',
                views: {
                    'menuItems': {
                        templateUrl: 'views/reports/storesales/storesalesdetails.html',
                        controller: 'StoreSalesDetailsCtrl'
                    }
                },
                params: {
                    'saleSummaries': undefined,
                    'searchParams': undefined
                },
                hideFooterInfo: true
            })
            .state('easyorder.mysalessearch', {
                url: '/mysalessearch',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/reports/mysales/mysalessearch.html',
                        controller: 'MySalesSearchCtrl'
                    }
                },
                hideFooterInfo: true
            })
            .state('easyorder.mysalesresult', {
                url: '/mysalesresult',
                views: {
                    'menuItems': {
                        templateUrl: 'views/reports/mysales/mysalesresult.html',
                        controller: 'MySalesResultCtrl'
                    }
                },
                params: {
                    'saleSummaries': undefined,
                    'searchParams': undefined
                },
                hideFooterInfo: true
            })
            .state('easyorder.mysalesdetails', {
                url: '/mysalesdetails',
                views: {
                    'menuItems': {
                        templateUrl: 'views/reports/mysales/mysalesdetails.html',
                        controller: 'MySalesDetailsCtrl'
                    }
                },
                params: {
                    'saleSummaries': undefined,
                    'searchParams': undefined
                },
                hideFooterInfo: true
            })
            .state('easyorder.transactionsearch', {
                url: '/transactionsearch',
                views: {
                    'menuItems': {
                        templateUrl: 'views/transactionsearch.html',
                        controller: 'TransactionSearchCtrl'
                    }
                },
                params: {
                    'op': undefined,
                    'authorizer': undefined,
                }
            })
            .state('easyorder.exchangetransactioncustomerIdentification', {
                url: '/exchangetransactioncustomerIdentification',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/returns/exchange/exchangetransactioncustomerIdentification.html',
                        controller: 'ExchangeTransactionCustomerIdentificationCtrl'
                    }
                },
                params: {
                    authorizer: undefined
                },
                hideFooterButtons: true,
                hideFooterTotal: true
            })
            .state('easyorder.exchangetransactioncustomerIdentificationv3', {
                url: '/exchangetransactioncustomerIdentification',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/returns/exchange/exchangetransactioncustomerIdentificationv3.html',
                        controller: 'ExchangeTransactionCustomerIdentificationCtrl'
                    }
                },
                hideFooterButtons: true,
                hideFooterTotal: true
            })
            .state('easyorder.exchangemenu', {
                url: '/exchangemenu',
                views: {
                    'menuItems': {
                        templateUrl: 'views/returns/exchange/exchangemenu.html',
                        controller: 'ExchangeMenuCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    authorizations: undefined,
                    customer: undefined
                },
                hideFooterButtons: true,
                hideFooterTotal: true
            })
            .state('easyorder.exchangemenuv3', {
                url: '/exchangemenuv3',
                views: {
                    'menuItems': {
                        templateUrl: 'views/returns/exchange/exchangemenuv3.html',
                        controller: 'ExchangeMenuCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    customer: undefined
                },
                hideFooterButtons: true,
                hideFooterTotal: true
            })
            .state('easyorder.rfidscannedexchangetransaction', {
                url: '/rfidscannedexchangetransaction',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/returns/exchange/scanned/rfidscannedexchangetransaction.html',
                        controller: 'RFIDScannedExchangeTransactionCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    authorizations: undefined,
                    customer: undefined,
                    exchangeData: undefined
                },
                hideFooterButtons: true,
                hideFooterTotal: true,
                disconnetBluebirdOnExit: true
            })
            .state('easyorder.exchangerfidtagtransactionsearch', {
                url: '/exchangerfidtagtransactionsearch',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/returns/exchange/epc/exchangerfidtagtransactionsearch.html',
                        controller: 'ExchangeRFIDTagTransactionSearchCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    authorizations: undefined,
                    customer: undefined,
                    exchangeData: undefined
                },
                hideFooterButtons: true,
                hideFooterTotal: true,
                disconnetBluebirdOnExit: true
            })
            .state('easyorder.scannedexchange', {
                url: '/scannedexchangesearch',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/returns/exchange/scanned/scannedexchangesearch.html',
                        controller: 'ScannedExchangeCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    authorizations: undefined,
                    customer: undefined,
                    exchangeData: undefined
                },
                hideFooterButtons: true,
                hideFooterTotal: true,
                disconnetBluebirdOnExit: true
            })
            .state('easyorder.scannedexchangev3', {
                url: '/scannedexchangesearchv3',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/returns/exchange/scanned/scannedexchangesearchv3.html',
                        controller: 'ScannedExchangeCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    exchangeData: undefined,
                    customer: undefined
                },
                hideFooterButtons: true,
                hideFooterTotal: true,
                disconnetBluebirdOnExit: true
            })
            .state('easyorder.rfidscannedexchangecouponless', {
                url: '/rfidscannedexchangecouponless',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/returns/exchange/scanned/rfidscannedexchangecouponless.html',
                        controller: 'RFIDScannedExchangeCouponlessCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    authorizations: undefined,
                    customer: undefined,
                    exchangeData: undefined
                },
                hideFooterButtons: true,
                hideFooterTotal: true,
                disconnetBluebirdOnExit: true
            })
            .state('easyorder.scannedexchangecouponless', {
                url: '/scannedexchangecouponless',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/returns/exchange/scanned/scannedexchangecouponless.html',
                        controller: 'ScannedExchangeCouponlessCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    authorizations: undefined,
                    customer: undefined,
                    exchangeData: undefined
                },
                hideFooterButtons: true,
                hideFooterTotal: true,
                disconnetBluebirdOnExit: true
            })
            .state('easyorder.typedexchange', {
                url: '/typedexchangesearch',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/returns/exchange/typed/typedexchangesearch.html',
                        controller: 'TypedExchangeCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    authorizations: undefined,
                    customer: undefined,
                    exchangeData: undefined
                },
                hideFooterButtons: true,
                hideFooterTotal: true
            })
            .state('easyorder.typedexchangev3', {
                url: '/typedexchangesearchv3',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/returns/exchange/typed/typedexchangesearchv3.html',
                        controller: 'TypedExchangeCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    exchangeData: undefined,
                    customer: undefined
                },
                hideFooterButtons: true,
                hideFooterTotal: true
            })
            .state('easyorder.documentexchange', {
                url: '/documentexchangesearch',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/returns/exchange/document/documentexchangesearch.html',
                        controller: 'DocumentExchangeCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    authorizations: undefined,
                    customer: undefined,
                    exchangeData: undefined
                },
                hideFooterButtons: true,
                hideFooterTotal: true
            })
            .state('easyorder.exchangetransactioncouponslist', {
                url: '/exchangetransactioncouponslist',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/returns/exchange/exchangetransactioncouponslist.html',
                        controller: 'ExchangeTransactionCouponsCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    transactions: undefined,
                    authorizations: undefined,
                    searchCustomer: undefined,
                    customer: undefined,
                    exchangeData: undefined
                },
                hideFooterButtons: true,
                hideFooterTotal: true
            })
            .state('easyorder.exchangetransactionproductlist', {
                url: '/exchangetransactionproductlist',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/returns/exchange/exchangetransactionproductlist.html',
                        controller: 'ExchangeTransactionProductListCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    authorizations: undefined,
                    customer: undefined,
                    exchangeData: undefined
                },
                hideFooterButtons: true,
                hideFooterTotal: true
            })
            .state('easyorder.exchangetransactionproductlistv3', {
                url: '/exchangetransactionproductlistv3',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/returns/exchange/exchangetransactionproductlistv3.html',
                        controller: 'ExchangeTransactionProductListCtrlV3'
                    }
                },
                params: {
                    flowHistory: undefined,
                    exchangeData: undefined,
                    storeNumber: undefined,
                    customer: undefined
                },
                hideFooterButtons: true,
                hideFooterTotal: true
            })
            .state('easyorder.exchangetransactionrfidlinkage', {
                url: '/exchangetransactionrfidlinkage',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/returns/exchange/exchangetransactionrfidlinkage.html',
                        controller: 'ExchangeTransactionRFIDLinkageCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    customer: undefined,
                    authorizations: undefined,
                    exchangeData: undefined
                },
                hideFooterButtons: true,
                hideFooterTotal: true,
                disconnetBluebirdOnExit: true
            })
            .state('easyorder.exchangetransactionrfidactivation', {
                url: '/exchangetransactionrfidactivation',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/returns/exchange/exchangetransactionrfidactivation.html',
                        controller: 'ExchangeTransactionRfidActivationCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    customer: undefined,
                    authorizations: undefined,
                    exchangeData: undefined
                },
                hideFooterButtons: true,
                hideFooterTotal: true,
                disconnetBluebirdOnExit: true
            })
            .state('easyorder.exchangetransactionrequest', {
                url: '/exchangetransactionrequest',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/returns/exchange/exchangetransactionrequest.html',
                        controller: 'ExchangeTransactionRequestCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    exchangeData: undefined,
                    customer: undefined,
                    authorizations: undefined
                },
                hideFooterButtons: true,
                hideFooterTotal: true
            })
            .state('easyorder.exchangetransactionrequestv3', {
                url: '/exchangetransactionrequestv3',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/returns/exchange/exchangetransactionrequestv3.html',
                        controller: 'ExchangeTransactionRequestCtrlV3'
                    }
                },
                params: {
                    flowHistory: undefined,
                    exchangeData: undefined,
                    customer: undefined,
                    authorizations: undefined
                },
                hideFooterButtons: true,
                hideFooterTotal: true
            })
            .state('easyorder.transactionproductlist', {
                url: '/transactionproductlist',
                views: {
                    'menuItems': {
                        templateUrl: 'views/transactionproductlist.html',
                        controller: 'TransactionProductListCtrl'
                    }
                },
                params: {
                    'op': undefined,
                    'authorizer': undefined,
                    'sourceTransaction': undefined
                },
            })
            .state('easyorder.transactionjustification', {
                url: '/transactionjustification',
                views: {
                    'menuItems': {
                        templateUrl: 'views/transactionjustification.html',
                        controller: 'TransactionJustificationCtrl'
                    }
                },
                params: {
                    'op': undefined,
                    'authorizer': undefined,
                    'data': undefined,
                },
            })
            .state('easyorder.voucher', {
                url: '/voucher',
                views: {
                    'menuItems': {
                        templateUrl: 'views/voucher.html',
                        controller: 'VoucherCtrl'
                    }
                },
                params: {
                    'op': undefined,
                    'authorizer': undefined,
                    'sourceTransaction': undefined,
                    'returnData': undefined,
                    'returnReason': undefined,
                }
            })
            .state('easyorder.exchangeuuidinputs', {
                url: '/exchangeuuidinputs',
                views: {
                    'menuItems': {
                        templateUrl: 'views/exchange-uuid-inputs.html',
                        controller: 'ExchangeUuidInputsCtrl'
                    }
                },
                params: {
                    'op': undefined,
                    'authorizer': undefined,
                    'sourceTransaction': undefined,
                    'exchangeData': undefined,
                    'returnReason': undefined,
                }
            })
            .state('easyorder.couponview', {
                url: '/couponview',
                views: {
                    'menuItems': {
                        templateUrl: 'views/coupon-view.html',
                        controller: 'CouponViewCtrl'
                    }
                },
                params: {
                    'pdf': undefined,
                    'printContents': undefined,
                    'documentTitle': undefined,
                    'showPdf': true
                },
                hideSideMenu: true,
                hideFooterButtons: true,
                hideFooterTotal: true
            })
            .state('easyorder.donation', {
                url: '/donation',
                views: {
                    'menuItems': {
                        templateUrl: 'views/donation.html',
                        controller: 'DonationCtrl'
                    }
                },
                params: {
                    'op': undefined,
                    'authorizer': undefined,
                }
            })
            .state('easyorder.voucherpayment', {
                url: '/voucherpayment',
                views: {
                    'menuItems': {
                        templateUrl: 'views/voucher-payment.html',
                        controller: 'VoucherPaymentCtrl'
                    }
                },
                params: {}
            })
            .state('easyorder.voucherpaymentsearch', {
                url: '/voucherpaymentsearch',
                views: {
                    'menuItems': {
                        templateUrl: 'views/voucherpaymentsearch.html',
                        controller: 'VoucherPaymentSearchCtrl'
                    }
                },
                params: {
                    'customer': undefined,
                    'vouchers': undefined,
                    'containsUsed': false,
                    'voucherType': undefined,
                    'voucherCredentials': null,
                    'paymentValue': undefined
                },
                hideSideMenu: true,
                customerEditDisabled: true
            })
            .state('easyorder.voucherpaymentsearchv3', {
                url: '/voucherpaymentsearchv3',
                views: {
                    'menuItems': {
                        templateUrl: 'views/voucherpaymentsearchv3.html',
                        controller: 'VoucherPaymentSearchCtrl'
                    }
                },
                params: {
                    'vouchers': undefined,
                    'containsUsed': false,
                    'voucherType': undefined,
                    'paymentValue': undefined
                },
                hideSideMenu: true,
                customerEditDisabled: true
            })
            .state('easyorder.voucherpaymentsearchoptions', {
                url: '/voucherpaymentsearchoptions',
                views: {
                    'menuItems': {
                        templateUrl: 'views/voucherpaymentsearchoptions.html',
                        controller: 'VoucherPaymentSearchOptionsCtrl'
                    }
                },
                params: {
                    customer: null,
                    paymentValue: null,
                    voucherType: null,
                    isPasswordRequired: null,
                },
                hideSideMenu: true,
                customerEditDisabled: true
            })
            .state('easyorder.voucherpaymentsearchoptionsv3', {
                url: '/voucherpaymentsearchoptionsv3',
                views: {
                    'menuItems': {
                        templateUrl: 'views/voucherpaymentsearchoptionsv3.html',
                        controller: 'VoucherPaymentSearchOptionsCtrl'
                    }
                },
                params: {
                    customer: null,
                    paymentValue: null,
                    voucherType: null
                },
                hideSideMenu: true,
                customerEditDisabled: true
            })
            .state('easyorder.voucherbarcodepayment', {
                url: '/voucherbarcodepayment',
                views: {
                    'menuItems': {
                        templateUrl: 'views/voucherbarcodepayment.html',
                        controller: 'VoucherBarcodePaymentCtrl'
                    }
                },
                params: {
                    paymentValue: null,
                    voucherType: null,
                    isPasswordRequired: null,
                },
                hideSideMenu: true,
                customerEditDisabled: true
            })
            .state('easyorder.reprintsearch', {
                url: '/reprintsearch',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/reprintsearch.html',
                        controller: 'reprintSearchCtrl'
                    }
                },
                params: {
                    option: null,
                    flowHistory: undefined
                }
            })
            .state('easyorder.reprintoptions', {
                url: '/reprintoptions',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/reprint-options.html',
                        controller: 'reprintOptionsCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    options: null
                }
            })
            .state('easyorder.reprintreceiptlist', {
                url: '/reprintreceiptlist',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/reprint-receipt-list.html',
                        controller: 'reprintReceiptListCtrl'
                    }
                },
                params: {
                    receipts: undefined,
                    flowHistory: undefined
                }
            })
			.state('easyorder.sitefqrpayment', {
                url: '/sitefqrpayment',
                cache: false,
                views: {
                    menuItems: {
                        templateUrl: 'views/payment/wallet/sitefqrpayment.html',
                        controller: 'SitefQRPaymentCtrl'
                    }
                },
                customerEditDisabled: true
            })
            .state('easyorder.e-wallet-payment', {
                url: '/e-wallet-payment',
                cache: false,
                views: {
                    menuItems: {
                        templateUrl: 'views/e-wallet-payment.html',
                        controller: 'EWalletPaymentCtrl'
                    }
                },
                params: {
                    paymentValue: undefined,
                    paymentMethod: undefined
                },
                customerEditDisabled: true
            })
            .state('easyorder.billingpaymentmenu', {
                url: '/billingpaymentmenu',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/billing/payment/v1/billingpaymentmenu.html',
                        controller: 'BillingPaymentMenuCtrl'
                    }
                },
                params: {
                    'op': undefined,
                    'authorizer': undefined,
                }
            })
            .state('easyorder.billingpaymentdocumentsearch', {
                url: '/billingpaymentdocumentsearch',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/billing/payment/v1/document/billingpaymentdocumentsearch.html',
                        controller: 'BillingPaymentDocumentSearchCtrl'
                    }
                },
                params: {
                    flowHistory: undefined
                }
            })
            .state('easyorder.billingpaymentscannedsearch', {
                url: '/billingpaymentscannedsearch',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/billing/payment/v1/scanned/billingpaymentscannedsearch.html',
                        controller: 'BillingPaymentScannedSearchCtrl'
                    }
                },
                params: {
                    flowHistory: undefined
                }
            })
            .state('easyorder.billingpaymentchipsearch', {
                url: '/billingpaymentchipsearch',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/billing/payment/v1/chip/billingpaymentchipsearch.html',
                        controller: 'BillingPaymentChipSearchCtrl'
                    }
                },
                params: {
                    flowHistory: undefined
                }
            })
            .state('easyorder.billingpaymentprocessorfilter', {
                url: '/billingpaymentprocessorfilter',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/billing/payment/v1/billingpaymentprocessorfilter.html',
                        controller: 'BillingPaymentProcessorFilterCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    searchData: undefined
                }
            })
            .state('easyorder.billingpaymenttypefilter', {
                url: '/billingpaymenttypefilter',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/billing/payment/v1/billingpaymenttypefilter.html',
                        controller: 'BillingPaymentTypeFilterCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    searchData: undefined
                }
            })
            .state('easyorder.billingpaymentlist', {
                url: '/billingpaymentlist',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/billing/payment/v1/billingpaymentlist.html',
                        controller: 'BillingPaymentListCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    searchData: undefined
                }
            })
            .state('easyorder.billingpaymentcardstatementlist', {
                url: '/billingpaymentcardstatementlist',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/billing/payment/v1/billingpaymentcardstatementlist.html',
                        controller: 'BillingPaymentCardStatementListCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    searchData: undefined
                }
            })
            .state('easyorder.billingpaymentdetachedlist', {
                url: '/billingpaymentdetachedlist',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/billing/payment/v1/billingpaymentdetachedlist.html',
                        controller: 'BillingPaymentDetachedListCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    searchData: undefined
                }
            })
            .state('easyorder.billingpaymentcustomeridentification', {
                url: '/billingpaymentcustomeridentification',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/billing/payment/v1/billingpaymentcustomeridentification.html',
                        controller: 'BillingPaymentCustomerIdentificationCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    searchData: undefined,
                    bills: undefined,
                    authorizerCode: undefined,
                    paymentOperationType: undefined
                }
            })
            .state('easyorder.billingpayment', {
                url: '/billingpayment',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/billing/payment/v1/billingpayment.html',
                        controller: 'BillingPaymentCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    searchData: undefined,
                    bills: undefined,
                    authorizerCode: undefined,
                    paymentOperationType: undefined
                }
            })
            .state('easyorder.billingpaymentresult', {
                url: '/billingpaymentresult',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/billing/payment/v1/billingpaymentresult.html',
                        controller: 'BillingPaymentResultCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    searchData: undefined,
                    bills: undefined,
                    authorizerCode: undefined,
                    payments: undefined,
                    paymentOperationType: undefined
                }
            })
            .state('easyorder.paymentlink', {
                url: '/paymentlink',
                cache: false,
                views: {
                    menuItems: {
                        templateUrl: 'views/payment/link/paymentlink.html',
                        controller: 'PaymentLinkCtrl'
                    }
                },
                customerEditDisabled: true
            })
            .state('easyorder.sitef-paymentlink', {
                url: '/sitefpaymentlink',
                cache: false,
                views: {
                    menuItems: {
                        templateUrl: 'views/payment/link/sitefpaymentlink.html',
                        controller: 'SitefPaymentLinkCtrl'
                    }
                },
                customerEditDisabled: true
            })
            .state('easyorder.paymentlinkRecipientCustomerConfirmation', {
                url: '/paymentlinkRecipientCustomerConfirmation',
                cache: false,
                views: {
                    menuItems: {
                        templateUrl: 'views/payment/link/paymentlinkRecipientCustomerConfirmation.html',
                        controller: 'PaymentlinkCustomerConfirmationCtrl'
                    }
                },
                customerEditDisabled: true
            })
            .state('easyorder.rfid-disable-tag',{
                url: '/rfiddisabletags',
                cache: false,
                views: {
                    menuItems: {
                        templateUrl: 'views/rfid/v1/sale/rfiddisabletags.html',
                        controller: 'RFIDDisableTagsCtrl'
                    }
                },
                disconnetBluebirdOnExit: true,
                hideFooterButtons: true,
                hideFooterTotal: true
            })
            .state('easyorder.rfid-tag-deactivation-menu',{
                url: '/rfidtagdeactivationmenu',
                cache: false,
                views: {
                    menuItems: {
                        templateUrl: 'views/rfid/v1/deactivation/rfidtagdeactivationmenu.html',
                        controller: 'RFIDTagDeactivationMenuCtrl'
                    }
                },
                hideFooterButtons: true,
                hideFooterTotal: true
            })
            .state('easyorder.rfid-tag-deactivation-coupom-type-menu', {
                url: '/rfidtagdeactivationcoupomtypemenu',
                cache: false,
                views: {
                    menuItems: {
                        templateUrl: 'views/rfid/v1/deactivation/rfidtagdeactivationcoupomtypemenu.html',
                        controller: 'RFIDTagDeactivationCoupomTypeMenuCtrl'
                    }
                },
                params: {
                    flowHistory: undefined
                },
                hideFooterButtons: true,
                hideFooterTotal: true
            })
            .state('easyorder.rfid-document-transaction-tag-deactivation', {
                url: '/rfiddocumenttransactiontagdeactivation',
                cache: false,
                views: {
                    menuItems: {
                        templateUrl: 'views/rfid/v1/deactivation/document/rfiddocumenttransactiontagdeactivation.html',
                        controller: 'RFIDDocumentTransactionTagDeactivationCtrl'
                    }
                },
                params: {
                    flowHistory: undefined
                },
                hideFooterButtons: true,
                hideFooterTotal: true
            })
            .state('easyorder.rfid-document-transaction-list-tag-deactivation', {
                url: '/rfiddocumenttransactionlisttagdeactivationCtrl',
                cache: false,
                views: {
                    menuItems: {
                        templateUrl: 'views/rfid/v1/deactivation/document/rfiddocumenttransactionlisttagdeactivationCtrl.html',
                        controller: 'RFIDDocumentTransactionListTagDeactivationCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    transactions: undefined,
                    searchCustomer: undefined
                },
                hideFooterButtons: true,
                hideFooterTotal: true
            })
            .state('easyorder.rfid-epc-transaction-tag-deactivation', {
                url: '/rfidepctransactiontagdeactivation',
                cache: false,
                views: {
                    menuItems: {
                        templateUrl: 'views/rfid/v1/deactivation/epc/rfidepctransactiontagdeactivation.html',
                        controller: 'RFIDEPCTransactionTagDeactivationCtrl'
                    }
                },
                params: {
                    flowHistory: undefined
                },
                disconnetBluebirdOnExit: true,
                hideFooterButtons: true,
                hideFooterTotal: true
            })
            .state('easyorder.rfid-scanned-transaction-tag-deactivation', {
                url: '/rfidscannedtransactiontagdeactivation',
                cache: false,
                views: {
                    menuItems: {
                        templateUrl: 'views/rfid/v1/deactivation/scanned/rfidscannedtransactiontagdeactivation.html',
                        controller: 'RFIDScannedTransactionTagDeactivationCtrl'
                    }
                },
                params: {
                    flowHistory: undefined
                },
                disconnetBluebirdOnExit: true,
                hideFooterButtons: true,
                hideFooterTotal: true
            })
            .state('easyorder.rfid-typed-transaction-tag-deactivation', {
                url: '/rfidtypedtransactiontagdeactivation',
                cache: false,
                views: {
                    menuItems: {
                        templateUrl: 'views/rfid/v1/deactivation/typed/rfidtypedtransactiontagdeactivation.html',
                        controller: 'RFIDTypedTransactionTagDeactivationCtrl'
                    }
                },
                params: {
                    flowHistory: undefined
                },
                hideFooterButtons: true,
                hideFooterTotal: true
            })
            .state('easyorder.rfid-tag-deactivation', {
                url: '/rfidtagdeactivation',
                cache: false,
                views: {
                    menuItems: {
                        templateUrl: 'views/rfid/v1/deactivation/rfidtagdeactivation.html',
                        controller: 'RFIDTagDeactivationCtrl'
                    }
                },
                params: {
                    flowHistory: undefined,
                    transaction: undefined
                },
                disconnetBluebirdOnExit: true,
                hideFooterButtons: true,
                hideFooterTotal: true
            })
            .state('easyorder.rfid-detached-change-tag-header',{
                url: '/rfiddetachedchangetagheader',
                cache: false,
                views: {
                    menuItems: {
                        templateUrl: 'views/rfid/v1/detached/rfiddetachedchangetagheader.html',
                        controller: 'RFIDDetachedChangeTagHeaderCtrl'
                    }
                },
                params: {
                    changeHeadersTo: undefined
                },
                disconnetBluebirdOnExit: true,
                hideFooterButtons: true,
                hideFooterTotal: true
            })

            //Private Label V1 - Biometria facial
            .state('easyorder.privatelabelbiopayment', {
                url: '/privatelabelbiopayment',
                views: {
                    'menuItems': {
                        templateUrl: 'views/payment/privatelabelbiopayment.html',
                        controller: 'PrivateLabelPaymentV1Ctrl'
                    }
                },
                disableExternalLoading: true,
                customerEditDisabled: true
            })

            //Private Label V1 - CartÃ£o e senha
            .state('easyorder.privatelabelpaymentv1', {
                url: '/privatelabelpaymentv1',
                views: {
                    'menuItems': {
                        templateUrl: 'views/privatelabelpayment.html',
                        controller: 'PrivateLabelPaymentV1Ctrl'
                    }
                },
                disableExternalLoading: true,
                customerEditDisabled: true
            })

            .state('easyorder.cardnumbersearch', {
                url: '/cardnumbersearch',
                cache: false,
                views: {
                    'menuItems': {
                        templateUrl: 'views/cardnumbersearch.html',
                        controller: 'cardNumberSearchCtrl'
                    }
                },
                params: {}
            })

            .state('easyorder.annulment', {
                url: '/annulment',
                views: {
                    'menuItems': {
                        templateUrl: 'views/annulment.html',
                        controller: 'AnnulmentCtrl'
                    }
                },
                params: {
                    'op': undefined,
                    'authorizer': undefined,
                    'sourceTransaction': undefined,
                    'returnData': undefined,
                    'returnReason': undefined,
                }
            })

            .state('easyorder.installment-plan-payment', {
                url: '/installment-plan-payment',
                cache: false,
                views: {
                    menuItems: {
                        templateUrl: 'views/payment/installment-plan/installment-plan-payment.html',
                        controller: 'InstallmentPlanPaymentCtrl'
                    }
                }
            })

        // if none of the above states are matched, use this as the fallback
        $urlRouterProvider.otherwise('/login');
    });
