(function() {
    'use strict';
    angular.module("easyorder.components.accordion", []).component("accordion",{
        controllerAs: "$ctrl",
        templateUrl : "js/components/accordion/accordion.template.html",
        transclude: true,
        bindings : {
            title: "@",//String que será mostrada no título do accordion
            field: "@",//Nome do atributo do objeto que será mostrado na listagem
            iconTitle: "@",//Icone que será mostrado no titulo do accordion
            classTitle: "@",//classes acionais para acionar no titulo.
            expanded: "<",//Caso queira que o accordion já apareça expandido.
            expandedMult: "<",//Caso queira que o accordion já apareça expandido.
            itemToggle: "<", //Ao clickar no item o accordion é recolhido.
            onClick: "&",//Função global(normamenta controller) que será acionada ao clicar em um dos itens
            onInfinite: "&",//Função global(normamenta controller) que será acionada ao subir o scroll
            list: "<",//Lista global de objetos que será ultilizada para verificar se é preciso fazer a chamada do infinite.
            disableInfiniteScroll: "@"
        },
        controller : function accordionController($scope, $rootScope) {
            this.field = this.field || "description";
            this.expanded = this.expanded || false;
            this.hasMore = true;
            console.log(this.list);
            this.keepFeeding = function() {
                return this.expanded && this.list.length > 0 && this.hasMore;
            };
            this.onClickAccordion = function() {
                if(!$scope.$ctrl.expanded && !this.expandedMult){
                    $rootScope.$broadcast('close-all-accordion');
                }
                this.expanded = !this.expanded;
            };
            this.clickItem = function (item) {
                if(this.itemToggle) this.expanded = false;
                this.onClick(item)
            };
            this.$onInit = function() {
                if(!this.expandedMult){
                    $rootScope.$on("close-all-accordion", function(){
                        $scope.$ctrl.expanded = false;
                    });
                }
            };
            $scope.$on('scroll.infiniteScrollReachedOut', function(event, args) {
                $scope.$ctrl.hasMore = false;
            });
            $scope.$on('scroll.infiniteScrollFeeding', function(event, args) {
                $scope.$ctrl.hasMore = true;
            });
        } 
    });
})();