(() => {
    "use strict";

    angular
        .module('easyorder.components.restart.float.button', [])
        .component("restartFloatButton", {
            templateUrl: 'js/components/button-float/button-float-basic.template.html',
            controller: RestartFloatButtonController,
            controllerAs: '$ctrl',
            bindings: {
                icon: '@',
                visible: '<',
                disabled: '<',
                animate: '<',
                onResult: '<'
            }
        });

    RestartFloatButtonController.$inject = [
                    '$q',
                    'AlertService'];
    function RestartFloatButtonController(
                    $q,
                    AlertService) {
        var ctrl = this;
                        
        ctrl.$onChanges = (_) => { };
        ctrl.$onDestroy = () => { };
        ctrl.$onInit = () => {
            ctrl.icon = ctrl.icon || "sync-alt";    
        };
        
        ctrl.doAction = () => {
            ctrl.onResult(AlertService.confirm('Deseja iniciar nova venda?')
                            .then(result => {
                                if (result) {
                                    return $q.resolve();
                                } else {
                                    return $q.reject();
                                }
                            }));
        };
    }
})();