(() => {
    "use strict";

    angular
        .module("easyorder.components.email.autocomplete", [])
        .component("emailAutoComplete", {
            templateUrl:
                "js/components/email-autocomplete/email-autocomplete.template.html",
            controller: emailAutoComplete,
            controllerAs: "ctrl",
            bindings: {
                defaultEmail: "=",
                onEmailChange: "&",
                required: "=",
                disabled: "="
            }
        });

    emailAutoComplete.$inject = ['$q','ConfigService','$timeout','$filter'];

    function emailAutoComplete($q,ConfigService,$timeout,$filter) {
        const ctrl = this;
        const listDomain = ConfigService.config.business.email_autocomplete_domain_list;

        ctrl.emails = listDomain ? listDomain : [];
        ctrl.closeList = true;
        ctrl.actualEmailValue = "";

        ctrl.querySearch  = function(evt) {
            const regex = /^(?!\d+\.)(\w[\w\-]{0,24}\w)\./;
            const query = evt.currentTarget.value;

            ctrl.actualEmailValue = query;

            const index = query.indexOf("@");

            if (index != -1) {
                ctrl.validate = true;
                const src = query.substring(0, index).toLowerCase();
                const ret = ctrl.emails
                                .filter(domainValid => domainValid.match(regex))
                                .map(emailHost => src.toLowerCase() + "@" + emailHost)
                                .filter(opt => opt.startsWith(query));
                ctrl.listEmails = ret;
                console.log(ctrl.listEmails);

                if (ctrl.listEmails.length) {
                    ctrl.closeList = false;
                } else {
                    ctrl.closeList = true;
                }
            } else {
                ctrl.closeList = true;
            }
        };

        ctrl.validEmail = function() {
            const email = ctrl.defaultEmail || ctrl.actualEmailValue;
            const emailNew = email.replace( /\s/g, '' ); // remove espaço em branco
            const regexEmail = /([A-Z0-9a-z_-][^@])+?@[^$#<>?]+?\.[\w]{2,4}/; // regex para validar email

            if (regexEmail.test(emailNew)) {
                return true;
            }
            return false;
        }

        ctrl.emailChange = function(email) {
            if (email) {
                ctrl.onEmailChange({ email: email });
            }
        };

        ctrl.emailClick = function(completedEmail){
            ctrl.closeList = true;
            ctrl.defaultEmail = completedEmail;
            ctrl.emailChange(ctrl.defaultEmail);
        };

        ctrl.focusChanged = function(evt) {
            console.log(evt);
        };

        ctrl.$onChanges = function(changesObj) {};
        ctrl.$onDestroy = function() {};
    }
})();
