(() => {
    'use strict';

    angular
        .module('easyorder.modals.orderchecking', [])
        .factory('OrderCheckingModal', OrderCheckingModal);

    OrderCheckingModal.$inject = ['$ionicModal', '$rootScope'];

    function OrderCheckingModal($ionicModal, $rootScope) {
        const HEADER = '[OrderCheckingModal]';
        const $scope = $rootScope.$new(),
            modalOptions = {
                scope: $scope,
                focusFirstInput: true
            };


        function open(conflitingItems) {
            return new Promise((resolve, reject) => {
                if (conflitingItems != null && conflitingItems.length > 0) {
                    $scope.conflitingItems = conflitingItems;
                    $ionicModal.fromTemplateUrl(
                        'js/components/order-checking/order-checking-modal.html',
                        modalOptions
                    ).then(function (modalInstance) {
                        $scope.close = function () {
                            closeAndRemove(modalInstance)
                            .finally(() => resolve());
                        };

                        return modalInstance.show();
                    });
                } else {
                    reject();
                }
            });
        }


        function closeAndRemove(modalInstance) {
            return modalInstance.hide()
                .then(() => {
                    return modalInstance.remove();
                });
        }

        const instance = {
            open: open
        };

        return instance;
    }
})();
