(() => {
    'use strict';

    angular
        .module('easyorder.components.qr-code', [])
        .component('qrCode', {
            templateUrl: 'js/components/qr-code/qr-code.template.html',
            controller: QRCodeController,
            controllerAs: '$ctrl',
            bindings: {
                data: '<',
                width: '<',
                height: '<'
            },
        });

    QRCodeController.$inject = [];
    function QRCodeController() {
        const ctrl = this;
        ////////////////
        
        new QRCode("qr-code", {
            text: ctrl.data,
            width: ctrl.width == null ? 128 : ctrl.width,
            height: ctrl.height == null ? 128 : ctrl.height,
            colorDark : "#000000",
            colorLight : "#ffffff",
            correctLevel : QRCode.CorrectLevel.H
        });

        ctrl.$onInit = function() { };
        ctrl.$onChanges = function(_) { };
        ctrl.$onDestroy = function() { };
    }
})();

