(function () {
    'use strict';
    angular.module('easyorder.controllers.authmanager', [])
        .controller('authmanagerCtrl', function ($scope,
            $rootScope,
            $stateParams,
            $ionicPopup,
            UtilService,
            AlertService,
            UserService) {
            $scope.user = {};

            var sucesso = function (result) {
                if(!result.authorized){
                    erro();
                }

                switch ($stateParams.nextPage) {
                    case 'balance':
                        UtilService.navigateWithoutHistory('easyorder.balance');
                        break;
                
                    default:
                        $rootScope.$emit("CallPayOrderMethod", {});
                        break;
                }
            };

            var erro = function (error) {
                AlertService.restError(error,
                    "Erro ao consultar autorização!").then(function () { UtilService.navigateWithoutHistory('easyorder.cart'); });
            };

            $scope.managerAuthentication = function () {
                var permission = null;

                switch ($stateParams.permission) {
                    case INCLOMPLETE_PARTNER_PRODUCT_PERMISSION:
                        permission = INCLOMPLETE_PARTNER_PRODUCT_PERMISSION;
                        break;

                    case OPERATOR_BALANCE:
                        permission = OPERATOR_BALANCE;
                        break;                
                    default:
                        permission = PRESCRIPTION_AVOIDANCE_PERMISSION
                        break;
                }

                if ($scope.user && $scope.user.login && $scope.user.password) {
                    UserService.checkAuthorization($scope.user.login, $scope.user.password, [permission], sucesso, erro);
                } else {
                    var ret = $ionicPopup.alert({
                        title: "Erro",
                        template: "Dados inválidos",
                        okType: "button-theme",
                        okText: okText ? okText : 'OK'
                    }).then(function () { UtilService.navigateWithoutHistory('easyorder.cart'); });
                }
            };
        });
})();