(function () {
    'use strict';
    angular.module('easyorder.controllers.balance', [])
        .controller('balanceCtrl', function (
            $rootScope,
            $scope,
            UserService,
            $ionicLoading,
            $stateParams,
            ConfigService,
            UtilService,
            AlertService) {
            (function () {
                var params = {
                    companyNumber: ConfigService.config.companyNumber,
                    storeNumber: ConfigService.config.storeNumber
                }

                $scope.getOperatorValueSum = function(items) {
                    return items
                        .map(function(x) { return x.balance; })
                        .reduce(function(a, b) { return a + b; });
                };

                UserService.getBalanceStore(params,
                    function (result) {
                        $scope.balanceStore = result.balances;        
                        for (let index = 0; index < $scope.balanceStore.length; index++) {
                            var date = new Date($scope.balanceStore[index].lastUpdate);
                            $scope.balanceStore[index].lastUpdate = date.getDate().toString() + '/' + (date.getMonth() + 1).toString() + '/' + date.getFullYear().toString();
                        }
                        $ionicLoading.hide();
                    },
                    function (err) {
                        $ionicLoading.hide();
                        AlertService.restError(err, 'Não foi possível obter saldo dos operadores.').then((result)=>{
                            UtilService.navigateWithoutHistory('easyorder.financial');
                        });
                    });
            })();
        })
})();
