(function () {
    'use strict';
    angular.module('easyorder.billing.payment.v1.menu', [])
    .controller('BillingPaymentMenuCtrl', function ($scope,
            $q,
            $state,
            $stateParams,
            CartService,
            AlertService,
            UtilService) {

        /**
         *
         */
        $scope.documentRead = () => {
            var promise = $q.resolve();

            if (CartService.hasItems()) {
                promise = cancelOperation();
            }
            promise
            .then(() => {
                const transitionParams = {
                    flowHistory: {
                        flow: [$state.current.name],
                        params: [$stateParams]
                    }
                };
                UtilService.navigateWithoutHistory("easyorder.billingpaymentdocumentsearch", transitionParams);
            });
        };
        /**
         *
         */
        $scope.barcodeRead = () => {
            var promise = $q.resolve();

            if (CartService.hasItems()) {
                promise = cancelOperation();
            }
            promise
            .then(() => {
                const transitionParams = {
                    flowHistory: {
                        flow: [$state.current.name],
                        params: [$stateParams]
                    }
                };
                UtilService.navigateWithoutHistory("easyorder.billingpaymentscannedsearch", transitionParams);
            });
        }
        /**
         *
         */
        $scope.cardRead = () => {
            var promise = $q.resolve();

            if (CartService.hasItems()) {
                promise = cancelOperation();
            }
            promise
            .then(() => {
                const transitionParams = {
                    flowHistory: {
                        flow: [$state.current.name],
                        params: [$stateParams]
                    }
                };
                UtilService.navigateWithoutHistory("easyorder.billingpaymentchipsearch", transitionParams);
            });
        }

        $scope.goBack = () => {
            UtilService.navigateWithoutHistory("easyorder.operations");
        };

        var cancelOperation = () => {
            return AlertService.confirm('Deseja encerrar a venda atual?')
            .then(function(result) {
               if (result) {
                   CartService.initCart();
                   return $q.resolve();
               } else {
                   return $q.reject();
               }
           });
        };
    });
})();
