(function () {
    'use strict';
    angular.module('easyorder.billing.payment.v1.processor.filter', [])
    .controller('BillingPaymentProcessorFilterCtrl', function ($scope,
            $state,
            $stateParams,
            UtilService,
            BillingPaymentService) {
        
        /**
         * 
         */
        $scope.goBack = () => {
            if ($stateParams.flowHistory) {
                const backState = $stateParams.flowHistory.flow.pop();
                const params = $stateParams.flowHistory.params.pop();
                
                UtilService.navigateWithoutHistory(backState, params);
            }
        };
        
        /**
         *
         */
        $scope.conductorRead = () => {
            processChoice(BillingPaymentService.SEARCH_TYPE_PROCESSOR_CONDUCTOR);
        };
        
        /**
         *
         */
        $scope.totvscardRead = () => {
            processChoice(BillingPaymentService.SEARCH_TYPE_PROCESSOR_TOTVS);
        };
        
        /**
         *
         */
        function processChoice(processorCode) {
            $stateParams.flowHistory.flow.push($state.current.name);
            $stateParams.flowHistory.params.push($stateParams);
            
            const transitionParams = {
                flowHistory: $stateParams.flowHistory,
                searchData: $stateParams.searchData
            };
            transitionParams.searchData.processorFilter = processorCode;
            
            let next = 'easyorder.billingpaymentlist';
            let simpleTypeFound = evaluateSingleTypeForProcessor(processorCode);

            if (!simpleTypeFound) {
                next = 'easyorder.billingpaymenttypefilter';        
            } else if (simpleTypeFound == 'contract') {
                transitionParams.searchData.typeFilter = BillingPaymentService.SEARCH_TYPE_CREDIT_BOOK;
            } else {
                transitionParams.searchData.typeFilter = BillingPaymentService.SEARCH_TYPE_CARD_STATEMENT;
            }
            UtilService.navigateWithoutHistory(next, transitionParams);
        }
        
        /**
         *
         */
        function evaluateSingleTypeForProcessor(processor) {
            let hasContracts =  !!$stateParams.searchData.data.contracts.filter(c => c.processorCode === processor).length;
            let hasCardStatements = !!$stateParams.searchData.data.cardStatements.filter(c => c.processorCode === processor).length;
            
            if (hasCardStatements ^ hasContracts) {
                return hasContracts ? 'contract' : 'cardStatement';
            }
            return undefined;
        }
    });
})();