(function () {
    'use strict';
    angular.module('easyorder.billing.payment.v1.type.filter', [])
    .controller('BillingPaymentTypeFilterCtrl', function ($scope,
            $state,
            $stateParams,
            UtilService,
            BillingPaymentService) {
        
        /**
         * 
         */
        $scope.goBack = () => {
            if ($stateParams.flowHistory) {
                const backState = $stateParams.flowHistory.flow.pop();
                const params = $stateParams.flowHistory.params.pop();
                
                UtilService.navigateWithoutHistory(backState, params);
            }
        };
        
        /**
         *
         */
        $scope.creditBookRead = () => {
            $stateParams.flowHistory.flow.push($state.current.name);
            $stateParams.flowHistory.params.push($stateParams);
            
            const transitionParams = {
                flowHistory: $stateParams.flowHistory,
                searchData: $stateParams.searchData
            };
            transitionParams.searchData.typeFilter = BillingPaymentService.SEARCH_TYPE_CREDIT_BOOK;

            UtilService.navigateWithoutHistory('easyorder.billingpaymentlist', transitionParams);
        };
        
        /**
         *
         */
        $scope.cardStatementdRead = () => {
            $stateParams.flowHistory.flow.push($state.current.name);
            $stateParams.flowHistory.params.push($stateParams);
            
            const transitionParams = {
                flowHistory: $stateParams.flowHistory,
                searchData: $stateParams.searchData
            };
            transitionParams.searchData.typeFilter = BillingPaymentService.SEARCH_TYPE_CARD_STATEMENT;

            UtilService.navigateWithoutHistory('easyorder.billingpaymentcardstatementlist', transitionParams);
        };    
    });
})();