(function () {
    'use strict';
    angular.module('easyorder.controllers.covenantidentification', [
        'easyorder.services.cart'
    ])
    .controller('covenantidentificationCtrl', function ($scope,
                                                            $ionicLoading,
                                                            $stateParams,
                                                            AlertService,
                                                            UserService,
                                                            UtilService,
                                                            $ionicPopup,
                                                            CovenantService) {
        /**
         * 
         */
        $scope.authCovenant = function(){
            $ionicLoading.show({
                template : 'Por favor, aguarde...',
                duration : 0
            }).then(function() {
                var error = function(error) {
                    $ionicLoading.hide();
                    AlertService.restError(error, "Não foi possível autorizar cliente no convênio")
                };
                var params = {
                    operatorCode  : UserService.operatorCode(),
                    userLogin     : $scope.covenant.covenantAuth.userLogin,
                    userPassword  : $scope.covenant.covenantAuth.userPassword,
                    covenantCode  : $scope.covenant.code
                };
                var detailsButtons = [
                    {text: 'Cancelar', type: 'button-stable', onTap: function(e) {
                        UtilService.navigateWithoutHistory('easyorder.covenant');
                        return false; 
                    }},
                    {text: 'Selecionar', type: 'button-theme',
                        onTap: function(e) {
                            CovenantService.currentCovenant($scope.covenant);
                            $scope.popupDetailsCovenant.close();
                            UtilService.navigateToMainScreen();
                        }
                    }
                ];
                
                CovenantService.covenantAuthUser(params, function(result) {
                    if (result) {
                        $scope.covenant.covenantAuth.userName        = result.userName;
                        $scope.covenant.covenantAuth.availableCredit = result.availableCredit;
                        $scope.covenant.covenantAuth.creditLimit     = result.creditLimit;
                        $scope.covenant.covenantAuth.cardNumber      = result.cardNumber;
                        
                        $ionicLoading.hide();
                        
                        $scope.popupDetailsCovenant = $ionicPopup.show({
                            title: 'Convênio',
                            templateUrl: './partials/customerCovenantDetails.html',
                            subTitle: '',
                            scope: $scope,
                            buttons: detailsButtons
                        });
                    } else {
                        error();
                    }
                }, error);
            });
        };
        
        /**
         * 
         */
        $scope.pagePasswordCovenant = function() { 
            if ($scope.covenant) {
                if ($scope.askPassword) {
                    UtilService.navigateWithoutHistory('easyorder.covenantpassword', {"covenant": $scope.covenant});
                } else {
                    $scope.authCovenant();
                }
            } else {
                UtilService.navigateToMainScreen();
            }
        };
        
        (function() {
            $scope.covenant = $stateParams.covenant;
            $scope.covenant.covenantAuth = {};
            $scope.askPassword = $scope.covenant.paymentCovenant; //TODO: Parametrizar a solicitacao de senha para Covênios que nao podem ser usados como pagamento.
        })();
    });
})();