(function () {
    'use strict';
    angular.module('easyorder.controllers.covenantpassword', [
        'easyorder.services.covenant',
        'easyorder.services.cart',
        'easyorder.services.user',
    ]).controller('covenantpasswordCtrl', function ($scope,
                                                        $ionicLoading,
                                                        $stateParams,
                                                        $ionicPopup,          
                                                        ConfigService,
                                                        UtilService,
                                                        AlertService,
                                                        CovenantService,
                                                        CartService,
                                                        UserService) {
        /**
         * 
         */
        $scope.authCovenant = function(){
            $ionicLoading.show({
                template : 'Por favor, aguarde...',
                duration : 0
            }).then(function() {

                const error = (error) => {          
                    $ionicLoading.hide();
                    AlertService.restError(error, "Não foi possível autorizar cliente no convênio").then(() =>{
                        UtilService.navigateWithoutHistory("easyorder.covenantidentification", {"covenant":  $scope.covenant});
                    });
                };
                var params = {
                    "operatorCode"  : UserService.operatorCode(),
                    "userLogin"     : $scope.covenant.covenantAuth.userLogin,
                    "userPassword"  : $scope.covenant.covenantAuth.userPassword,
                    "covenantCode"  : $scope.covenant.code
                };
                var detailsButtons = [
                    {text: 'Cancelar', type: 'button-stable', onTap: function(e) {
                        UtilService.navigateWithoutHistory('easyorder.covenant');
                        return false; 
                    }},
                    {text: 'Selecionar', type: 'button-theme',
                        onTap: function(e) {
                            if (CartService.cart.customer) {
                                CartService.cart.customer.covenants = [{covenantCode:params.covenantCode}];
                            } else {
                                CartService.cart.customer = {covenants: [{covenantCode:params.covenantCode}]};
                            }
                            CovenantService.currentCovenant($scope.covenant);
                            $scope.popupDetailsCovenant.close();
                            UtilService.navigateToMainScreen();
                        }
                    }
                ];
                
                CovenantService.covenantAuthUser(params, function(result) {
                    if (result) {
                        $scope.covenant.covenantAuth.userName        = result.userName;
                        $scope.covenant.covenantAuth.availableCredit = result.availableCredit;
                        $scope.covenant.covenantAuth.creditLimit     = result.creditLimit;
                        $scope.covenant.covenantAuth.cardNumber      = result.cardNumber;

                        $ionicLoading.hide();
                        
                        $scope.popupDetailsCovenant = $ionicPopup.show({
                            title: 'Convênio',
                            templateUrl: './partials/customerCovenantDetails.html',
                            subTitle: '',
                            scope: $scope,
                            buttons: detailsButtons
                        });
                    } else {
                        error();
                    }
                }, error);
            });
        };
        
        (function() {
            $scope.covenant = $stateParams.covenant;
        })();
    });
})();