(function () {
    'use strict';

    angular.module('easyorder.controllers.discountrules', [
            'easyorder.services.discountrules',
            'easyorder.services.util'
        ])
        .controller('DiscountRulesCtrl', function (
            $scope,
            DiscountRulesService,
            $stateParams,
            $ionicModal,
            UtilService
        ) {
            $scope.rules = [];

            /**
             * 
             */
            $scope.getRule = function (event, rule, type) {
                if ($scope.item) {
                    UtilService.navigateWithoutHistory('easyorder.includediscounts', {
                        "discountData": {
                            "rule": rule,
                            "type": (!type) ? $scope.rules.description : type,
                            "item": $scope.item
                        }
                    });
                } else {
                    UtilService.navigateWithoutHistory('easyorder.purchasesummary', {});
                }
            };

            /**
             * 
             */
            $scope.openModal = function () {
                $scope.modal.show();
            };

            /**
             * 
             */
            $scope.closeModal = function () {
                $scope.modal.hide();
            };

            /**
             * 
             */
            $scope.$on('$destroy', function () {
                $scope.modal.remove();
            });

            /**
             * 
             */
            $ionicModal.fromTemplateUrl('views/requestauthmodal.html', {
                scope: $scope,
                focusFirstInput: true,
                animation: 'slide-in-up'
            }).then(function (modal) {
                $scope.modal = modal;
            });

            (function () {

                if ($stateParams.item) {
                    $scope.item = $stateParams.item;
                }
                if ($stateParams.discountTypes.discountRules.length > 1) {
                    $scope.rules = $stateParams.discountTypes;
                } else {
                    $scope.getRule(null, $stateParams.discountTypes.discountRules[0], $stateParams.discountTypes.description);
                }

            })();
        });
})();
