(function () {
    'use strict';

    angular.module('easyorder.controllers.discounttypes', [
            'easyorder.services.discounttypes',
            'easyorder.services.util',
            'easyorder.services.log'
        ])
        .controller('DiscountTypesCtrl', function (
            $scope,
            $stateParams,
            UtilService,
            LogService
        ) {

            $scope.discounts = [];

            /**
             * 
             */
            $scope.getType = function (event, discount) {
                UtilService.navigateWithoutHistory('easyorder.productdiscounts', {
                    prevState: null,
                    item: (!$scope.item) ? null : $scope.item,
                    discountResult: null,
                    automatic: $stateParams.automatic,
                    cart: $scope.cart,
                    discountType: discount,
                });
            };

            $scope.nextWithoutDiscounts = function () {
                if($scope.cart){
                    UtilService.navigateWithoutHistory('easyorder.purchasesummary', {});
                }
            };

            (function () {
                let result = $stateParams.result;

                if ($stateParams.item) {
                    $scope.item = $stateParams.item;
                } 
                $scope.cart = $stateParams.cart;
                try {
                    if (result.discountRuleTypes.length > 1) {
                        $scope.discounts = result.discountRuleTypes;
                    } else {

                        if($scope.cart && $stateParams.automatic && result.discountRuleTypes.length == 0){
                            UtilService.navigateWithoutHistory('easyorder.purchasesummary', {});
                        }
                        if (result.discountRuleTypes.length > 0 && result.discountRuleTypes[0].discountRules.length >= 1) {
                            $scope.getType(null, result.discountRuleTypes[0]);
                        } else if (result.discountRuleTypes.length > 0 && result.discountRuleTypes[0].discountRules.length == 0) {
                            $scope.showAlert('O produto não possui descontos disponíveis');
                        }
                    }
                } catch (e) {
                    LogService.error(e);
                }

            })();
        });
})();
