(function () {
    'use strict';
    angular.module('easyorder.controllers.giftcardmenu', [])
        .controller('GiftCardMenuCtrl', function ($scope, ConfigService, AlertService, UtilService, CartService) {
            var giftCardMandatoryCustomerIdentification = ConfigService.config.business.gift_card_mandatory_customer_identification;    
           
            if(giftCardMandatoryCustomerIdentification && CartService.cart.customer == null) {
                AlertService.warn('Deve ser identificado o cliente')
                .then(() => {
                    if (ConfigService.config.business.unified_customer_identification_enabled) {
                        return UtilService.navigateWithoutHistory('easyorder.customer');
                    } else {
                        return UtilService.navigateWithoutHistory('easyorder.customermenu');
                    }
                });
            } 

            $scope.giftCard = function() {
                UtilService.navigateWithoutHistory('easyorder.giftcardsearch');
            }

            $scope.virtualGiftCard = function() {
                UtilService.navigateWithoutHistory('easyorder.giftcardtheme');
            }
    
           /**
            * Todos os tipos de carga de cartão
            */
           var allMethods = [{
               id: "PHYSICAL_CARD",
               handler: $scope.giftCard,
               icon: "fa fa-gift",
               description: "Cartão de presente"
           }, {
               id: "VIRTUAL_CARD",
               handler: $scope.virtualGiftCard,
               icon: "virtual",
               description: "Cartão de presente virtual"
           }];
           
           /**
            * Filtra os métodos de carga pelo valor do paraâmetro.
            */
           $scope.allowedMethods = (configMethods => {
               return allMethods.filter(m => configMethods.filter(configMethod => configMethod === m.id).length);
           })(ConfigService.config.business.giftcard_recharge_methods);
       });
})();
