(function () {
    'use strict';
    angular.module('easyorder.controllers.giftcardpaymentmenu', [])
    .controller('GiftCardPaymentMenuCtrl', function ($scope,
                                                     $state,
                                                     $stateParams,
                                                     ConfigService,
                                                     UtilService,
                                                     CartService,
                                                     PaymentService,
                                                     $ionicLoading) { 
        
        $scope.goBack = () => {
            if ($stateParams.flowHistory) {
                $ionicLoading.show({
                    template : 'Por favor, aguarde...',
                    duration : 0
                })
                .then(CartService.undoCashbackDiscountPartial)
                .then(CartService.undoFirtsPurchaseDiscount)
                .then(undoPaymentCampaigns)
                .then(() => {
                    const backState = $stateParams.flowHistory.flow.pop();
                    const params = $stateParams.flowHistory.params.pop();
                    UtilService.navigateWithoutHistory(backState, params);
                });

                
            }
        };
        
        $scope.giftCardProvider = ConfigService.config.business.giftcard_service_provider;
        
        async function undoPaymentCampaigns() {
            const campaigns = PaymentService.currentPayment.campaigns;

            if (campaigns && campaigns.length) {
                campaigns.forEach(campaign => {
                    LogService.info(`Desfazendo desconto de campanha por pagamento: ${campaign.codeCampaign}`);
                    CartService.undoCampaignDiscountsPartial(campaign);
                });
            }
        };

        $scope.paymentGiftCard = function () {
            UtilService.navigateWithoutHistory('easyorder.giftcardpayment', { thruTrail: true });
        };

        $scope.paymentTypedGiftCard = function () {
            navigateToState('easyorder.giftcardtypedpayment');
        };

        $scope.paymentScannedGiftCard = () => {
            UtilService.navigate('easyorder.scannedgiftcardpayment');
        };

        function navigateToState(state, params) {
            $stateParams.flowHistory.flow.push($state.current.name);
            $stateParams.flowHistory.params.push($stateParams);
            
            const transitionParams = {
                flowHistory: $stateParams.flowHistory,
            };
            angular.merge(transitionParams, params || {});
            
            UtilService.navigateWithoutHistory(state, transitionParams);
        };
    })
})();
