(function () {
    'use strict';
    angular.module('easyorder.controllers.giftcardtheme', [
        'easyorder.services.util',
        'easyorder.services.config'])
    .directive("imageonload", () => {
        return {
            restrict: "A",
            link: function(scope, element, attrs) {
                element.bind("load", () => {
                    scope.$apply(attrs.imageonload);
                }).bind('error', () => {
                    scope.$apply(attrs.imageonload);
                });
            }
        }
    })
    .controller('GiftCardThemeCtrl', function ($scope, $q, $ionicLoading, GiftCardService, ConfigService, UtilService, AlertService) {
        /**
         *
         */
        $scope.goNext = function() {
            const selectedTheme = $scope.data.layouts[$scope.data.currentPage];
            $scope.giftCard.imageRef = selectedTheme.reference;
            
            UtilService.navigateWithoutHistory('easyorder.giftcardaddvalue', { giftCard: $scope.giftCard });
        };
        
        /**
         * 
         */
        $scope.imageLoaded = function(layout) {
            layout.loading.resolve();
        };

        
        (function() {
            $scope.giftCard = {};
            $scope.readyState = false; //Inicilaiza em modo "carregando".
            $scope.data = {};
            $scope.data.currentPage = 0;
            $scope.data.sliderOptions = {
                initialSlide: 0,
                direction: 'horizontal', //or vertical
                speed: 300 //0.3s transition
            };
            $scope.data.sliderDelegate = null;
            
            $scope.$watch('data.sliderDelegate', function(newVal, oldVal) {
                if (newVal != null) {
                    $scope.data.sliderDelegate.on('slideChangeEnd', function() {
                        $scope.data.currentPage = $scope.data.sliderDelegate.activeIndex;
                        $scope.$apply();
                    });
                }
            });

            $ionicLoading.show({
                template : 'Carregando imagens. Aguarde...',
                duration : 0
            }).then(function() {
                var success = function(response) {
                    $scope.data.layouts = response.layouts;
                    
                    if ($scope.data.layouts && $scope.data.layouts.length) {
                        $scope.readyState = true;
                        
                        var promises = [];
                        
                        for (var i = 0; i < $scope.data.layouts.length; i++) {
                            $scope.data.layouts[i].loading = $q.defer();
                            promises.push($scope.data.layouts[i].loading);
                        }
                        $scope.data.allLoadingPromises = $q.all(promises);
                        $scope.data.allLoadingPromises.then(() => $ionicLoading.hide()); //Quando todas as imagens forem resolvidas, fechar mensagem.
                    } else {
                        AlertService.restError(response, 'Imagens de Cartão Presente virtual não encontradas.')
                            .then(() => UtilService.navigateWithoutHistory('easyorder.giftcardmenu'));
                    }
                };
                var error = function(response) {
                    $ionicLoading.hide();
                    
                    AlertService.restError(response, 'Não foi possível ao recarregar imagens de Cartão Presente virtual.')
                        .then(() => UtilService.navigateWithoutHistory('easyorder.giftcardmenu'));
                };
                GiftCardService.queryVirtualCardLayouts().then(success, error);
            });
        })();
    })
})();
