(function() {
    'use strict';

	angular.module('easyorder.controllers.mobilerechargeoptions', [
    'easyorder.services.mobilerecharge',
    'easyorder.services.config',
    'easyorder.services.cart',
    'easyorder.services.util',
    'easyorder.services.alert',
    'easyorder.services.log'
    ])

	.controller('MobileRechargeOptionsCtrl', function($scope,
                                       MobileRechargeService,
                                       UtilService,
                                       AlertService,
                                       LogService) {

        $scope.selectMobileRechargeOption = function(mobileRechargeOption) {
            UtilService.navigateWithoutHistory('easyorder.mobilerechargephonenumber', { mobileRechargeOption : mobileRechargeOption });
        };
        
        /**
        *
        */
       (function() {
           $scope.loadingState = true;

           MobileRechargeService.searchOptions().then(result => { 
            $scope.loadingState = false;
            if (!result || !result.data || !result.data.mobileRechargeOptions || result.data.mobileRechargeOptions.length === 0) {
                AlertService.warn('Não existem opções de recarga disponíveis.')
                    .finally(function() {
                        UtilService.navigateToMainScreen();
                    });
            } else {
                $scope.mobileRechargeOptions = result.data.mobileRechargeOptions;
            }
           }).catch(error => {
            $scope.loadingState = false;
            LogService.error(error);
            AlertService.restError(error, 'Não foi possível obter as opções de recarga disponíveis. ')
                .finally(function() {
                    UtilService.navigateToMainScreen();
                });
            });

       })();
    });
})();
