(function() {
    'use strict';

    angular.module('easyorder.controllers.order.doc.search', [])

    .controller('OrderDocumentSearchCtrl', function($scope,
                                                    $state,
                                                    $stateParams,
                                                    UtilService,
                                                    AlertService) {

        $scope.searchOrder = {};
        
        /**
         * 
         */
        $scope.goBack = () => {
            if ($stateParams.flowHistory) {
                const backState = $stateParams.flowHistory.flow.pop();
                const params = $stateParams.flowHistory.params.pop();
                
                UtilService.navigateWithoutHistory(backState, params);
            }
        };
        
        /**
         *
         */
        $scope.validateDocument = () => {
            var document = $scope.searchOrder.document;
            $scope.documentInvalid = false;
        
            if (document) {
                if (document.length == 11 && !validaCPF(document)) {
                    $scope.documentInvalid = true;
                    AlertService.warn("CPF inválido");
                }
            }
        };
        
        /**
         *
         */
        $scope.doSearch = () => {
            $stateParams.flowHistory.flow.push($state.current.name);
            $stateParams.flowHistory.params.push($stateParams);
            
            const transitionParams = {
                flowHistory: $stateParams.flowHistory,
                orderCustomerDocument: $scope.searchOrder.document
            }
            UtilService.navigateWithoutHistory('easyorder.order-search-list', transitionParams);
        };     
    });
})();