(function () {
    'use strict';

    angular.module('easyorder.controllers.paymentlinkcustomerconfirmation', [
    ]).controller('PaymentlinkCustomerConfirmationCtrl', function (
		$scope,
        $rootScope,
        $interval,
		CartService,
		MessagingService,
		UtilService,
		AlertService,
        ConfigService
    ) {

		const self = this;
        $scope.meanOfSendingMessages =
			ConfigService
				.config
				.business.payment_link_send_methods.filter(
					item => item == 'WHATSAPP' || item == 'SMS'
				);
        $scope.paymentLinkSettings = CartService.cart.paymentLinkSettings;


		$scope.confirmMeansOfSendingMessages = () => {
			const phone = $scope.paymentLinkSettings.messageReceiverCustomer.phoneNumber;
			if (!isPhoneNumberValid(phone)) {
				return AlertService.warn('Telefone inválido')
			}
			CartService.cart.paymentLinkSettings = $scope.paymentLinkSettings;
			return UtilService.navigate('easyorder.paymentlink');
		}

		function isPhoneNumberValid(phone) {
			return MessagingService.isPhoneNumberValid(phone);
		}

        $scope.goBack = () => {
            UtilService.navigateWithoutHistory('easyorder.paymentmethods');
		}
    });
})();
