(function() {
    'use strict';

    angular.module('easyorder.controllers.paymentresult', [
        'easyorder.services.printer',
        'easyorder.services.alert',
        'easyorder.components.document.slides',
        'easyorder.components.button-float',
        'easyorder.services.prescriptions',
        'easyorder.components.document.slides',
        'easyorder.services.financial',
        'easyorder.services.log',
        "angular-uuid"
    ])

    .controller('PaymentresultCtrl', function($rootScope,
                                        $scope,
                                        $ionicLoading,
                                        $ionicModal,
                                        $q,
                                        $timeout,
                                        UtilService,
                                        CartService,
                                        PrinterService,
                                        NFCeService,
                                        ConfigService,
                                        PaymentService,
                                        AlertService,
                                        MailService,
                                        UserService,
                                        GiftCardService,
                                        CustomerService,
                                        ServiceSaleService,
                                        PrescriptionsService,
                                        FinancialService,
                                        MobileRechargeService,
                                        LogService,
                                        EFTService,
                                        uuid) {

        $scope.newOrderActionText = ($rootScope.externallyLoadedApp ? "Sair" : $scope.NEW_ORDER);
        //Parametro refernte a permissão de impressão da Nota
        $scope.printingEnabled = ConfigService.config.business.printing_enabled;
	    const documents = new Array();
        $scope.sendMailEnabled = ConfigService.config.business.send_mail_enabled;
        
        $scope.percentButtonMail = function(){
            if ($scope.sendMailEnabled){
                if ($scope.printingEnabled){
                    return "27%";
                }else{
                    return "9%";
                }
            }
        };
        // Modal de busca de produtos
		$ionicModal.fromTemplateUrl('views/sendmailorder.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modalMail) {
			$scope.modalMail = modalMail;
        });

        $scope.$on('$destroy', function() {
            if ($scope.modal){
                $scope.modal.remove();
            }

            if ($scope.modalMail){
                $scope.modalMail.remove();
            }
        });

        $ionicModal.fromTemplateUrl('views/printerslist.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.modal = modal;
        });

        $scope.openModal = function() {
            $scope.modal.show();
        };

        $scope.openModalMail = function() {
            $scope.modalMail.show();
        };
        $scope.closeModal = function() {
            $scope.modal.hide();
            $scope.printersSearchResult = [];
            $scope.pluginPrinters = [];
            $scope.wsPrinters = [];
        };

        $scope.$on('$destroy', function() {
            $scope.modal.remove();
        });

        $scope.closeModalMail = function() {
            $scope.modalMail.hide();
        };

        /**
         *
         */
        $ionicModal.fromTemplateUrl('views/printerslist.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.modal = modal;
        });

        /**
         *
         */
        $scope.loadNFCePDF = function(danfeBase64, printData) {
            const printContentsMap = mapByTitle(printData);
            for(var contents of printContentsMap) {
                var pdf = contents[1][0].base64PDF;
                documents.push(createPDF(pdf  !== undefined ? pdf : danfeBase64, contents[1]));
            }
            LogService.info("Geração do PDF da NFCE concluída...");
        };

        $scope.loadIntegrationPDF = function(printData) {
            const printContentsMap = mapByTitle(printData);
            for(var contents of printContentsMap) {
                var pdf = contents[1][0].base64PDF;
                if (pdf == null) continue;
                documents.push(createPDF(pdf, contents[1]));
            }
            LogService.info("Geração do PDF da Integração concluída...");
        };

        function mapByTitle(printData) {
            var printContentsMap = new Map();
            printData.forEach(data => {                
                if(printContentsMap.has(data.documentTitle)) {
                    printContentsMap.get(data.documentTitle).push(new PrintContent(data.documentTitle, data.paperType, data.base64PrintData, data.base64PDF));
                } else {
                    printContentsMap.set(data.documentTitle, [new PrintContent(data.documentTitle, data.paperType, data.base64PrintData, data.base64PDF)]);
                }
            });
            return printContentsMap;
        }

        function createPDF(base64, printContents) {
            let pdf;
            try {
                pdf = new PaymentResultPDF(base64, printContents);
            } catch(err) {
                LogService.error(err instanceof Error ? err.stack : err);
                LogService.error(`failed to parse pdf base64:\n${base64}`);
                pdf = new IncompletePDF(base64, printContents);
            }
            return pdf;
        }

       /**
        *
        */
       var createNewOrder = function() {
           CartService.initCart();
           UtilService.navigateToMainScreen();
       };

        const confirmAppExit = () => {
           var confirmPopup = AlertService.confirm('Deseja sair da aplicação?');

           confirmPopup.then(function(result) {
               if (result) {
                   $rootScope.exitApp();
               }
           });
       };

       /**
        *
        */
       const confirmNewOrder = () => {
           var confirmPopup = AlertService.confirm('Deseja iniciar ' + ($scope.isModoPedido ? 'novo pedido?' : 'nova venda?'));

           confirmPopup.then(function(result) {
               if (result) {
                    createNewOrder();
               }
           });
       };

        $scope.doNewOrderAction = function() {
			if ($rootScope.externallyLoadedApp) {
				confirmAppExit();
			} else {
				confirmNewOrder();
			}
        };

        $scope.doSendMailAction = function(){
            if ($scope.sendMailEnabled && $scope.documents){
                $scope.attachmentContent = [];
                $scope.mails = [];
                $scope.textMail = {
                    value: ""
                };
                var customer = CartService.cart.customer;
                if (customer && customer.email){
                    $scope.mails.push(customer.email);
                }
                for (var i = 0; i < documents.length; i++){
                    var doc = documents[i];
                    if (doc instanceof PDF || doc instanceof IncompletePDF) {
                        $scope.attachmentContent.push(new Attachment(doc.base64, doc.printContents[0].title + ".pdf"));
                    }
                }
                $scope.openModalMail();
            }
        };

        $scope.sendMail = function(){
            $scope.useDestinationInputValue();
            if ($scope.mails && $scope.mails.length > 0) {
                $ionicLoading.show({
                    template : 'Aguarde... Enviando comprovantes',
                    duration : 0
                }).then(function() {
                    const mailRequest = new MailRequest();
                    

                    if ($scope.nfceAuthResponse) {
                        mailRequest.type = MailRequest.TYPES.NFCE;

                        let document = $scope.nfceAuthResponse.nfceResponse;
                        mailRequest.protocolNumber = document.nProt;
                        mailRequest.docURL = document.xUrlDanfe;
                        mailRequest.number = document.numeroNotaAutorizada;
                        mailRequest.docDate = document.dhRetorno;

                        mailRequest.terminalNumber = ConfigService.config.terminalNumber;
                        mailRequest.nsu = CartService.cart.nsu;
                        mailRequest.storeNumber = ConfigService.config.storeNumber;
                    } else {
                        mailRequest.type = MailRequest.TYPES.SERVICE;
                    }
                    mailRequest.attachmentContent = $scope.attachmentContent;
                    mailRequest.destinations = $scope.mails;

                    MailService.send(mailRequest, () => {
                        $ionicLoading.hide();
                        AlertService.info('Email enviado!').then(() => {
                            $scope.doNewOrderAction();
                        });
                    }, error => {
                        LogService.error(error);
                        $ionicLoading.hide();
                        AlertService.info('Ocorreu um erro ao tentar enviar comprovante por email!');
                    });

                }, error => {
                    LogService.error(error);
                    $ionicLoading.hide();
                    AlertService.info('Ocorreu um erro ao tentar enviar comprovante por email!');
                });
            } else {
                AlertService.error('Informe ao menos um e-mail válido para o envio');
            }
        };
        
        $scope.useDestinationInputValue = function() {
            if ($scope.textMail.value && $scope.textMail.value !== "") {
                LogService.info("Adicionando e-mail informado no input à lista de destino");
                $scope.addMail($scope.textMail.value);
            }
        }

        $scope.addMail = function(mail){
            var validador = /[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?/gi;
            if (validador.test(mail)){
                if (!$scope.mails.includes(mail)){
                    $scope.mails.push(mail);
                     $scope.textMail.value = "";
                }else{
                    AlertService.error("Endereço de email já inserido!");
                }
            } else{
                AlertService.error("Endereço de email inválido!");
            }
        };

        $scope.removeMail = function(mail){
            var index = $scope.mails.indexOf(mail);
            if (index !== -1) $scope.mails.splice(index, 1);
        };

        /**
         *
         */
        $scope.doPrint = function(params, printer, printingDoc) {
            var error = function(error) {
                $scope.loadingState = false;
                $ionicLoading.hide();

                AlertService.restError(error, 'Erro no envio da impressão');
                LogService.error('Erro no envio da impressão: ', error);
            }

            PrinterService.submit(params)
                .then(() => {
                    $ionicLoading.hide();
                    $scope.loadingState = false;
                    printingDoc.printed = true;

                    const message = "Documento impresso na impressora: [" + printer.name + "]";

                    const allDocumentsPrinted = $scope.documents.every(doc => doc.printed);
                    const okText = $rootScope.externallyLoadedApp && allDocumentsPrinted ? "Sair" : "OK";
                    const alertPopup = AlertService.info(message, okText);

                    alertPopup.then(function(res) {
                        $scope.closeModal();
                        if (allDocumentsPrinted && $scope.redirectsWhenPrinting) {
                            if ($rootScope.externallyLoadedApp) {
                                $rootScope.exitApp();
                            } else {
                                createNewOrder();
                            }
                        }
                    });
                })
                .catch(error);
        };

        /**
         * Função envio de impressão da NFC-e.
         */
        $scope.print = function(printer, printingDoc) {
            $ionicLoading.show({
                template : 'Imprimindo...',
                duration : 0
            }).then(function() {
                const paperType = printer.paperType;
                const printContents = printingDoc.printContents;
                const printContent = printContents.find(printContent => {
                    return paperType === printContent.paperType;
                });

                var params = {
                    'printerid':    printer.id,
                    'contentType':  printer.paperType === 'A_SERIES' ? 'application/pdf' : 'application/vnd.linx.printer-text',
                    'content':      printContent.data,
                    'title':        printContent.title,
                    'terminal':     ConfigService.config.terminalNumber,
                    'origin':       printer.origin,
                    'paperType':    printer.paperType
                };
                $scope.doPrint(params, printer, printingDoc);
            });
        };

        /**
         * Função para busca de impressoras com status de 'ONLINE'.
         */
        $scope.loadPrinters = function(doc) {
            $ionicLoading.show({
                template : 'Consultando impressoras...',
                duration : 0
            }).then(function() {
                var error = function(error) {
                    $scope.loadingState = false;
                    $ionicLoading.hide();

                    AlertService.restError(error, 'Não foi possível obter impressoras disponíveis!');
                }

                var searchParams = {
                    connection_status: 'ONLINE'
                }

                PrinterService.search(searchParams)
                    .then(printers => {
                        $scope.printersSearchResult =  [];
                        $scope.pluginPrinters = [];
                        $scope.wsPrinters = [];
                        $ionicLoading.hide();
                        $scope.loadingState = false;

                        const printingContents = doc.printContents;
                        const supportedPrinters = printers.filter(printer => printerFilter(printer, printingContents));

                        const pluginPrinters = printers.filter(printer => printer.origin == PrinterService.ORIGIN_PLUGIN);
                        const wsPrinters = printers.filter(printer => printer.origin == PrinterService.ORIGIN_WS);

                        if (supportedPrinters.length == 1) {
                            $scope.printingDoc = doc;
                            $scope.printersSearchResult = supportedPrinters;
                            $scope.pluginPrinters = pluginPrinters;
                            $scope.wsPrinters = wsPrinters;

                            $scope.print(supportedPrinters[0], doc);

                        } else if (supportedPrinters.length > 0) {
                            $scope.printingDoc = doc;
                            $scope.printersSearchResult = supportedPrinters;
                            $scope.pluginPrinters = pluginPrinters;
                            $scope.wsPrinters = wsPrinters;
                            $scope.modal.show(); // lists the printers
                        } else {
                            error({
                                data : {
                                    message : "Nenhuma impressora disponível para o documento escolhido!"
                                }
                            });
                        }
                })
                .catch(error);
            });
        };

        /**
         *
         */
        function printerFilter(printer, printContents) {
            const length = printContents.length;

            for (let i = 0; i < length; ++i) {
                if (printer.paperType === printContents[i].paperType) {
                    return true;
                }
            }
            return false;
        }

        /**
         *
         */
        var processServiceOperation = function() {
            var appInfo = {
                name : $scope.APP_NAME,
                version : $scope.appVersion
            };

           var error = function(error) {
               $scope.loadingState = false;
               $ionicLoading.hide();
               $scope.waitingNfceProcess = false;
               AlertService.restError(error, 'Erro na confirmação do pagamento do serviço.').finally(() => {
                   $scope.paymentError();
               });
           };

           var serviceOperation = {
               companyNumber: ConfigService.config.companyNumber,
               storeNumber: ConfigService.config.storeNumber,
               terminalNumber: ConfigService.config.terminalNumber,
               operatorCode: UserService.operatorCode(),
               nsu: CartService.cart.nsu,
               serviceItems: CartService.cart.serviceItems,
               payments: JSON.parse(JSON.stringify(CartService.cart.salePayments)),
               totalValue: CartService.cart.totalValue,
               customer: CartService.cart.customer,
               insuranceData: CartService.cart.insuranceData,
               date: new Date().toJSON()
           };

           serviceOperation.payments.forEach(function(payment) {
               payment.type = undefined; // remove o 'tipo', não existente nos pagamentos atuais

               if (payment.installments) {
                   payment.installments.sort(function(a,b) {
                       return a.paymentSequence - b.paymentSequence;
                   });
               }
           }, this);

           var tefProvider = ConfigService.config.tefserver.provider;
           var atomicGiftCardReloadPromises = atomicGiftCardReload(CartService.cart.serviceItems);

           $q.all(atomicGiftCardReloadPromises).then(function() {
               NFCeService.confirmServiceIntegration(serviceOperation, appInfo, tefProvider, function(resp) {
                   LogService.info("Operação de pagamento do serviço efetuada com sucesso.");
                   confirmPayments(() => {
                       const printContents = parsePrintContents(resp.printData);

                       if (resp.pdfDocumentBase64PrintData) {
                           documents.push(createPDF(resp.pdfDocumentBase64PrintData, printContents));
                       } else {
                           documents.push(new DummyDocument(printContents));
                       }

                       initializeDocumentSlides();
                   });
               }, function() {
                   NFCeService.undoServiceIntegration(serviceOperation).finally(function() { error(); })
               });
           }, function(result) {
               NFCeService.undoServiceIntegration(serviceOperation).finally(function() {
                   error({ data : { message : (result.data && result.data.message || 'Não foi possível realizar a recarga do Cartão.') } });
               });
           });
        };

        function showLoading() {
            return $q(resolve => {
                $scope.loadingState = true;
                $ionicLoading.show().then(resolve);
            });
        }

        function hideLoading() {
            return $q(resolve => {
                $scope.loadingState = false;
                $scope.waitingNfceProcess = false;
                $ionicLoading.hide().then(resolve);
            });
        }

        /**
         *
         * Cria um array de promessas para operações sobre a lista de itens de serviço passada.
         * Caso nenhuma operação seja necessária, a função retorna uma promessa já resolvida.
         *
         * @return Array com as promessas ou com uma promessa resolvida.
         */
        var atomicGiftCardReload = function(serviceItems) {
            var atomicReloadPromises = [];

            if (serviceItems) {
                serviceItems.forEach(function(item) {
                    const contextUid = uuid.v4();
                    if (item.operationType === "GIFT_CARD_RELOAD" && !item.nsuNumber) {
                        atomicReloadPromises.push(GiftCardService.atomicReload(item.documentNumber, contextUid, item.value, function(response) {
                            item.operationType = "GIFT_CARD_RELOAD";
                            item.documentNumber = response.cardNumber;
                            item.receiptText = response.receiptText;
                            item.value = response.amount;
                            item.nsuNumber = response.nsuNumber;
                            item.contextUid = contextUid;
                        }));
                    }
                });
            }

            if (atomicReloadPromises.length == 0) {
                var defer = $q.defer(); //Criando.
                defer.resolve(); //Marcando como sucesso.
                atomicReloadPromises.push(defer.promise);
            }
            return atomicReloadPromises;
        };

        /**
         *
         */
        var processFiscalOperation = function() {
            const appInfo = {
                name: $scope.APP_NAME,
                version: $scope.appVersion
            };
            const cart = CartService.cart;

            var cloneCart = JSON.parse(JSON.stringify(cart));

            if(ConfigService.config.business.additional_services){
                cloneCart = ServiceSaleService.prepareServices(cloneCart);
            }

            const mergedOrders = cloneCart.mergedOrders;
            delete cloneCart.mergedOrders;
            delete cloneCart.paymentLinkSettings;

            if (cloneCart.showroomingInfo.searchOption === 'pickup_in_store') {
                delete cloneCart.deliveryAddress;
            }

            const currentOrder = cloneCart.currentOrder;
            const isPickupOrDelivery = (cart && cart.deliveryOption && ( cart.deliveryOption === 'PICK_UP_FROM_WAREHOUSE' || cart.deliveryOption === 'WAREHOUSE_DELIVERY'));

            if (!!cloneCart.genericOrderPaymentsFinancialDocuments && cloneCart.genericOrderPaymentsFinancialDocuments.length > 0) {
                extractFinancialDocuments(cloneCart.genericOrderPaymentsFinancialDocuments);
                delete cloneCart.genericOrderPaymentsFinancialDocuments; //Limpando.
            }

            if (isPickupOrDelivery) {
                // em caso de pickup ou delivery, não emite NFCe/SAT. Apenas integra no ProcTrans e confirma os TEF's.
                const error = function(error) {
                    $scope.loadingState = false;
                    $ionicLoading.hide();
                    $scope.paymentError();

                    AlertService.restError(error, 'Erro na emissão do pedido');
                };

                const orderInfo = {
                    storeNumber: cart.storeNumber,
                    orderNumber: cart.orderNumber,
                    externalOrderCode: cart.externalOrderCode,
                    originSystem: cart.originSystem,
                    orderDate: cart.orderDate,
                    deliveryOption: cart.deliveryOption,
                    footerTextLines: (cart.cupomFooterNote && cart.cupomFooterNote.textLines?cart.cupomFooterNote.textLines:null),
                    sellerName: cart.operatorCode // Não existe o nome do vendedor no 'Order'.
                };

                var inventoryInfo;
                
                if (ConfigService.config.business.enable_reserve_products && cloneCart.fiscalItems.filter(p => (p.itemUuid)).length > 0) {
                    inventoryInfo = {
                        storeNumber : cloneCart.storeNumber,
                        terminalNumber: cloneCart.terminalNumber,
                        orderNumber: CartService.sessionId
                    };
                }

                searchFinancialServiceItems(cloneCart, orderInfo, appInfo)
                    .then(() => integrateNFCe(cloneCart, appInfo, orderInfo, currentOrder, mergedOrders, inventoryInfo, error))
                    .catch(error);
            } else {
                let orderInfo;
                const hasShowrooming = CartService.hasShowrooming();

            	 if (cart.orderRetrieved) {
            	     orderInfo = {
            	             storeNumber: cart.storeNumber,
            	             orderNumber: cart.orderNumber,
            	             externalOrderCode: cart.externalOrderCode,
            	             originSystem: cart.originSystem,
            	             orderDate: cart.orderDate,
            	             deliveryOption: cart.deliveryOption,
            	             footerTextLines: (cart.cupomFooterNote && cart.cupomFooterNote.textLines?cart.cupomFooterNote.textLines:null),
            	             sellerName: cart.operatorCode // Não existe o nome do vendedor no 'Order'.
            	     };
            	 }
                 var error = function(error) {
                     $scope.loadingState = false;
                     $ionicLoading.hide();

                    if (error && error.status && error.status == 422){
                        AlertService.restError(error).finally(() => {
                            PaymentService.cancel(true).finally(function() {
                                UserService.logout(true);
                            });
                        });
                    }else{
                        AlertService.restError(error, 'Erro na geração da NFCe').finally( () => {
                            $scope.paymentError();
                        });
                    }
                     
                 };

                 var freightInfo = undefined;
                 // se existirem ítens de showrooming, ajusta atributos para envio.
                 
                 if (hasShowrooming) {
                	 if (cart.orderRetrieved) {
                		 // se for resgate de pedido showrooming, remove atributos temporários.
                		 for (i = 0; i < cloneCart.fiscalItems.length; i++) {
      						var fiscalItem = cloneCart.fiscalItems[i];

      						if (fiscalItem.showrooming) {
      	                        fiscalItem.showrooming = undefined;
      						}
                		 }
                	 } else {
                	     // se tiver criando pedido de showrooming, usa a cotação de frete
                	     var freightSelected = cloneCart.showroomingInfo.freightSelected;
                	     // se tiver showrooming, usa a cotação de frete
                	     var isShipment = (freightSelected.type === 'SHIPMENT');

                	     // ajusta sequencial e dados do delivery
                	     var i;
                	     for (i = 0; i < cloneCart.fiscalItems.length; i++) {
                	         var fiscalItem = cloneCart.fiscalItems[i];

                	         if (!fiscalItem.sequenceId) {
                	             fiscalItem.sequenceId = i + 1;
                	         }
                	         if (fiscalItem.showrooming) {
                	             fiscalItem.deliveryOption = (isShipment ? 'WAREHOUSE_DELIVERY' : 'PICK_UP_IN_STORE');
                	             fiscalItem.showrooming = undefined;
                	         } else {
                	             fiscalItem.deliveryOption = 'SOLD_IN_STORE';
                	         }
                	     }

                	     // cria a cotação de frete escolhida
                	     freightInfo = {
                	         quoteId: freightSelected.quoteId,
 			                 freightQuotes : [{
 			                     groupId: freightSelected.groupId,
 			                     id: freightSelected.id,
 			                     type: freightSelected.type
 			                 }]
                	     };
                	 }
                 }

                 if (!CartService.hasSoldInStoreItems()) {
                     var error = function(error) {
                         $scope.loadingState = false;
                         $ionicLoading.hide();
                         AlertService.restError(error, 'Erro na integração da venda!').finally( () => {
                             $scope.paymentError();
                         });

                         LogService.error('Erro na integração da venda: ', error);
                         
                     }
                     // se só existirem ítens de showrooming, integra.
                     integrateNFCeShowrooming(cloneCart, appInfo, orderInfo, mergedOrders, freightInfo, currentOrder, error);
                 } else {
                     var inventoryInfo;

                     if (ConfigService.config.business.enable_reserve_products && cloneCart.fiscalItems.filter(p => (p.itemUuid)).length > 0) {
                        inventoryInfo = {
                            storeNumber : cloneCart.storeNumber,
                            terminalNumber: cloneCart.terminalNumber,
                            orderNumber: CartService.sessionId
                        };
                     }
                    searchFinancialServiceItems(cloneCart, orderInfo, appInfo)
                         .then(() => {
                             if ($rootScope.createDANFE && !ConfigService.config.business.ignore_mid_settings) {
                                authNFCe(cloneCart, appInfo, inventoryInfo, orderInfo, freightInfo, currentOrder, mergedOrders, error);
                             } else {
                                 integrateNFCe(cloneCart, appInfo, orderInfo, currentOrder, mergedOrders, inventoryInfo, error);
                             }
                         }).catch(error);
                 }
            }
        };

        function initializeDocumentSlides() {
            showAnyPDF();
            $scope.documents = documents;
        }

        function showAnyPDF() {
            const doc = documents.find(doc => doc instanceof PDF);
            if (doc) {
                $scope.pdf = doc;
                $scope.printDocument = doc;
            } else {
                $scope.printDocument = documents[0];
            }
        }

        function showAutoEmailSentMessage(){
            if($scope.autoEmailEnable && CartService.cart.customer && CartService.cart.customer.email){
                AlertService.info("Comprovantes serão enviados automaticamente ao e-mail cadastrado.");
            }
        }

        /**
         *
         */
        function searchFinancialServiceItems(cart, orderInfo, appInfo) {
            return $q((resolve, reject) => {
                if (cart.orderRetrieved && hasOrderItemExternalProcessingMode(cart.fiscalItems)) {
                    FinancialService.searchFinancialServiceItems(cart, orderInfo, appInfo)
                        .then(ret => {
                            const financialDocuments = ret.data;

                            if (financialDocuments.length > 0) {
                                updateFiscalitemsInsuranceData(cart, financialDocuments);
                                extractFinancialDocuments(financialDocuments);
                            }
                            resolve();
                        })
                        .catch(error => {
                            reject(error);
                        });
                } else {
                    resolve();
                }
            });
        }

        /**
         *
         */
        function hasOrderItemExternalProcessingMode(fiscalItems) {
            const length = fiscalItems.length;

            for (let i = 0; i < length; ++i) {
                if (fiscalItems[i].orderItemExternalProcessingMode) {
                    return true;
                }
            }
            return false;
        }

        /**
         *
         */
        function updateFiscalitemsInsuranceData(cart, financialDocuments) {
            financialDocuments.forEach(financialDocument => {
                const fiscalItem = cart.fiscalItems.find(item => item.sequenceId == financialDocument.sequenceId);

                if (!fiscalItem) {
                    throw new Error("Pedido não possui item com o sequence ID = " + financialDocument.sequenceId);
                }
                fiscalItem.insuranceData = financialDocument.insuranceData;
            });
        }

        /**
         *
         */
        function extractFinancialDocuments(financialDocuments) {
            const financialDocumentsPrintData = ArrayUtil.flatMap(financialDoc => financialDoc.itemPrintData, financialDocuments).map(financialDocumentToPDF);
            documents.push(...financialDocumentsPrintData);
        }

        /**
         *
         */
        function parsePrintContents(receiptPrintData) {
            const length = receiptPrintData.length;
            const printContents = new Array();

            for (let i = 0; i < length; ++i) {
                const title = receiptPrintData[i].documentTitle;
                const paperType = receiptPrintData[i].paperType;
                const data = receiptPrintData[i].base64PrintData;
                printContents.push(new PrintContent(title, paperType, data));
            }
            return printContents;
        }

        /**
         *
         */
        function financialDocumentToPDF(financialDocument) {
            const printContents = parsePrintContents(financialDocument.printData);
            const pdfBase64 = financialDocument.pdfDocumentBase64PrintData;

            return pdfBase64 ? createPDF(pdfBase64, printContents)
                            : new DummyDocument(printContents);
        }

        function integrateNFCe(cart, appInfo, orderInfo, currentOrder, mergedOrders, inventoryInfo, error) {
            NFCeService.integrate(cart, appInfo, orderInfo, null, currentOrder, mergedOrders, inventoryInfo, CartService.params, function(resp) {
                LogService.info("Integração do pedido efetuada com sucesso.");

                confirmPayments(() => {
                    confirmSale(() => {
                            const printContents = parsePrintContents(resp.printData);
                            if (resp.pdfDocumentBase64PrintData) {
                                documents.push(createPDF(resp.pdfDocumentBase64PrintData, printContents));
                            } else {
                                documents.push(new DummyDocument(printContents));
                            }
                            initializeDocumentSlides();
                    });
                });

                
            }, error);
        }

        function confirmPayments(action) {
            return showLoading()
                .then(PaymentService.confirmPayments)
                .then(
                    () => { 
                        CartService.cart.confirmedPayments = true;
                        return hideLoading().then(action);
                    }, // success
                    err => { //error
                        hideLoading()
                            .then(() => LogService.error(err))
                            .then(() => AlertService.confirm(`Falha ao confirmar pagamentos, deseja tentar novamente?`))
                            .then(tryAgain => {
                                if (tryAgain) {
                                    confirmPayments(action);
                                } else {
                                    cancelPayments()
                                        .catch(LogService.error)
                                        .finally(() => UtilService.navigateWithoutHistory('easyorder.cart'));
                                }
                            });                                        
                    }
                );
        }

        function cancelPayments() {
            return showLoading()
                .then(PaymentService.cancel)
                .catch(LogService.error)
                .then(CartService.reloadNSU)
                .then(hideLoading)
                .then(AlertService.alert("Aviso!", "Pagamentos existentes foram desfeitos."));
        }

        function confirmSale(action) {
            return showLoading().then(() =>
                NFCeService.confirm({
                    transactionKey: {
                        storeInfo: {
                            companyNumber: ConfigService.config.companyNumber,
                            storeNumber: ConfigService.config.storeNumber,
                        },
                        date: CartService.cart.date,
                        nsu: CartService.cart.nsu,
                        terminal: ConfigService.config.terminalNumber,
                    }
                })
            )
            .finally(() => hideLoading())
            .then(
                () => action(),
                err => {
                    LogService.error(err);
                    // o serviço de confirmação de venda NUNCA deve falhar, logo neste caso
                    // alertamos como uma falha de rede
                    return AlertService.warn(
                        'Falha de conexão durante a confirmação da venda, procure um ponto com melhor sinal'
                    )
                    .then(() => confirmSale(action));
                }
            );
        }

        /**
         *
         */
        function integrateNFCeShowrooming(cart, appInfo, orderInfo, mergedOrders, freightInfo, currentOrder, error) {
            NFCeService.integrate(cart, appInfo, orderInfo, freightInfo, currentOrder, mergedOrders, null, CartService.params, function(resp) {
                LogService.info("Integração de venda showrooming efetuada com sucesso.");

                confirmPayments(() => {
                    confirmSale(() => {
                            if(cart.prescriptions && cart.prescriptions.length > 0) {
                                cart.prescriptions.forEach((value) => {
                                    PrescriptionsService.confirmation({
                                        code: value.code
                                    }, function (suc) {
                                        LogService.info(suc);
                                    }, function (er) {
                                        LogService.error(er);
                                    })
                                });
                            }

                            const printContents = parsePrintContents(resp.printData);
                            if (resp.pdfDocumentBase64PrintData) {
                                documents.push(createPDF(resp.pdfDocumentBase64PrintData, printContents));
                            } else if (printContents.length > 0) {
                                $scope.loadIntegrationPDF(resp.printData);
                            } else {
                                documents.push(new DummyDocument(printContents));
                            }
                            initializeDocumentSlides();
                    });
                });
            }, error);
        }

        function authNFCe(cart, appInfo, inventoryInfo, orderInfo, freightInfo, currentOrder, mergedOrders, error) {
            NFCeService.auth(cart, appInfo, inventoryInfo, orderInfo, freightInfo, currentOrder, mergedOrders, CartService.params, function(resp) {
                try {
                    $scope.autoEmailEnable = resp.isAutoEmailEnable;
                    var result = resp.nfceResponse;
                    if(CartService.cart.customer && CartService.cart.customer.coupon){
                        var params = {};
                        params.storeNumber = ConfigService.config.storeNumber;
                        params.terminalNumber = ConfigService.config.terminalNumber;
                        params.nsu = CartService.cart.nsu;
                        params.cpf = CartService.cart.customer.document;
                        params.couponCode = CartService.cart.customer.coupon.couponCode;
                        params.value = CartService.cart.customer.coupon.value;

                        CustomerService.confirmCoupon(params, function(response) {
                            LogService.info(response);
                        }, function(err) {
                            LogService.error(err)
                        });
                    }
                    if(cart.prescriptions) {
                        cart.prescriptions.forEach((value)=>{
                            PrescriptionsService.confirmation({
                                code: value.code
                            }, function (suc) {
                                LogService.info(suc);
                            }, function (er) {
                                LogService.error(er);
                            });
                        });
                    }

                    if (result && (result.cStat || result.codSat)
                            && (result.cStat == "100" || result.cStat == "MC015" ||
                            result.cStat == "M0015" || result.codSat == "06000")) {

                        $scope.nfceAuthResponse = resp;

                        LogService.info("NFCe - Chave: [" + result.chNFe + "]");
                        LogService.info("NFCe - Motivo: [" + result.xMotivo + "]");

                        if (result.ultimaNota) {
                            LogService.info("NFCeService - Nota autorizada: [" + result.ultimaNota + "]");

                        } else {
                            LogService.warn("Número de ultima nota não retornada.");
                        }

                        confirmPayments(() => {
                            confirmSale(() => {
                                $scope.loadNFCePDF(result.danfe, resp.printData);
                                initializeDocumentSlides();
                                showAutoEmailSentMessage();
                            });
                        });
                    } else {
                        error({
                            data : {
                                message : result.cStat + " - " + result.xMotivo
                            }
                        });
                    }
                } catch (err) {
                    error({
                        data : {
                            message : err
                        }
                    });
                }
            }, error);
        }

        /**
         *
         */
        $scope.processNFCe = function() {
            if (CartService.getCurrentOperation() === 'SERVICE') {
                 processServiceOperation();
            } else {
                 processFiscalOperation();
            }
         };

        $scope.paymentError = function() {
            AlertService.confirm('Tentar efetivar a venda novamente?').then(function(result) {
                if (result) {
                    $ionicLoading.show({
                        template : 'Por favor, aguarde...',
                        duration : 0
                    }).then(function() {
                        $scope.processNFCe();
                    });
                } else {
                    PaymentService.cancel(true).finally(function() {
                        CartService.reloadNSU();
                        UtilService.navigateWithoutHistory('easyorder.cart');
                    });
                }
            });
        };

        $scope.onDocumentClick = doc => {
            $scope.printDocument = doc;
            if (doc instanceof PDF) {
                $scope.pdf = doc;
            }
        }

        $scope.onPrintDocument = function() {
        	if (ConfigService.config.business.printing_enabled){
        		var document = $scope.printDocument;
        		if (document instanceof PaymentResultPDF || document instanceof DummyDocument) {
        			if (document.printed && $scope.redirectsWhenPrinting) {
        				AlertService.info('Documento já impresso!');
        			} else {
        				$scope.loadPrinters(document);
        			}
        		}
        	}
        };

        $scope.onDocumentHold = doc => {
        	if (ConfigService.config.business.printing_enabled){
        		if (doc instanceof PaymentResultPDF || doc instanceof DummyDocument) {
        			if (doc.printed && $scope.redirectsWhenPrinting) {
        				AlertService.info('Documento já impresso!');
        			} else {
        				$scope.loadPrinters(doc);
        			}
        		}
        	}
        }

        function rechargeDone(mobileRechargeResponse) {
            LogService.info('Recarga efetuada com sucesso!');
            var response = mobileRechargeResponse.data;
            LogService.info(response);

            var receiptTexts = new Array();
            if (response.companyReceipt) {
                receiptTexts.push(response.companyReceipt);
            }
            if (response.customerReceipt) {
                receiptTexts.push(response.customerReceipt);
            }
            var mobileRechargeServiceItem = CartService.cart.serviceItems[0];
            mobileRechargeServiceItem.receiptTexts     = receiptTexts;
            mobileRechargeServiceItem.authorizerCode   =  'LD';
            LogService.info('Item da recarga: ', mobileRechargeServiceItem);
            $scope.processNFCe();          
        }
        
        function rechargeError(error) {
            $scope.waitingNfceProcess = false;
            $ionicLoading.hide();
            var errMsg = error.data.message ? error.data.message + " Pagamentos serão desfeitos!" : "Não foi possível confirmar recarga! Pagamentos serão desfeitos!";

            PaymentService.cancel().finally(function() {
                AlertService.error(errMsg).then(function() {
                    UtilService.navigateWithoutHistory('easyorder.cart');
                });
            });
        } 

        const doMobileRecharge = () => {
            MobileRechargeService.isLWSMode() ? doMobileRechargeLWS() : doMobileRechargeTEF();
        };

        const doMobileRechargeLWS = () => {
            LogService.info('Efetuando a recarga via LWS.');
            var mobileRechargeServiceItem = CartService.cart.serviceItems[0];

            const nsuLastDigit = (ConfigService.nsuControll.currentCartNSU() + "").slice(-1);
            const storeNumber = ("0000" + ConfigService.config.storeNumber).slice(-4);
            const terminalNumber = ("000" + ConfigService.config.terminalNumber).slice(-3);
            // id de transação [pode se repetir]: loja [4], terminal [3], último dígito da nsu [1]
            const transactionId = storeNumber + terminalNumber + nsuLastDigit;
            const mobileRechargeRequest = {
                transactionId: transactionId,
                phoneNumber: mobileRechargeServiceItem.documentNumber,
                amount: mobileRechargeServiceItem.value
            };
            MobileRechargeService.recharge(mobileRechargeRequest).then(rechargeDone).catch(rechargeError);
        };

        const doMobileRechargeTEF = () => {
            LogService.info('Efetuando a recarga via TEF.');
            var mobileRechargeServiceItem = CartService.cart.serviceItems[0];

            EFTService.executeTransaction(
                {
                    transactionType:    EFTService.transactionType.MOBILE_RECHARGE,
                    operatorCode:       UserService.operatorCode(),
                    amount: mobileRechargeServiceItem.value,
                    mobileOperatorCode: 'LD',
                    DDD: mobileRechargeServiceItem.documentNumber.substring(0,2),
                    phoneNumber: mobileRechargeServiceItem.documentNumber.substring(2,11)
                }, {
                    paymentDone: function(paymentResults) {
                        LogService.info('Recarga efetuada com sucesso!');
                        LogService.info(paymentResults);

                        var receiptTexts = new Array();
                        if (paymentResults.ComprovanteEstabelecimento) {
                            receiptTexts.push(paymentResults.ComprovanteEstabelecimento);
                        }
                        if (paymentResults.ComprovanteCliente) {
                            receiptTexts.push(paymentResults.ComprovanteCliente);
                        }

                        mobileRechargeServiceItem.receiptTexts     = receiptTexts;
                        mobileRechargeServiceItem.nsuNumber        = paymentResults.NSURede;
                        mobileRechargeServiceItem.authorizerCode   = paymentResults.CodigoAutorizadora;
                        LogService.info('Item da recarga: ', mobileRechargeServiceItem);
                        PaymentService.pushMobileRecharge({
                            paymentValue: mobileRechargeServiceItem.value,
                            paymentAuthorizationNSU: paymentResults.NSU,
                        });
                        $scope.processNFCe();
                    },
                    paymentError: function(paymentResults) {
                        $scope.waitingNfceProcess = false;
                        $ionicLoading.hide();
                        var errMsg = paymentResults.MensagemErro ? paymentResults.MensagemErro : "Não foi possível confirmar recarga! Pagamentos serão desfeitos!";

                        PaymentService.cancel().finally(function() {
                            AlertService.error(errMsg).then(function() {
                                UtilService.navigateWithoutHistory('easyorder.cart');
                            });
                        });
                    },
                    clearDisplay: function() {
                        $timeout(function() {
                            $scope.message = "";
                        });
                        LogService.info("clearDisplay");
                    },
                    displayMessage: function(message) {
                        if (message) {
                            $timeout(function() {
                                $scope.message = message;
                            });
                        }
                        LogService.info("displayMessage: " + $scope.message);
                    }
                }
            );
        };

        /**
         * Função de inicialização.
         */
        (function() {
            $scope.options = [];
            $scope.waitingNfceProcess   = true;
            $scope.printersSearchResult = [];
            $scope.pluginPrinters = [];
            $scope.wsPrinters = [];
            $scope.redirectsWhenPrinting = ConfigService.config.business.redirects_new_sale_when_printing !== false;

            $scope.onProgress = function(progress) { // Funções do progresso do carregamento da NFCe na tela.
                if (progress.loaded === progress.total) {
                    $scope.waitingNfceProcess = false;
                    $ionicLoading.hide();
                }
            };
            $scope.onError = function(error) {
                LogService.error(error);
                $scope.waitingNfceProcess = false;
                $ionicLoading.hide();
            }
            if (CartService.getCurrentServiceOperationType() === 'MOBILE_RECHARGE') {
                // no caso da recarga, a transação deve ser efetuada após os pagamentos pois não pode ser desfeita.
                doMobileRecharge();
            } else {
                $scope.processNFCe();
            }
        })();
    });
})();

class PrintContent {
    constructor(title, paperType, data, base64PDF) {
        this.title = title;
        this.paperType = paperType;
        this.data = data;
        this.base64PDF = base64PDF;
    }
}

class PDF {
    constructor(base64) {
        const byteCharacters = atob(base64);
        const byteNumbers = new Array(byteCharacters.length);

        for (let i = 0; i < byteCharacters.length; i++) {
            byteNumbers[i] = byteCharacters.charCodeAt(i);
        }

        this.base64 = base64;
        this.data = new Uint8Array(byteNumbers);
        this.type = 'PDF';

    }

    toURL() {
        const blob = new Blob([this.data], {type: 'application/pdf'});

        return URL.createObjectURL(blob);
    }
}

class PaymentResultPDF extends PDF {
    constructor(base64, printContents) {
        super(base64);
        this.printContents = printContents;
        this.printed = false;
    }
}

class DummyDocument {
    constructor(printContents) {
        this.printContents = printContents;
        this.type = 'DUMMY';
        this.printed = false;
    }
}

class IncompletePDF extends DummyDocument {
    constructor(base64, printContents) {
        super(printContents);
        this.base64 = base64;
    }
}
