class BarcodeHandler {
    constructor($injector) {
        if (this.constructor === BarcodeHandler) {
            throw new TypeError('Class "BarcodeHandler" nao pode ser instanciada diretamente.'); 
        }
        this.$q = $injector.get('$q');
    }

    handleBarcode(barcode) {
        throw new Error('Método "handleBarcode" não implementado!');
    }

    extractProductCode(barcode) {
        throw new Error('Método "extractProductCode" não implementado!');
    }

    isCustomBarcode(code) {
        throw new Error('Método "isCustomBarcode" não implementado!');
    }
}

class DefaultBarcodeHandler extends BarcodeHandler {
    constructor($injector) {
        super($injector);
    }

    isCustomBarcode(code) {
        return false;
    }

    extractProductCode(barcode) {
        return barcode;
    }

    handleBarcode(barcode) {
        return this.$q.resolve(barcode);
    }
}