class CeaTag {
    constructor(tag) {
        this._tag = tag;
        this._orderNumber = tag.substr(0, 6);
        this._sku = tag.substr(6, 8);
        this._saleOrder = tag.substr(14, 2);
        this._topBottom = tag.substr(16, 1);
        this._digit = tag.substr(17, 1);
    }

    get orderNumber() {
        return this._orderNumber;
    }

    get sku() {
        return this._sku;
    }

    get saleOrder() {
        return this._saleOrder;
    }

    get topBottom() {
        return this._topBottom;
    }

    get digit() {
        return this._digit;
    }
    
    get fullTag() {
        return this._tag;
    }

    // a etiqueta é identificada unicamente pela junção dos dois campos
    get uniqueId() {
        return this.sku + this.topBottom;
    }
    
    get productCode() {
        // remove os zeros à esquerda
        return ""+ parseInt(this.sku);
    }
    
    isExternal() {
        return this.topBottom === '0';
    }


}