(function () {
    'use strict';
    angular.module('easyorder.controllers.returns.exchange.typed.search', [])
    .controller('TypedExchangeCtrl', function ($scope,
            $state,
            $stateParams,
            AlertService,
            UtilService) {


        $scope.stepper = $stateParams.stepper;

        /**
         *
         */
        $scope.goBack = () => {
            if ($stateParams.flowHistory) {
                const backState = $stateParams.flowHistory.flow.pop();
                const params = $stateParams.flowHistory.params.pop();

                UtilService.navigateWithoutHistory(backState, params);
            }
        };
        /**
         *
         */
        $scope.onSearchResult = (resultPromise) => {
            resultPromise.then(result => {
                if (result.transaction.availableFiscalItems.length) {
                    goNext(result.transaction);
                } else {
                    AlertService.error('A transação consultada não possui itens disponívéis para troca.');
                }
            }, error => {
                AlertService.restError(error, 'Não foi possível consultar transação para troca!');
            });
        };
        /**
         *
         */
         $scope.onSearchResultV3 = (resultPromise) => {
            resultPromise.then(result => {
                if (result.transaction.availableFiscalItems.length) {
                    goNextV3(result.transaction);
                } else {
                    AlertService.error('A transação consultada não possui itens disponívéis para troca.');
                }
            }, error => {
                AlertService.restError(error, 'Não foi possível consultar transação para troca!');
            });
        };

        /**
         *
         */
        function goNext(transaction) {
            var transitionParams = UtilService.cloneDeep($stateParams);

            transitionParams.flowHistory.flow.push($state.current.name);
            transitionParams.flowHistory.params.push($stateParams);
            transitionParams.exchangeData.items = transaction.availableFiscalItems
            .map(item => {
                return {
                    transaction: transaction,
                    item: item,
                    quantity: 1
                };
            });
            UtilService.navigateWithoutHistory('easyorder.exchangetransactionproductlist', transitionParams);
        }
        /**
         *
         */
         function goNextV3(transaction) {
            var transitionParams = UtilService.cloneDeep($stateParams);

            transitionParams.flowHistory.flow.push($state.current.name);
            transitionParams.flowHistory.params.push($stateParams);
            transitionParams.exchangeData.items = transaction.availableFiscalItems
            .map(item => {
                return {
                    transaction: transaction,
                    item: item,
                    quantity: 1
                };
            });
            transitionParams.storeNumber = transaction.key.storeNumber;
            transitionParams.customer = $stateParams.customer;
            UtilService.navigateWithoutHistory('easyorder.exchangetransactionproductlistv3', transitionParams);
        }
    })
})();
