
(function () {
    'use strict';

    angular.module('easyorder.services.installment-plan', [
    ]).service('InstallmentPlanService', function(
        ConfigService,
        $http,
    ) {
        const HTTP = 'http';
        const HTTPS = 'https';

        const SERVICE = 'linx-webservices/v1/installment-plan';

        const AUTH = 'auth';
        const SEARCH_AVAILABLE_CREDIT = "available-credit";

        function url(action) {
            const lws = ConfigService.config.linxwebservices;
            return `${protocol()}://${lws.host}:${lws.port}/${SERVICE}/${action}`;
        }

        function protocol() {
            const lws = ConfigService.config.linxwebservices;
            return lws.secure ? HTTPS : HTTP;
        }

        const service = {
            auth: (request) => {
                return $http.post(url(AUTH), request, {
                    headers: {
                        'Service-Provider': ConfigService.config.business.installment_plan_provider
                    }
                });
            },
            searchAvailableCredit: (request) => {
                return $http.get(url(SEARCH_AVAILABLE_CREDIT), {
                    params: request,
                    headers: {
                        'Service-Provider': ConfigService.config.business.installment_plan_provider
                    }
                });
            }
        };

        return service;
    });
})();
