(function() {
    'use strict';

    angular.module('easyorder.services.audit', ['ngResource'])

    .factory('AuditService', function($http, ConfigService, UserService) {
        
        var service = {};
        
        if (typeof device !== 'undefined') { 
			var platform = device.platform === "Android" ? "ANDROID" : "IOS";
		} else { 
			var platform = "WEB";
		}
        
        service.loadSettings = function() {
            service.url  = ConfigService.config.linxwebservices.secure ? 'https://' : 'http://';
            service.url += ConfigService.config.linxwebservices.host + ':';
            service.url += ConfigService.config.linxwebservices.port;
            service.url += '/linx-webservices';
        };
        
        service.appStarted = function() {
            service.loadSettings();

            return $http.post(`${service.url}/app-started`, {
                platform: platform,
                originSystem: 'CAIXA_RAPIDO',
                ipAddress: window.ionic.ipAddress,
                // a mesma coisa?
                hostAddress: window.ionic.ipAddress
            });
        };
        
        service.expiredSession = function() {
            service.loadSettings();
            
            let params = {
                username: UserService.currentUser.username,
                ipAddress: window.ionic.ipAddress,
                storeNumber: ConfigService.config.storeNumber,
                terminalNumber: ConfigService.config.terminalNumber
            };
            return $http.post(service.url + '/expired-session', params);
        };
        return service;
    });
})();
