(function() {
    "use strict";

    angular.module("easyorder.services.config", [
        "ngResource",
        "ngStorage",
        "ngCordova",
        "easyorder.services.log"
    ])
    .factory("ConfigService", function($rootScope, LogService, $injector, UtilService, $http) {
        var service = {};

        service.device = {
        	lio: false
        };

        service.BaseConfig = function() {
            this.configLoaded = false;
            this.companyNumber = "";
            this.storeNumber = "";
            this.store = "";
            this.terminalNumber = "";
            this.eftStoreNumber = "";
            this.linxwebservices = {
                host: "",
                port: 0,
                secure: true
            };
            this.orderserver = {
                host: "",
                port: 0,
                secure: false
            };
            this.tefserver = {
                host: "",
                port: 0,
                secure: false
            },
            this.theme = "Linx";
            this.business = {
                price_change_behavior:                              'NONE',
                price_change_reasons_list:                          [],
                price_override:                                     false,
                item_multiplication_enabled:                        false,
                payment_plan_enabled:                               false,
                parcials_payment_enabled:                           true,
                displays_interest_installment_amounts:              true,
                payment_plan_display_order:                         'REVERSED_INTS_NUMBER',
                campaign_enabled:                                   false,
                promotion_engine_enabled:                           false,
                giftcard_recharge_methods:                          [],
                product_inventory_enabled:                          false,
                must_reload_customer:                               false,
                product_code_character_type:                        'numeric',
                application_idle_timeout:                           600,
                seller_identification_mode:                         'desativado',
                automatic_seller_identification_enabled:            false,
                allow_item_as_gift:                                 false,
                product_images_enabled:                             false,
                showrooming_enabled:                                false,
                printing_enabled:                                   true,
                allow_generate_order:                               false,
                available_payment_methods:                          ["CREDIT", "DEBIT"],
                payment_methods_with_cashback:                      [],
                barcode_scanning_method:                            "CAMERA",
                voucher_barcode_scanning_method:                    "CAMERA",
                available_exchange_operation_methods:               ["COUPON", "CPF", "COUPONLESS"],
                customer_identification_required_enabled:           true,
                discount_coupon_mode:                               undefined,
                enable_type_nfce:                                   true,
                enable_reserve_products:                            false,
                enable_screen_discount:                             false,
                customer_mandatory_fields:                          "DEFAULT",
                search_orders_return_limited_to:                    30,
                search_orders_return_date_minus:                    0,
                mobile_recharge_enabled:                            false,
                mobile_recharge_mode:                               'TEF',
                sox_enabled:                                        false,
                uuid_enabled:                                       false,
                default_home_screen:                                "Camera",
                check_signin_before_sale:                           false,
                interstate_selling:                                 true,
                send_mail_enabled:                                  false,
                product_code_display_type:                          "AUTOMATION_CODE",
                email_autocomplete_domain_list:                     [],
                request_employee_id_comfirmation:                   false,
                available_payment_methods_names:                    [],
                default_request_timeout:                            60,
                disabled_credit_card_bins:                          [],
                check_permission_manual_discount:                   false,
                enable_customer_crud_by_rest_api:                   false,
                enable_givex_voucher_redirection_request:           false,
                allows_discount_rule_overlap:                       false,
                allow_current_customer_editing:                     false,
                show_marketing_fields:                              false,
                customer_data_marketing_fields:                     null,
                remote_nsu_sync:                                    false,
                mobile_recharge_operators:                          "TIM#LD",
                self_authorizer:                                    true,
                sitef_qr_not_accepted_vouchers:                     undefined,
                apply_charges_on_payment_value:                     false,
                gift_card_mandatory_customer_identification:        false,
                enables_automatic_addition_to_cart:                 false,
                payment_link_send_methods:                          ['WHATSAPP'],
                gui_button_choice_timeout:                          30,
                customer_identification_names:                      [],
                discount_employee_search_enabled:                   false,
                available_billing_payment_methods:                  ["DEBIT"],
                elastic_enabled:                                    false,
                elastic_servers:                                    undefined,
                transaction_search_days_threshold:                  90,
                enables_rfid_reading:                               false,
                enables_exchange_rfid_reading:                      false,
                rfid_reading_power:                                 5,
                rfid_writing_power:                                 5,
                enables_reading_by_rfid_only:                       false,
                enables_exchange_by_rfid_only:                      false,
                epc_enable_prefix:                                  null,
                epc_disable_prefix:                                 null,
                default_product_search_operation:                   "Barcode",
                ignore_mid_settings:                                false,
                minimum_value_for_mandatory_identification:         10000.01,
                item_exclusion_by_sliding:                          true,
                item_exclusion_by_barcode_scanning:                 false,
                order_with_delivery_of_merged_items_allowed:        false,
                sale_by_style:                                      false,
                multiple_orders_enabled:                            false,
                custom_barcode_handler:                             null,
                enable_end_user_license_agreement:                  false,
                payment_link_enable_copy_url_button:                true,
                address_service_provider:                           "SAP",
                paymentlink_service_provider:                       undefined,
                paymentlink_available_payment_methods:              ['CREDIT_CARD'],
                paymentlink_contact_confirmation_enabled:           false,
                voucher:                                            {auto_search_fields:[]},
                redirects_new_sale_when_printing:                   true,
                password_change_enabled:                            false,
                mandatory_fiscal_fields:                            null,
                minimum_value_for_fiscal_identification:            null,
                maximum_sale_value:                                 null,
                fiscal_menu_ufs:                                    null,
                paf_timeout:                                        120,
                payment_link_screen_mode:                           'MANUAL_ORDER_CREATION',
                order_search_screen_operations:                     ['DETAIL_ORDER', 'CANCEL_ORDER'],
                fiscal_cart_order_operations:                       null,
                unallowed_phone_numbers:                            [],
                order_search_reload_customer_behavior:              'V1',
                giftcard_service_provider:                          'GIVEX',
                giftcard_type:                                      null,
                loyalty_provider:                                   null,
                loyalty_enabled:                                    false,
                external_order_number_keyboard_type:                'Alphanumeric',
                use_customer_as_fiscal_customer:                    false,
                paf_file_storage_mode:                              null,
                auto_select_unique_event:                           false,
                product_query_shortcut_on_the_cart_screen_enabled:  false,
                product_remove_shortcut_on_the_cart_screen_enabled: false,
                scan_order_sold_in_store_items:                     false,
                allow_different_customer_on_orders:                 true,
                reprint_options:                                    null,
                enables_control_of_single_items_by_marketing:       false,
                marketing_codes_to_control_the_items_inclusion:     [],
                disable_order_redemption_calculation:               false,
                order_status_filter:                                [],
                biometric_payment_methods:                          null,
                add_fiscal_document_msg:                            'Deseja adicionar CPF na nota?',
                payment_insurance_provider:                         'LREN',
                installment_plan_provider:                          null,
                showrooming_label:                                  'Showrooming',
                promo_voucher_label:                                ['Voucher Promo', 'Vouchers Promo'],
                enable_editing_of_exchange_coupon_quantity:         false,
                interstate_selling_allowed_modes:                   [],
                no_fiscal_identification_marketing_codes:           [],
                skip_fiscal_dialog_when_overlimit:                  false,
                reprint_max_interval_days:                          null,
                state_registration_error_msg:                       'Inscrição Estadual Inválida',
                showrooming_freight_labels:                         {PICKUP: "Disponível em ${FREIGHT_DAYS} dia(s)",
                                                                     SHIPMENT: "Prazo de ${FREIGHT_DAYS} dia(s)",
                                                                     DEFAULT: "Prazo de ${FREIGHT_DAYS} dia(s)"},
                enable_imei_iccid_validation:                       false
            };
            this.login = {
                keyboard_type: 'Alphanumeric'
            };
            this.sms_info = {
                order_ready: {
                    sender_id: "",
                    message: ""
                }
            };
            this.payment_plan = {
                search: {
                    // format:
                    // {
                    //   "PAYMENT_METHOD": {
                    //      id: "PROVIDER",
                    //      timeout: TIMEOUT_VALUE
                    //   },
                    //   "PAYMENT_METHOD2": {
                    //      id: "PROVIDER2",
                    //      timeout: TIMEOUT_VALUE
                    //   },
                    // }
                    providers:      {},
                    // same format
                    fb_providers:   {},
                },
            };
        };

        service.SystemData = function() {
        	this.currentLinxWebservicesHost = null;
        };

        if (!service.config) {
            service.config = new service.BaseConfig();
            service.config.linxwebservices.secure = true;
        }

        if (!service.systemData) {
        	service.systemData = new service.SystemData();
        	var linxWsHost = service.config.linxwebservices.host;

        	if (linxWsHost) {
        		LogService.info('Configurando último acesso ao LinxWebservices como host ' + linxWsHost);
        		service.systemData.currentLinxWebservicesHost = linxWsHost;
        	}
        }

        service.NSUControll = function() {
            var nsuStorage = {};

            var resetData = function() {
                LogService.info("Reinicializando contador da NSU...");
                nsuStorage.nsu = 99;
                nsuStorage.cartNsu = nsuStorage.nsu;
                nsuStorage.date = new Date().toISOString();

                $rootScope.dataSourceManager.updateNSUStorage();

                return nsuStorage.nsu;
            };

            this.currentNSU = function() {
                reset();
                return nsuStorage.nsu;
            };

            this.currentCartNSU = () => {
                reset();
                return nsuStorage.cartNsu;
            }

            function reset() {
                const current = moment();
                const stored = moment(nsuStorage.date);

                // não verificamos cartNsu para evitar
                // nsu duplicada na primeira vez que rodar o
                // aplicativo com esta versão
                if (!nsuStorage.nsu || !current.isSame(stored, 'day')) {
                    resetData();
                }
            }

            this.updateStorageNSU = function(nsuStor){
                if (nsuStor) {
                    nsuStorage = nsuStor;
                }
            };

            this.getNSUStorage = function(){
                return nsuStorage;
            };

            this.incrementNSU = function(persist) {
                LogService.info("Incrementando contador da NSU...");
                this.currentNSU();
                const nsu = ++nsuStorage.nsu;

                if (persist == null || persist === true) {
                    $rootScope.dataSourceManager.updateNSUStorage();
                }
                return nsu;
            };

            this.incrementCartNSU = () => {
                const nsu = this.incrementNSU(false);
                nsuStorage.cartNsu = nsu;

                $rootScope.dataSourceManager.updateNSUStorage();

                return nsu;
            };
        };

        service.nsuControll = new service.NSUControll();

        service.isConfigurationLoaded = function() {
        	return (service.config.configLoaded);
        };

        function extractValue(param, numericField, state, defaultValue) {
            var valueByState = param.split(';');

            for (var i = 0; i < valueByState.length; i++) {
                var line = valueByState[i].trim();
                var values = line.split('=');

                if (values.length == 2) {
                    var key = values[0].trim().toUpperCase();
                    var value = values[1].trim();

                    if (key === state) {
                        if (numericField) {
                            if (!UtilService.isNumeric(value)) {
                                LogService.info(`Valor inválido para UF ${key}: ${value}. Utilizando valor default ${defaultValue}.`);
                            } else {
                                return +value;
                            }
                        } else {
                            return value;
                        }


                    }
                }
            }

            return defaultValue;

        }
        function updateFiscalSettings() {
            const currentStoreState = service.config.store && service.config.store.address && service.config.store.address.state ? service.config.store.address.state.toUpperCase() : null;

            // Valor mínimo com identificação fiscal obrigatória. Default = R$10.000,00.
            const minimumValueList = service.config.business.minimum_value_for_fiscal_identification ? service.config.business.minimum_value_for_fiscal_identification : "";
            const minimumValue = extractValue(minimumValueList, true, currentStoreState, 10000);

            // Valor máximo da compra. Default = R$200.000,00.
            const maximumSaleValueList = service.config.business.maximum_sale_value ? service.config.business.maximum_sale_value : "";;
            const maximumSaleValue = extractValue(maximumSaleValueList, true, currentStoreState, 200000);

            // Campos adicionais obrigatórios (além do documento).
            const mandatoryFieldsList = service.config.business.mandatory_fiscal_fields ? service.config.business.mandatory_fiscal_fields : "";
            const mandatoryFields = extractValue(mandatoryFieldsList, false, currentStoreState, '');
            const mandatoryFieldsArray = (mandatoryFields) ? mandatoryFields.toUpperCase().split(',') : [];

            // Menu fiscal
            const fiscalMenuUfsArray = service.config.business.fiscal_menu_ufs ? service.config.business.fiscal_menu_ufs.toUpperCase().split(';') : [];
            const fiscalMenuEnabled = fiscalMenuUfsArray.includes(currentStoreState);

            $rootScope.minimumValueFiscalIdentification = minimumValue;
            $rootScope.maximumSaleValue = maximumSaleValue;
            $rootScope.mandatoryFiscalFields = mandatoryFieldsArray;
            $rootScope.fiscalMenuEnabled = fiscalMenuEnabled;

            LogService.info(`Loja em '${currentStoreState}'. Valor mínimo da compra identificada: ${minimumValue}. Valor máximo da compra: ${maximumSaleValue}. Campos adicionais obrigatórios: '${mandatoryFieldsArray.join(',')}'. Menu fiscal habilitado: ${fiscalMenuEnabled}.`);
        }

        function createCertificateFile() {
            // se usar SSL e for o proprietário da SE, copia o certificado
            // (não é usado por enquanto o serv. de config. pelo tamanho do arquivo e pela inexistência de parâmetros binários)
            if (service.config.tefserver.secure && service.config.tefserver.sslProvider === 'SOFTWARE_EXPRESS') {
                const certificateName = MOZILLA_PEM_FILE;
                $http.get(`certificates/${certificateName}`)
                    .then(function(response) {
                        $rootScope.dataSourceManager.saveCertificateFile(certificateName, response.data)
                            .then(fileName => {
                                LogService.info(`Arquivo do certificado '${fileName}' salvo com sucesso!`);
                            }).catch(error => {
                                LogService.error("Erro ao salvar arquivo do certificado!");
                                LogService.error(error);
                            });
                    })
                    .catch(error => {
                        LogService.error(`Erro ao copiar arquivo do certificado '${certificateName}'!`);
                        LogService.error(error);
                    });
            }
        }

        service.updateAppSettings = function() {
			// atributos usados para se evitar checagens no ConfigService em todos os pontos que utilizem os atributos.
			$rootScope.loginKeyboardType = (service.config.login && service.config.login.keyboard_type && service.config.login.keyboard_type=='Numeric')?$rootScope.platformNumberInputType:'text';
			// campanha está habilitada, exceto se explicitamente tiver o parâmetro setado pra 'false'
			$rootScope.campaignEnabled =  (service.config.business && service.config.business.campaign_enabled === false)?false:true;
            $rootScope.promotionEngine = (service.config.business && service.config.business.promotion_engine_enabled === true);
			// cartão presente está desabilitado, exceto se explicitamente tiver o parâmetro setado pra 'true'
			$rootScope.gifcardRechargeEnabled =  (service.config.business && service.config.business.giftcard_recharge_methods && service.config.business.giftcard_recharge_methods.length);
			// estoque está desabilitado, exceto se explicitamente tiver o parâmetro setado pra 'true'
			$rootScope.productInventoryEnabled =  (service.config.business && service.config.business.product_inventory_enabled === true);
			$rootScope.selectedTheme = service.config.theme;
            // convênios está desabilitado, exceto se explicitamente tiver o parâmetro"
            $rootScope.covenantEnable = (service.config.business && service.config.business.covenant_identification_types && service.config.business.covenant_identification_types.length >= 1);
             // receitas está desabilitado, exceto se explicitamente tiver o parâmetro"
            $rootScope.prescriptionEnable = (service.config.business && service.config.business.prescription === true);
			// busca de imagens desabilitada por padrão
			$rootScope.productImageEnabled = (service.config.business && service.config.business.product_images_enabled === true);
			// showrooming desabilitado por padrão.
            $rootScope.showroomingEnabled = (service.config.business && service.config.business.showrooming_enabled === true);
            // permissão para gerar pedido auto-serviço desabilitado por padrão.
            $rootScope.allowGenerateOrderEnabled = (service.config.business && service.config.business.allow_generate_order === true);
            // cpf na nota está desabilitado, exceto se explicitamente haver o parâmetro"
            $rootScope.cpfInNoteEnabled = (service.config.business && service.config.business.cpf_in_note === true);
            // recarga de celulares está desabilitada, exceto se explicitamente tiver o parâmetro setado pra 'true'
            $rootScope.mobileRechargeEnabled = (service.config.business && service.config.business.mobile_recharge_enabled === true);
            // forma de exibição do código do produto
            $rootScope.productCodeDisplayType = service.config.business.product_code_display_type;
            // Numero do terminal
            $rootScope.terminalNumber = service.config.terminalNumber;
            //
            $rootScope.createDANFE = !(service.config.business && service.config.business.enable_type_nfce === false);

            const operations = service.config.business.operations;
            $rootScope.operations = operations ? operations.split(';') : undefined;
            $rootScope.exchangeOtherStore = service.config.business.exchange_other_store;

            const exchangeMaxDays = service.config.business.exchange_max_days;
            $rootScope.exchangeMaxDays = exchangeMaxDays ? exchangeMaxDays : 1;

            const returnMaxDays = service.config.business.return_max_days;
            $rootScope.returnMaxDays = returnMaxDays ? returnMaxDays : 2;

            const available_reports = service.config.business.available_reports;
            $rootScope.reports = available_reports ? available_reports.split(';') : undefined;

            // O timeout de aplicação não pode ser menor que o da requisição
            const idleTimeout = service.config.business.application_idle_timeout;
            const requestTimeout = service.config.business.default_request_timeout;

            if (idleTimeout < requestTimeout) {
                LogService.info(`Timeout de sessão (${idleTimeout}s) configurado é menor que o de requisição (${requestTimeout}s). Requisição usará o timeout de sessão (${idleTimeout}s).`);
                $rootScope.defaultRequestTimeoutInMillis = idleTimeout * 1000;
            } else {
                $rootScope.defaultRequestTimeoutInMillis = requestTimeout * 1000;
            }

            $rootScope.allowsDiscountRuleOverlap = service.config.business.allows_discount_rule_overlap;
            $rootScope.allowCurrentCustomerEditing = service.config.business.allow_current_customer_editing;
            $rootScope.showMarketingFields = service.config.business.show_marketing_fields;

            $rootScope.customBarcodeHandler = service.config.business.custom_barcode_handler === 'CEA' ? new CeaBarcodeHandler($injector) : new DefaultBarcodeHandler($injector);
            $rootScope.passwordChangeEnabled = service.config.business.password_change_enabled === true;
            $rootScope.productCodeType = service.config.business.product_code_character_type;

            $rootScope.pafTimeout = service.config.business.paf_timeout > 60 ? service.config.business.paf_timeout * 1000: 120000;

            updateFiscalSettings();
            createCertificateFile();
            LogService.reconfigure(service.config);
            LogService.info(`${APP_NAME} reconfigurado - versão: [${$rootScope.appVersion}] - data: [${new Date().toLocaleDateString()}]`);
        };

        service.updateStorage = function(newConfig) {
            for (var key in newConfig) { // Atualizando o storage.
                service.config[key] = newConfig[key];
            }
            for (var key in service.config) { // removendo propriedades que não estão mapeadas;
                if (!newConfig.hasOwnProperty(key)) {
                    delete service.config[key];
                }
            }
            service.systemData.currentLinxWebservicesHost = service.config.linxwebservices.host;
        };
        return service;
    });
})();
