/**
 *
 */
class DataSourceProviderManager {

    constructor($injector) {
        this.provider = ionic.Platform.isAndroid() ?
                new FileDataSourceProvider($injector) : new LocalStorageDataSourceProvider($injector);
    }

    initialize() {
        return this.provider.initialize();
    }

    doDataSourceMigration() {
        return this.provider.doDataSourceMigration();
    }

    persist() {
        return this.provider.persist();
    }

    load() {
        const provider = this.provider;
        return this.initialize()
                .then(() => this.doDataSourceMigration())
                .then(() => provider.load());
    }

    remove() {
        return this.provider.remove();
    }

    updateServConfigStorage() {
        return this.provider.updateServConfigStorage();
    }

    updateNSUStorage() {
        return this.provider.updateNSUStorage();
    }

    checkNsuStorage () {
        return this.provider.checkNsuStorage();
    }

    updateEftActivationStorage() {
        return this.provider.updateEftActivationStorage();
    }

    savePafFile (fileName, fileContent) {
        return this.provider.savePafFile(fileName, fileContent);
    }

    saveCertificateFile(fileName, fileContent) {
        return this.provider.saveCertificateFile(fileName, fileContent);
    }

    getCertificateAbsolutePath(fileName) {
        return this.provider.getCertificateAbsolutePath(fileName);
    }
    
}
