
(function () {
    'use strict';

    angular.module('easyorder.services.donation', [
        'ngResource',
        'easyorder.services.config'
    ]).factory('DonationService', function(ConfigService,
                                            $http) {

        const lws = ConfigService.config.linxwebservices;
        const service = {
            url: (lws.secure ? 'https://' : 'http://')
                + lws.host + ':' + lws.port + '/linx-webservices/v1/donation'
        };

        service.donate = params => {
            return $http.post(`${service.url}/donate`, params);
        };

        service.searchReasons = params => {
            return $http.get(`${service.url}/reasons`, params);
        };

        return service;
    });
})();
