(() => {
    'use strict';

    angular
        .module('easyorder.services.financial', [])
        .service('FinancialService', FinancialService);

    FinancialService.$inject = ['$http', 'ConfigService'];
    function FinancialService($http, ConfigService) {
        let service = {
            url: ''
        };

        service.loadSettings = function() {
            service.url  = ConfigService.config.linxwebservices.secure ? 'https://' : 'http://';
            service.url += ConfigService.config.linxwebservices.host + ':';
            service.url += ConfigService.config.linxwebservices.port;
            service.url += '/linx-webservices/v1/orders/financial';
        };

        this.searchFinancialServiceItems = searchFinancialServiceItems;
        this.processFinancialGenericOrderPayments = processFinancialGenericOrderPayments;
        
        function searchFinancialServiceItems(cart, orderInfo, appInfo) {
            service.loadSettings();
            return $http.post(service.url + '/serviceitem/process', {sale: cart, orderInfo: orderInfo, appInfo: appInfo});
        }
        
        function processFinancialGenericOrderPayments(cart, orderInfo, appInfo) {
            service.loadSettings();
            return $http.post(service.url + '/payment/generic', {sale: cart, orderInfo: orderInfo, appInfo: appInfo});
        }
    }
})();