(function() {
    'use strict';

    angular.module('easyorder.services.info', ['ngResource','easyorder.services.config'])

    .factory('InfoService', function($q, $resource, ConfigService) {
        var service = {};
        
        /**
        *
        */
       service.loadSettings = function () {
           service.url  = ConfigService.config.linxwebservices.secure ? 'https://' : 'http://';
           service.url += ConfigService.config.linxwebservices.host + ':';
           service.url += ConfigService.config.linxwebservices.port;
           service.url += '/linx-webservices';
       };
        
        /**
         * 
         */
        service.checkCTFAuthorizerCodeSimilarity = function(orderAuthorizerCode, paymentAuthorizerCode) {
            return $q(function(resolve, reject) {
                if (orderAuthorizerCode && orderAuthorizerCode !== "" 
                        && paymentAuthorizerCode && paymentAuthorizerCode !== "" 
                        && ConfigService.config.tefserver.provider === 'Auttar') {
                    service.loadSettings();
                    
                    var params = {
                        code1: orderAuthorizerCode,
                        code2: paymentAuthorizerCode
                    };
                    
                    var res = $resource(service.url + "/v1/company/info/ctf/similarityCheck", {}, {
                        similarityCheck: {
                            method: 'POST'
                        }
                    });
                    
                    res.similarityCheck(params).$promise.then(function(result) {
                        if (!result.result) {
                            reject({ data:{ message: "Bandeira não é válida para o pagamento."}});
                        } else {
                            resolve();
                        }
                    }, function() {
                        reject();
                    });
                } else {
                    resolve();
                }
            });
        };
        return service;
    });
})();