(function() {
    'use strict';

    angular.module('easyorder.services.mail', ['ngResource','easyorder.services.config'])

    .factory('MailService', function($resource, ConfigService) {
        var service = {};
        const TYPE_NFCE = "nfce";

        service.loadSettings = function () {
            service.url  = ConfigService.config.linxwebservices.secure ? 'https://' : 'http://';
            service.url += ConfigService.config.linxwebservices.host + ':';
            service.url += ConfigService.config.linxwebservices.port;
            service.url += '/linx-webservices';
        };
        
        service.send = function(mailRequest, success, error) {
            service.loadSettings();
            service.url = service.url + '/v1/email/send';
            const params = {
                subject: mailRequest.subject,
                type: mailRequest.type,
                url: mailRequest.docURL,
                protocolNumber: mailRequest.protocolNumber,
                attachmentContent: mailRequest.attachmentContent,
                serie: mailRequest.terminalNumber,
                number: mailRequest.number,
                date: mailRequest.docDate,
                destinations: mailRequest.destinations,
                storeNumber: mailRequest.storeNumber,
                nsu: mailRequest.nsu,
                template: mailRequest.template,
                bodyData: mailRequest.bodyData
            };
            return $resource(service.url, {}, { send: { method: 'POST' } }).send({}, params, success, error).$promise;
        };
        return service;
    });
})();

class MailRequest {
    constructor() {
        this.type = undefined;
        this.docURL = undefined;
        this.protocolNumber = undefined;
        this.attachmentContent = undefined;
        this.terminalNumber = undefined;
        this.number = undefined;
        this.docDate = undefined;
        this.destinations = undefined;
        this.storeNumber = undefined;
        this.nsu = undefined;
    }
}

class Attachment {
    constructor(content, fileName) {
        this.content = content;
        this.mimeType = "application/pdf";
        this.fileName = fileName;
    }
}

MailRequest.TYPES = {
    NFCE: "nfce",
    SERVICE: "service",
    REPORT: "report"
}