(function() {
    'use strict';

    angular.module('easyorder.services.mobilerecharge', ['ngResource', 'easyorder.services.config'])

    .factory('MobileRechargeService', function(ConfigService, $http) {

        const HTTP = 'http://';
        const HTTPS = 'https://';

        const SERVICE = '/linx-webservices/v1/mobile-recharge';

        const OPTIONS = '/options';
        const VALIDATE = '/validate';
        const RECHARGE = '/recharge';
        
        function url(action) {
            const lws = ConfigService.config.linxwebservices;
            return `${protocol()}${lws.host}:${lws.port}${SERVICE}${action}`;
        }

        function protocol() {
            const lws = ConfigService.config.linxwebservices;
            return lws.secure ? HTTPS : HTTP;
        }

        const service = {
            searchOptions: () => {
                return $http.post(url(OPTIONS), {});
            },

            validate: (validateMobileRechargeRequest) => {
                return $http.post(url(VALIDATE), validateMobileRechargeRequest);
            },

            recharge: (mobileRechargeRequest) => {
                return $http.post(url(RECHARGE), mobileRechargeRequest);
            },

            isLWSMode: () => {
                return (ConfigService.config.business && ConfigService.config.business.mobile_recharge_mode === 'LWS');
            }
        };
        

        return service;
    });
})();
