(function () {
    'use strict';

    angular.module('easyorder.services.prescriptions', [
            'ngResource',
            'easyorder.services.util',
            'easyorder.services.config'
        ])

        .factory('PrescriptionsService', function (
            $resource,
            $ionicPopup,
            $rootScope,
            ConfigService,
            UtilService,
            UserService
        ) {
            var service = {};

            /*
             *
             */
            service.loadSettings = function () {
                service.url = ConfigService.config.linxwebservices.secure ? 'https://' : 'http://';
                service.url += ConfigService.config.linxwebservices.host + ':';
                service.url += ConfigService.config.linxwebservices.port;
                service.url += '/linx-webservices';
                service.companyNumber = ConfigService.config.companyNumber;
                service.storeNumber = ConfigService.config.storeNumber;
            };

            /*
             *
             */
            service.searchPrescription = function (params, success, error) {
                service.loadSettings();
                service.url += '/v1/prescription/search';

                var respose = $resource(service.url, {}, {
                    'process': {
                        method: 'POST'
                    }
                });

                return respose.process({}, params, success, error);
            };

            /*
             *
             */
            service.confirmation = function (params, success, error) {
                service.loadSettings();
                service.url += '/v1/prescription/confirmation';

                var respose = $resource(service.url, {}, {
                    'process': {
                        method: 'POST'
                    }
                });

                return respose.process({}, params, success, error);
            };


            return service;
        });
})();
