(function () {
    'use strict';

    angular.module('easyorder.services.reprintservice', [
        'ngResource',
        'easyorder.services.config'
    ]).factory('ReprintService', function ($resource,
        ConfigService) {

        const linxwebservices = ConfigService.config.linxwebservices;
        const service = {
            url: (linxwebservices.secure ? 'https://' : 'http://')
                + linxwebservices.host + ':' + linxwebservices.port + '/linx-webservices/v1/receipt'
        };

        service.search = params => {
            return $resource(service.url + '/search', {}, {
                searchreprintRequest: {
                    method: 'POST'
                }
            }).searchreprintRequest(params).$promise;
        };

        service.searchLastTransactions = params => {
            return $resource(service.url + '/search-last-transactions', {}, {
                searchLastTransactions: {
                    method: 'POST'
                }
            }).searchLastTransactions(params).$promise;
        };

        return service;
    });
})();
