(function () {
    'use strict';

    angular.module('easyorder.services.transactionsearchservice', [
        'ngResource',
        'easyorder.services.config'
    ]).factory('TransactionSearchService', function ($resource,
                                                     ConfigService) {

        const linxwebservices = ConfigService.config.linxwebservices;
        const service = {
            url: () => (linxwebservices.secure ? 'https://' : 'http://')
                + linxwebservices.host + ':' + linxwebservices.port + '/linx-webservices/v1/transaction'
        };

        service.search = params => {
            return $resource(service.url() + '/search', {}, {
                searchTransactionRequest: {
                    method: 'POST'
                }
            }).searchTransactionRequest({}, params).$promise;
        };
        
        service.list = params => {
            return $resource(service.url() + '/search/list', {}, {
                searchTransactionRequest: {
                    method: 'POST'
                }
            }).searchTransactionRequest({}, params).$promise;
        };
        return service;
    });
})();
