//onKeyDown="fnFormataCampo('CPF',this,event);"

function maskField(type, obj, e) {
    if (type == 'CPF')
        maskCpf(obj, e);
    else if (type == 'CNPJ')
        maskCnpj(obj, e);
}

function maskCpf(obj, e) {
    var key, size;
    var e = window.event || e;
    key = e.keyCode;
    obj.maxLength = 14;
    if (key != 8) {
        size = obj.value.length;
        if (size == 3) {
            obj.value = obj.value + '.';
        } else if (size == 7) {
            obj.value = obj.value + '.';
        } else if (size == 11) {
            obj.value = obj.value + '-';
        }
    }
}

function applyCpfMask(cpf) {
    return cpf.substr(0, 3) + '.' + cpf.substr(3, 3) + '.' + cpf.substr(6, 3) + '-' + cpf.substr(9, 2);
}

function applyCnpjMask(cnpj) {
    return cnpj.substr(0, 2) + '.' + cnpj.substr(2, 3) + '.' + cnpj.substr(5, 3) + '/' + cnpj.substr(8, 4) + '-' + cnpj.substr(12, 2);
}

function maskCnpj(obj, e) {
    var key, size;
    var e = window.event || e;
    key = e.keyCode;

    //        tecla = event.keyCode;
    obj.maxLength = 18;
    if (key != 8) {
        size = obj.value.length;
        if (size == 2) {
            obj.value = obj.value + '.';
        } else if (size == 6) {
            obj.value = obj.value + '.';
        } else if (size == 10) {
            obj.value = obj.value + '/';
        } else if (size == 15) {
            obj.value = obj.value + '-';
        }
    }
}

function removeMask(str) {
    return str.replace(/\./g, "").replace(/-/g, "");
}

function decimalNumberOnly(obj, e) {
    var code;
    code = e.keyCode;
    if (code == 44 && obj.value.indexOf(',') < 0)
        return true;

    if (code < 48 || code > 57) {
        e.keyCode = 0;
        return false;
    }
}

function validaCPF(cpf) {
    var numeros, digitos, soma, i, resultado, digitos_iguais;
    digitos_iguais = 1;

    if (!cpf) return;

    if (cpf.length < 11)
        return false;
    for (i = 0; i < cpf.length - 1; i++)
        if (cpf.charAt(i) != cpf.charAt(i + 1)) {
            digitos_iguais = 0;
            break;
        }
    if (!digitos_iguais) {
        numeros = cpf.substring(0, 9);
        digitos = cpf.substring(9);
        soma = 0;
        for (i = 10; i > 1; i--)
            soma += numeros.charAt(10 - i) * i;
        resultado = soma % 11 < 2 ? 0 : 11 - soma % 11;
        if (resultado != digitos.charAt(0))
            return false;
        numeros = cpf.substring(0, 10);
        soma = 0;
        for (i = 11; i > 1; i--)
            soma += numeros.charAt(11 - i) * i;
        resultado = soma % 11 < 2 ? 0 : 11 - soma % 11;
        if (resultado != digitos.charAt(1))
            return false;
        return true;
    } else
        return false;
}

function validaCNPJ(cnpj) {

    cnpj = cnpj.replace(/[^\d]+/g, '');

    if (cnpj == '')
        return false;

    if (cnpj.length != 14)
        return false;

    // Elimina CNPJs invalidos conhecidos
    if (cnpj == "00000000000000" || cnpj == "11111111111111" || cnpj == "22222222222222" || cnpj == "33333333333333"
            || cnpj == "44444444444444" || cnpj == "55555555555555" || cnpj == "66666666666666" || cnpj == "77777777777777"
            || cnpj == "88888888888888" || cnpj == "99999999999999")
        return false;

    // Valida DVs
    tamanho = cnpj.length - 2
    numeros = cnpj.substring(0, tamanho);
    digitos = cnpj.substring(tamanho);
    soma = 0;
    pos = tamanho - 7;
    for (i = tamanho; i >= 1; i--) {
        soma += numeros.charAt(tamanho - i) * pos--;
        if (pos < 2)
            pos = 9;
    }
    resultado = soma % 11 < 2 ? 0 : 11 - soma % 11;
    if (resultado != digitos.charAt(0))
        return false;

    tamanho = tamanho + 1;
    numeros = cnpj.substring(0, tamanho);
    soma = 0;
    pos = tamanho - 7;
    for (i = tamanho; i >= 1; i--) {
        soma += numeros.charAt(tamanho - i) * pos--;
        if (pos < 2)
            pos = 9;
    }
    resultado = soma % 11 < 2 ? 0 : 11 - soma % 11;
    if (resultado != digitos.charAt(1))
        return false;

    return true;

}

function validaPassport(passport) {
    var isValid = false;
    if (passport != '') {
        isValid = true;
    }

    return isValid;
}


function validaRNE(rne) {
    var isValid = false;
    if (rne != '') {
        isValid = true;
    }

    return isValid;
}