cordova.define("linx-cordova-fs-watchdog.FSWatchdog", function(require, exports, module) {
const exec = require('cordova/exec');

class FSWatchdog {
    constructor() {}
}

FSWatchdog.EVENT = {
    ACCESS: 0x00000001,
    ALL_EVENTS: 0x00000fff,
    ATTRIB: 0x00000004,
    CLOSE_NOWRITE: 0x00000010,
    CLOSE_WRITE: 0x00000008,
    CREATE: 0x00000100,
    DELETE: 0x00000200,
    DELETE_SELF: 0x00000400,
    MODIFY: 0x00000002,
    MOVED_FROM: 0x00000040,
    MOVED_TO: 0x00000080,
    MOVE_SELF: 0x00000800,
    OPEN: 0x0000002
};

FSWatchdog.watch = (args) => {
    _checkCommonArgs(args);
    _typeCheck(args.path, "args.path", "string");
    _typeCheck(args.events, "args.events", "number");
    exec(args.success, args.error, 'FSWatchdog', 'watch', [args.id, args.path, args.events]);
};

FSWatchdog.stop = (args) => {
    _checkCommonArgs(args);
    exec(args.success, args.error, 'FSWatchdog', 'stop', [args.id]);
};

function _checkCommonArgs(args) {
    _typeCheck(args, "args", "object");
    _typeCheck(args.success, "args.success", "function");
    _typeCheck(args.error, "args.error", "function");
    _typeCheck(args.id, "args.id", "number");
}

function _typeCheck(arg, name, type) {
    if (arg == null) {
        throw new Error(`Arg ${name} can't be null`);
    }
    if (typeof arg != type) {
        throw new Error(`Arg ${name} is ${typeof arg}, only ${type} is accepted`);
    }
}

module.exports = FSWatchdog;

});
