cordova.define("linx-lio.lio", function(require, exports, module) {
const exec = require('cordova/exec');

const Lio = {
    PMNT_METHOD_DEBIT: 0x0111,
    PMNT_METHOD_POST_DATED_DEBIT: 0x0112,
    PMNT_METHOD_CREDIT: 0x0211,
    PMNT_METHOD_CREDIT_INSTALLMENTS_STORE: 0x0222,
    PMNT_METHOD_CREDIT_INSTALLMENTS_ADM: 0x0224,
    PMNT_METHOD_PRE_AUTHORIZED: 0x0411,
    PMNT_METHOD_FOOD_VOUCHER: 0x0811,
    PMNT_METHOD_MEAL_VOUCHER: 0x0812,

    PMNT_CANCELLED: 'PAYMENT_CANCELLED',
    PMNT_CANCELLATION_CANCELLED: 'PAYMENT_CANCELLATION_CANCELLED',

    init: function(clientId, token, success, error) {
        exec(success, error, 'Lio', 'init', [{'clientId': clientId,
            'token': token}]);
    },

    bind: function(success, error) {
        exec(success, error, 'Lio', 'bind', [{}]);
    },

    unbind: function(success, error) {
        exec(success, error, 'Lio', 'unbind', [{}]);
    },

    isBound: function(success, error) {
        exec(success, error, 'Lio', 'isBound', [{}]);
    },

    placeOrder: function(order, success, error) {
        exec(success, error, 'Lio', 'placeOrder', [order]);
    },

    checkout: function(payment, success, error) {
        exec(success, error, 'Lio', 'checkout', [payment]);
    },

    confirmOrder: function(nsu, success, error) {
    	exec(success, error, 'Lio', 'confirmOrder', [nsu]);
    },
    
    cancelOrder: function(nsu, success, error) {
	    exec(success, error, 'Lio', 'cancelOrder', [nsu]);
    }

}

module.exports = Lio;

});
